* SUBROUTINE EAFU27             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FA  VALUE OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAFU27(N,KA,X,FA,NEXT)
      INTEGER N,KA,NEXT
      $FLOAT X(N),FA
      IF (NEXT.LE.30) THEN
      CALL EAFU02(N,KA,X,FA,NEXT)
      ELSE IF (NEXT.LE.52) THEN
      CALL EAFU15(N,KA,X,FA,NEXT-30)
      ELSE IF (NEXT.LE.96) THEN
      CALL EAFU18(N,KA,X,FA,NEXT-52)
      ENDIF
      RETURN
      END

