* SUBROUTINE ECFU41             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR EQUATIONS.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FC  VALUE OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE ECFU41(N,KC,X,FC,NEXT)
      INTEGER N,KC,NEXT
      $FLOAT X(N),FC
      INTEGER J,L
      GO TO (10,20,30), NEXT
   10 J=2*((KC-1)/3+1)
      L=MOD(KC,3)
      GO TO (11,12,13), L+1
   11 FC=X(J-1)**2+X(J)**2+X(J+1)**2+X(J+2)**2+X(J-1)-X(J)+X(J+1)-
     & X(J+2)
      RETURN
   12 FC=X(J-1)**2+2.0$P 0*X(J)**2+X(J+1)**2+2.0$P 0*X(J+2)**2-X(J-1)-
     & X(J+2)
      RETURN
   13 FC=2.0$P 0*X(J-1)**2+X(J)**2+X(J+1)**2+2.0$P 0*X(J-1)-X(J)-
     & X(J+2)
      RETURN
   20 CONTINUE
      RETURN
   30 CONTINUE
      RETURN
      END

