* SUBROUTINE EIUD23                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR UNCONSTRAINED MINIMIZATION.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD23(N,NA,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NA,NEXT,IEXT,IERR
      $FLOAT X(N),FMIN,XMAX
      NA=2000
      IF (NEXT.LE.22) THEN
      CALL EIUD14(N,NA,X,FMIN,XMAX,NEXT,IEXT,IERR)
      ELSE IF (NEXT.LE.44) THEN
      CALL EIUD15(N,NA,X,FMIN,XMAX,NEXT-22,IEXT,IERR)
      ELSE IF (NEXT.LE.74) THEN
      CALL EIUD18(N,NA,X,FMIN,XMAX,NEXT-44,IEXT,IERR)
      ELSE
      IERR=1
      ENDIF
      RETURN
      END
