* SUBROUTINE EYFU30             ALL SYSTEMS                 93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR PARAMETER ESTIMATION OF DYNAMICAL
*  SYSTEMS. UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  KE  INDEX OF THE DIFFERENTIAL EQUATION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FE  INITIAL VALUE.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EYFU30(N,KE,X,FE,NEXT)
      INTEGER N,KE,NEXT
      REAL*8 X(N),FE
      GOTO (10,10,30,40),NEXT
   10 GOTO (11,12,13,14),KE
   11 FE=X(1)
      RETURN
   12 FE=0.0D 0
      RETURN
   13 FE=X(2)
      RETURN
   14 FE=0.0D 0
      RETURN
   30 GOTO (31,32,33,34,35),KE
   31 FE=0.0D 0
      RETURN
   32 FE=0.0D 0
      RETURN
   33 FE=X(1)
      RETURN
   34 FE=0.0D 0
      RETURN
   35 FE=X(2)
      RETURN
   40 GOTO (41,42,43,44,45),KE
   41 FE=0.0D 0
      RETURN
   42 FE=X(1)
      RETURN
   43 FE=1.0D 0
      RETURN
   44 FE=X(2)
      RETURN
   45 FE=0.0D 0
      RETURN
      END
