* SUBROUTINE UESET2                ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIAL DETERMINATION OF MESH POINTS FOR INITIAL VALUE PROBLEMS.
*
* PARAMETERS :
*  II  NA  NUMBER OF MESH POINTS.
*  II  NE  DECLARED NUMBER OF DIFFERENTIAL EQUATIONS.
*  RI  AT(NA)  MESH POINTS.
*  RO  AY(NA*NE)  FIELD OF SOLUTION VECTORS IN THE MESH POINTS.
*  RU  YA(NE)  INITIAL SOLUTION VECTOR.
*  RU  TA  INITIAL VALUE OF THE INTEGRATION PARAMETER.
*
*  SUBPROGRAM USED :
*  S  UXVCOP  COPY OF A VECTOR.
*
      SUBROUTINE UESET2(NA,NE,AT,AY,YA,TA)
      INTEGER NA,NE
      REAL*8 AT(NA),AY(NA*NE),YA(NE),TA
      AT(1)=TA
      CALL UXVCOP(NE,YA,AY)
      RETURN
      END
