* SUBROUTINE UOERR3               ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PREPARATION OF ERROR PRINT.
*
* PARAMETERS
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF MATRIX CORRECTION.
*         KOUT=5-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=6-ADDITIONAL PRINT OF DEBUGGING.
*  II  LOUT  PRINT OF ITERATIONS. LOUT=0-STANDARD PAPER SAVING PRINT.
*         LOUT=1-ADDITIONAL PRINT OF VARIABLES. LOUT=2-ADDITIONAL
*         PRINT OF THE GRADIENT. LOUT=3-ADDITIONAL PRINT OF THE HESSIAN
*         MATRIX.
*  II  MOUT  LEVEL OF PRINT ON THE TERMINAL DEVICE.
*         MOUT=0 - NO PRINT.
*         MOUT=1 - PRINT OF FINAL RESULTS.
*         MOUT=2 - ADDITIONAL PRINT OF ITERATIONS.
*  II  ITERM  TERMINATION INDICATOR. ITERM<0-INVALID TERMINATION.
*         ITERM>0-VALID TERMINATION.
*  IO  IER  ERROR INDICATOR.
*
*
      SUBROUTINE UOERR3(KOUT,LOUT,MOUT,ITERM,IER)
      INTEGER KOUT,LOUT,MOUT,ITERM,IER
      IER=0
      IF (ITERM.GE.0) RETURN
      IER=1
      IF (ITERM.EQ. -2) IER=0
      IF (ITERM.EQ. -3) IER=0
      IF (ITERM.EQ. -6) IER=0
      IF (ITERM.EQ. -8) IER=0
      IF (ITERM.EQ. -9) IER=0
      IF (ITERM.EQ.-88) IER=0
      IF (IER.NE.0.AND.ITERM.NE.-100) THEN
      KOUT=0
      LOUT=1
      IF (MOUT.EQ.0) MOUT=1
      ENDIF
      RETURN
      END
