* SUBROUTINE UOJZD2                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* CHOICE OF VISUALISED VARIABLES.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  II  NED  NUMBER OF VISUALIZED DIFFERENTIAL EQUATION.
*  IO  IE  INDEX OF THE 1-ST VISUALIZED DIFFERENTIAL EQUATION.
*  IO  JE  INDEX OF THE 2-ND VISUALIZED DIFFERENTIAL EQUATION.
*  IO  KE  INDEX OF THE 3-RD VISUALIZED DIFFERENTIAL EQUATION.
*
      SUBROUTINE UOJZD2(N,NED,IE,JE,KE)
      INTEGER N,NED,IE,JE,KE
      IF (N.LE.0) RETURN
      IF (NED.GE.1) THEN
   1  CONTINUE
      WRITE(*,'(A56)')
     & 'INDEX OF THE 1-ST VISUALIZED DIFFERENTIAL EQUATION: IE ='
      READ(*,'(I5)',ERR=1) IE
      IF (IE.GT.N) GO TO 1
      IF (IE.LE.0) GO TO 1
      IF (N.LE.1) RETURN
      ENDIF
      IF (NED.GE.2) THEN
   2  CONTINUE
      WRITE(*,'(A56)')
     & 'INDEX OF THE 2-ND VISUALIZED DIFFERENTIAL EQUATION: JE ='
      READ(*,'(I5)',ERR=2) JE
      IF (JE.GT.N) GO TO 2
      IF (JE.LE.0) GO TO 2
      IF (JE.EQ.IE) GO TO 2
      IF (N.LE.2) RETURN
      ENDIF
      IF (NED.GE.3) THEN
   3  CONTINUE
      WRITE(*,'(A56)')
     & 'INDEX OF THE 3-RD VISUALIZED DIFFERENTIAL EQUATION: KE ='
      READ(*,'(I5)',ERR=3) KE
      IF (KE.GT.N) GO TO 3
      IF (KE.LE.0) GO TO 3
      IF (KE.EQ.IE) GO TO 3
      IF (KE.EQ.JE) GO TO 3
      ENDIF
      RETURN
      END
