* SUBROUTINE UQELSE                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE 'ELSE'
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  II  NIF1 - NUMBER OF NESTED IF-ENDIF WITH CONDIF=.TRUE.
*  II  NIF2 - NUMBER OF ALL NESTED IF-ENDIF
*  II  MNIF - MAX. NUMBER OF NESTED IF-ENDIF
*  LU  LELSE(MNIF) - WORK ARRAY
*  LI  LIFDON(MNIF) - WORK ARRAY
*  LU  CONDIF - CONDITION OF LAST IF-ENDIF
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQCEOL - CHECK END OF LINE
*
      SUBROUTINE UQELSE(BUFFER,MLENB,IPOSD,NIF1,NIF2,MNIF,LELSE,
     *                  LIFDON,CONDIF,IER)
      INTEGER MLENB,IPOSD,NIF1,NIF2,MNIF,IER
      CHARACTER*1 BUFFER(MLENB)
      LOGICAL LELSE(MNIF),LIFDON(MNIF),CONDIF
      CALL UQCEOL(BUFFER,MLENB,IPOSD,IER)
      IF(IER.NE.0) RETURN
      IF(NIF1.EQ.0) GOTO 1
      IF(NIF1.EQ.NIF2) THEN
        IF(LELSE(NIF1)) GOTO 1
        LELSE(NIF1)=.TRUE.
        CONDIF=.NOT.LIFDON(NIF1)
      ENDIF
      RETURN
C
C ERROR: UNEXPECTED 'ELSE'
C
    1 IER=36
      RETURN
      END
