* SUBROUTINE UQREST                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE 'RESTORE'
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF LINE
*               IN THE BUFFER
*  TI  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  II  LP - LAST POINTER TO THE SYMBOL TABLE
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQSADR - SYNTAX ANALYSIS OF DIRECTIVE LINE
*  LF  UQVDEF - IS MACRO DEFINED IN THE SYMBOL TABLE ?
*
      SUBROUTINE UQREST(BUFFER,MLENB,IPOSD,IPOS2,SYMTAB,MLENST,
     *                  IPOINT,MNP,LP,IER)
      INTEGER MLENB,IPOSD,IPOS2,MLENST,MNP,IPOINT(MNP,6),LP,IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
      CHARACTER*50   FN1,FN2,FNAMES(20),NAME,MSG(50)*70
      COMMON/UQCHRX/ FN1,FN2,FNAMES,NAME,MSG
      INTEGER MNPAR,I
      PARAMETER(MNPAR=1)
      INTEGER NPAR,IPOSP(MNPAR,2),ITYPE(MNPAR)
      INTEGER IP,IPPRED
      LOGICAL UQVDEF
      CALL UQSADR(BUFFER,MLENB,IPOSD,IPOS2,IPOSP,MNPAR,NPAR,ITYPE,IER)
      IF(IER.NE.0) RETURN
      IF(NPAR.NE.1) GOTO 1
      IF(ITYPE(1).NE.5) GOTO 2
      IF(.NOT.UQVDEF(BUFFER,MLENB,IPOSP(1,1),IPOSP(1,2),SYMTAB,
     *               MLENST,IPOINT,MNP,LP,IP,IPPRED)) GOTO 3
      IPOINT(IP,5)=1
      RETURN
C
C ERROR: SYNTAX ERROR
C
    1 IER=20
      RETURN
C
C ERROR: MACRO NAME EXPECTED
C
    2 IER=23
      RETURN
C
C ERROR: VARIABLE NOT DEFINED
C
    3 IER=9
      NAME='                                                  '
      DO 4 I=0,IPOSP(1,2)-IPOSP(1,1)
      NAME(I+1:I+1)=BUFFER(IPOSP(1,1)+I)
    4 CONTINUE
      RETURN
      END
