* SUBROUTINE UQSTRI                ALL SYSTEMS                98/12/01
* PORTABILITY : ALL SYSTEMS
* 98/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  CONVERT AN INTEGER NUMBER TO A STRING
*
* PARAMETERS :
*  II  NUMBER - AN INTEGER NUMBER BEING CONVERTED
*  TU  STRARR(MLEN) - A STRING ARRAY
*  II  MLEN - MAX. LENGTH OF STRARR
*  II  IPOS - POSITION OF THE FIRST CHARACTER OF A NUMBER IN STRARR
*  IU  LEN - ACTUAL LENGTH OF STRARR
*  IO  IER - ERROR INDICATOR
*
* COMMON DATA:
*  TI  ASCII(127) - SET OF CHARACTERS
*
* SUBPROGRAMS USED :
*  S   UQINCS - INCLUDE A SUBSTRING TO A STRING ARRAY
*
      SUBROUTINE UQSTRI(NUMBER,STRARR,MLEN,LEN,IPOS,IER)
      INTEGER*4 NUMBER
      INTEGER MLEN,LEN,IPOS,IER
      CHARACTER*1 STRARR(MLEN)
      INTEGER*4 I,J,K
      INTEGER M,LSTRI
      LOGICAL L
      PARAMETER(LSTRI=11)
      CHARACTER*1 STRI(LSTRI)
C ----------------------------------------------------------------------
      INTEGER        LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT(30),NSUB,MNSUB,
     *        NDIR,LENDIR(30),NMSG,MNIF,NIF1,NIF2,TABCH(0:255),ADF,
     *        ADA,ADC,ARD,CRD
      COMMON/UQINT2/ LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT,NSUB,MNSUB,
     *        NDIR,LENDIR,NMSG,MNIF,NIF1,NIF2,TABCH,ADF,ADA,ADC,ARD,CRD
      INTEGER*4      LABEL1,LABEL2,MAXLAB,LEVLAB(20)
      COMMON/UQINT4/ LABEL1,LABEL2,MAXLAB,LEVLAB
      CHARACTER*1    CHCON,CHEOL,CHDS,CHDIR,WTRUE(6),WFALSE(7),
     *        ASCII(32:127),OPTNM(200),DIRNM(200)
      COMMON/UQCHR1/ CHCON,CHEOL,CHDS,CHDIR,WTRUE,WFALSE,
     *        ASCII,OPTNM,DIRNM
      CHARACTER*50   FN1,FN2,FNAMES(20),NAME,MSG(50)*70
      COMMON/UQCHRX/ FN1,FN2,FNAMES,NAME,MSG
      LOGICAL        LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON(20),
     *        LELSE(20),CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
      COMMON/UQLOGL/ LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON,
     *        LELSE,CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
C ----------------------------------------------------------------------
      J=1000000000
      L=.FALSE.
      M=0
      I=NUMBER
      IF(I.LT.0) THEN
        STRI(1)='-'
        I=-I
        M=1
      ENDIF
    1 K=I/J
      I=I-J*K
      IF(K.NE.0.OR.L.OR.I.LE.0) THEN
        L=.TRUE.
        M=M+1
        STRI(M)=ASCII(K+48)
      ENDIF
      J=J/10
      IF(J.GE.1) GOTO 1
      CALL UQINCS(STRARR,MLEN,LEN,IPOS,STRI,LSTRI,1,M,IER)
      RETURN
      END
