* SUBROUTINE UXBSDO                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  A SCALAR IS SET TO ALL DIAGONAL ELEMENTS OF THE SYMMETRIC BLOCKED
*  MATRIX.
*
* PARAMETERS :
*  II  NBLA  DIMENSION OF THE ARRAY ABL.
*  II  NBLKS  NUMBER OF BLOCKS OF THE MATRIX.
*  RI  ALF  SCALAR WHICH IS SET TO ALL DIAGONAL ELEMENTS
*           OF THE MATRIX.
*  RI  ABL(NBLA)  VALUES OF THE NONZERO ELEMENTS OF THE MATRIX.
*  II  IBLBG(NBLKS+1)  BEGINNINGS OF THE BLOCKS IN THE MATRIX.
*
* SUBROUTINES USED :
*  UXDSDA  A SCALAR IS SET TO ALL DIAGONAL ELEMENTS OF A DENSE
*  SYMMETRIC MATRIX.
*  MATRIX.
*
      SUBROUTINE UXBSDO(NBLA,NBLKS,ALF,ABL,IBLBG)
      INTEGER NBLKS,NBLA,IBLBG(NBLKS+1)
      REAL*8 ALF,ABL(NBLA)
      INTEGER I,K,KBEG,KLEN
      K=1
      DO 1 I=1,NBLKS
      KBEG=IBLBG(I)
      KLEN=IBLBG(I+1)-KBEG
      CALL UXDSDO(KLEN,ALF,ABL(K))
      K=K+KLEN*(KLEN+1)/2
   1  CONTINUE
      RETURN
      END
