* SUBROUTINE UXDPGS                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALING OF A DENSE SYMMETRIC POSITIVE DEFINITE MATRIX A+E USING THE
* FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE SUBROUTINE UXDPGF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RU  A(N*(N+1)/2) FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
*         SUBROUTINE UXDPGF.
*  RI  ALF  SCALING FACTOR.
*
      SUBROUTINE UXDPGS( N, A, ALF)
      INTEGER N
      REAL*8  A(N*(N+1)/2), ALF
      INTEGER I,J
      J = 0
      DO 1  I = 1, N
      J = J + I
      A(J) = A(J) * ALF
    1 CONTINUE
      RETURN
      END
