* SUBROUTINE UXDPRT                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* FACTORIZATION A=TRANS(R)*R IS TRANSFORMED TO A=L*D*TRANS(L).
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RU  A(N*(N+1)/2) FACTORIZATION OF THE MATRIX A.
*
      SUBROUTINE UXDPRT(N,A)
      INTEGER N
      REAL*8 A(N*(N+1)/2)
      REAL*8 TEMP
      INTEGER I,J,K,L
      L=0
      DO 2 I=1,N
      L=L+I
      TEMP=A(L)
      A(L)=TEMP**2
      K=L
      DO 1 J=I+1,N
      K=K+J-1
      A(K)=A(K)/TEMP
    1 CONTINUE
    2 CONTINUE
      RETURN
      END
