* SUBROUTINE UXDSMC                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COPYING OF A DENSE SYMMETRIC MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRICES A AND B.
*  RI  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*  RO  B(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM
*         WHERE B:=A.
*
      SUBROUTINE UXDSMC(N,A,B)
      INTEGER N
      REAL*8  A(N*(N+1)/2), B(N*(N+1)/2)
      INTEGER M,I
      M = N * (N+1)/2
      DO  1  I = 1, M
      B(I) = A(I)
    1 CONTINUE
      RETURN
      END
