* SUBROUTINE  UXSRO9             ALL SYSTEMS               92/12/01
C PORTABILITY : ALL SYSTEMS (NEWORDER)
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE : SET ARRAYS : BIA, BLEN
*
*  PARAMETERS :
*  II  M NUMBER OF ROWS OF THE MATRIX.
*  II  NN  NUMBER OF BLOCK COLUMNS OF A.
*  II  P(NN) WINDTH OF THE BLOCK COLUMNS.
*  II  BJA1(NN) BEGINNINGS OF THE BLOCK COLUMNS IN A.
*  II  BJA2(NN) ENDING INDICES OF THE BLOCK COLUMNS IN A.
*  IO  BIA(NN+1) BEGINNING BLOCKS IN VALUE BA
*  IO  BLEN(NN)  LENGTH BLOCKS IN VALUE BA
*
      SUBROUTINE UXSRO9(M,NN,N,P,BIA,BJA1,BJA2,BLEN)
      INTEGER NN,M,N,BIA(NN+1),BLEN(NN),BJA1(NN),BJA2(NN),I,P(NN)
      BIA(1)=1
C ----------------
C SETTING BIA,BLEN
C ----------------
      DO 20 I=1,NN
        BLEN(I)=(BJA2(I)-BJA1(I)+1)
        BIA(I+1)=BIA(I)+BLEN(I)*P(I)
   20 CONTINUE
      BIA(NN+1)=N*M+1
      RETURN
      END
