* SUBROUTINE UXSSDO                ALL SYSTEMS                89/12/01
C PORTABILITY : ALL SYSTEMS
C 89/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  A SCALAR IS SET TO ALL DIAGONAL ELEMENTS OF A SPARSE
*  SYMMETRIC MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  ALF  SCALAR WHICH IS SET TO ALL DIAGONAL ELEMENTS
*           OF THE MATRIX A.
*  RU  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*
      SUBROUTINE UXSSDO(N,M,ALF,A,IA,JA)
      INTEGER N,M
      REAL*8 A(M),ALF
      INTEGER IA(N),JA(M),I,J
      DO 1 I=1,N
      J=IA(I)
      JA(J)=I
      A(J)=ALF
    1 CONTINUE
      RETURN
      END
