* SUBROUTINE  UXVETC              ALL SYSTEMS               06/04/92
C PORTABILITY : ALL SYSTEMS
C 24/03/92 TU : ORIGINAL VERSION
*
* PURPOSE: RENUMBER TREE OF MODIFIED CLIQUE-2 SEPARATION SCHEMES
*
* PARAMETERS :
*  II  N NUMBER OF COLUMNS.
*  IU  LABEL(N) LABELS OF COLUMNS.
*  II  SON(N)
*  IA  STACK(N) AUXILIARY VECTOR.
*  IA  WN01(N) AUXILIARY VECTOR.
*  IO  NN  NUMBER OF BLOCKS IN THE MATRIX A
*
      SUBROUTINE UXVETC(N,LABEL,SON,WN01,NN)
      INTEGER I,J,IEND,INDEX,K,N,NN,SON(N),WN01(N),LABEL(N)
      IEND = 0
      INDEX = 1
      K = 1
  100 CALL UXVET1(N,K,INDEX,WN01,SON)
      CALL UXVET2(N,K,INDEX,WN01,IEND)
      IF (IEND .EQ. 0) GO TO 100
      DO 200 I=1, N
        J = LABEL(I)
        IF (J .GT. 0) THEN
          LABEL(I) = WN01(J)
        ELSE
          LABEL(I) = (WN01(-J)) + 1
        END IF
  200 CONTINUE
      NN = K - 2
      RETURN
      END
