* FUNCTION UXVNM2                ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  EUCLIDEAN NORM OF VECTOR DIFFERENCE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RR  UXVNM2  EUCLIDEAN NORM OF X-Y.
*
      FUNCTION UXVNM2(N,X,Y)
      INTEGER N
      REAL*8 X(N),Y(N),UXVNM2
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      INTEGER I
      REAL*8 TEMP
      TEMP=ZERO
      DO 10 I=1,N
        TEMP=TEMP+(X(I)-Y(I))**2
   10 CONTINUE
      UXVNM2=SQRT(TEMP)
      END
