* SUBROUTINE UYSORB               ALL SYSTEMS                08/10/01
C PORTABILITY : ALL SYSTEMS
C 08/10/01 MA : ORIGINAL VERSION
*
* PURPOSE :
* LSTRS METHOD: UPDATES BOUNDS FOR ALPHA (SAFEGUARDING INTERVAL).
*
* PARAMETERS :
*  RI  SNORM  THE NORM OF A DIRECTION VECTOR S.
*  RI  XDEL  TRUST-REGION RADIUS.
*  II  ITER  IF THE 1-ST OR 2-ND EIGENPAIR IS USED.
*  RI  ALPHA  SCALAR PARAMETER IN LSTRS METHOD.
*  RU  ALPHAL  LOWER UPDATED BOUND FOR ALPHA.
*  RU  ALPHAU  UPPER UPDATED BOUND FOR ALPHA.
*
      SUBROUTINE UYSORB(SNORM,XDEL,ITER,ALPHA,ALPHAL,ALPHAU)
      INTEGER ITER
      REAL*8 SNORM,XDEL,ALPHA,ALPHAL,ALPHAU
      IF (ITER.EQ.1) THEN
      IF (SNORM.LT.XDEL) THEN
      ALPHAL = ALPHA
      ELSE IF (SNORM.GT.XDEL) THEN
      ALPHAU = ALPHA
      ENDIF
      ELSE
      ALPHAU = ALPHA
      ENDIF
      RETURN
      END
