* PROGRAM PROTEX                ALL SYSTEMS                 14/12/01
C PORTABILITY : ALL SYSTEMS
C 14/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GENERATION OF TEX FIGURE FOR PERFORMANCE PROFILES.
*
      PROGRAM PROTEX
      REAL*8 PP(100),SS(5),DT,W,X
      INTEGER*2 I,K,L,N
      INTEGER LEN,M
      CHARACTER*1 PICTURE,CHAR
      CHARACTER*4 PROFILE
      CHARACTER*10 CBOUND
      CHARACTER*14 NAME
      REAL*8 BOUND
      CALL GET_COMMAND_ARGUMENT(1,PROFILE,LEN,M)
      IF (M.LT.0) PROFILE='NFV'
      CALL GET_COMMAND_ARGUMENT(2,CBOUND,LEN,M)
      IF (M.LT.0) CBOUND='2.0D0'
      READ(CBOUND,'(D10.3)') BOUND
      CALL GET_COMMAND_ARGUMENT(4,PICTURE,LEN,M)
      IF (M.LT.0) PICTURE='1'
      IF (PICTURE.NE.'1'.AND.PICTURE.NE.'2'.AND.PICTURE.NE.'3') 
     & PICTURE='1' 
      OPEN(7,FILE='P.PER',STATUS='UNKNOWN')
      OPEN(8,FILE='P.PRO',STATUS='UNKNOWN')
      OPEN(9,FILE='P.TEX',STATUS='UNKNOWN')
      CALL UOTES7(PROFILE,BOUND)
      CLOSE(8)
      OPEN(8,FILE='P.PRO',STATUS='UNKNOWN')
      READ(8,'(77X,I3)') L
      DO 1 I=1,5
      SS(I)=FLOAT(INT(I))*BOUND/5.0D 0
    1 CONTINUE
      WRITE (9,'(A)') '\documentclass{article}'
      WRITE (9,'(A)') '\usepackage{epsfig,color}'
      WRITE (9,'(A)')
     & '\def\plinr#1#2#3{{\linethickness{.8pt}\color{red}'
      WRITE (9,'(A)')
     % '\multiput(#1,#2)(.4,#3){20}{\line(1,0){.4}\line(0,1){#3}}}}'
      WRITE (9,'(A)')
     & '\def\plinc#1#2#3{{\linethickness{.4pt}\color{cyan}'
      WRITE (9,'(A)')
     & '\multiput(#1,#2)(.4,#3){20}{\line(1,0){.4}\line(0,1){#3}}}}'
      WRITE (9,'(A)')
     & '\def\plinb#1#2#3{{\linethickness{2pt}\color{blue}'
      WRITE (9,'(A)')
     & '\multiput(#1,#2)(.4,#3){20}{\line(1,0){.4}\line(0,1){#3}}}}'
      WRITE (9,'(A)')
     & '\def\pling#1#2#3{{\linethickness{2pt}\color{green}'
      WRITE (9,'(A)')
     & '\multiput(#1,#2)(.4,#3){20}{\line(1,0){.4}\line(0,1){#3}}}}'
      WRITE (9,'(A)') '\begin{document}'
      WRITE (9,'(A)')
      IF (PICTURE.EQ.'1') THEN
      WRITE (9,'(A)') '\setlength{\unitlength}{0.70mm}'
      ELSE
      WRITE (9,'(A)') '\setlength{\unitlength}{0.45mm}'
      ENDIF
      IF (PICTURE.EQ.'1') THEN
      WRITE (9,'(A)') '\begin{picture}(200,80)(0,0)'
      ELSE IF (PICTURE.EQ.'2') THEN
      WRITE (9,'(A)') '\begin{picture}(200,80)(30,80)'
      ELSE IF (PICTURE.EQ.'3') THEN
      WRITE (9,'(A)') '\begin{picture}(200,80)(-170,0)'
      ENDIF 
      WRITE (9,'(A)') '\put(20,20){\framebox(160,100)}{ }'
      IF (L.EQ.4) THEN
      WRITE (9,'(A)') '\put(104,24){\framebox(60,24){ }}'
      WRITE (9,'(A)') '\plinb{107}{44.0}{0}\plinb{115}{44.0}{0}%'
      WRITE (9,'(A)') '\plinc{107}{38.5}{0}\plinc{115}{38.5}{0}%'
      WRITE (9,'(A)') '\plinr{107}{33.0}{0}\plinr{115}{33.0}{0}%'
      WRITE (9,'(A)') '\pling{107}{27.5}{0}\pling{115}{27.5}{0}%'
      ELSE IF (L.EQ.3) THEN
      WRITE (9,'(A)') '\put(104,24){\framebox(60,19){ }}'
      WRITE (9,'(A)') '\plinb{107}{38.5}{0}\plinb{115}{38.5}{0}%'
      WRITE (9,'(A)') '\plinc{107}{33.0}{0}\plinc{115}{33.0}{0}%'
      WRITE (9,'(A)') '\plinr{107}{27.5}{0}\plinr{115}{27.5}{0}%'
      ELSE IF (L.EQ.2) THEN
      WRITE (9,'(A)') '\put(104,24){\framebox(60,14){ }}'
      WRITE (9,'(A)') '\plinb{107}{33.0}{0}\plinb{115}{33.0}{0}%'
      WRITE (9,'(A)') '\plinc{107}{27.5}{0}\plinc{115}{27.5}{0}%'
      ENDIF
      IF (PICTURE.EQ.'1') THEN
C      WRITE (9,'(3A)') '\put(87,0){\small ',PROFILE,'}'
      WRITE (9,'(3A)')
     & '\put(55,125){\large \bf Performance profiles for ',PROFILE,'}'
      ELSE
      WRITE (9,'(3A)') '\put(87,0){\footnotesize ',PROFILE,'}'
      ENDIF
      WRITE (9,'(A)') '\multiput(52, 20)(32,0){4}{\line(0, 1){2}}'
      WRITE (9,'(A)') '\multiput(52,120)(32,0){4}{\line(0,-1){2}}'
      IF (PICTURE.EQ.'1') THEN
      WRITE (9,'(A)') '\put(19,13){\footnotesize 0}'
      WRITE (9,'(A27,F3.1,A1)') '\put( 48,13){\footnotesize ',SS(1),'}'
      WRITE (9,'(A27,F3.1,A1)') '\put( 80,13){\footnotesize ',SS(2),'}'
      WRITE (9,'(A27,F3.1,A1)') '\put(112,13){\footnotesize ',SS(3),'}'
      WRITE (9,'(A27,F3.1,A1)') '\put(144,13){\footnotesize ',SS(4),'}'
      WRITE (9,'(A27,F3.1,A1)') '\put(174,13){\footnotesize ',SS(5),'}'
      ELSE
      WRITE (9,'(A)') '\put(19,13){\tiny 0}'
      WRITE (9,'(A19,F3.1,A1)') '\put( 48,13){\tiny ',SS(1),'}'
      WRITE (9,'(A19,F3.1,A1)') '\put( 80,13){\tiny ',SS(2),'}' 
      WRITE (9,'(A19,F3.1,A1)') '\put(112,13){\tiny ',SS(3),'}'
      WRITE (9,'(A19,F3.1,A1)') '\put(144,13){\tiny ',SS(4),'}'
      WRITE (9,'(A19,F3.1,A1)') '\put(174,13){\tiny ',SS(5),'}'
      ENDIF
      WRITE (9,'(A)') '\put(184,17.5){\small $$\tau$$}'
      WRITE (9,'(A)') '\multiput( 20,30)(0,10){9}{\line( 1,0){2}}'
      WRITE (9,'(A)') '\multiput(180,30)(0,10){9}{\line(-1,0){2}}'
      WRITE (9,'(A)') '\put(0,119){\small $$\rho(\tau)$$}'
      IF (PICTURE.EQ.'1') THEN
      WRITE (9,'(A)')
     & '\put(15,17.5){\footnotesize 0}\put(15,117.5){\footnotesize 1}' 
      WRITE (9,'(A)')
     & '\put(9,28){\footnotesize 0.1}\put(9,38){\footnotesize 0.2}'
      WRITE (9,'(A)')
     & '\put(9,48){\footnotesize 0.3}\put(9,58){\footnotesize 0.4}'
      WRITE (9,'(A)')
     & '\put(9,68){\footnotesize 0.5}\put(9,78){\footnotesize 0.6}'
      WRITE (9,'(A)')
     & '\put(9,88){\footnotesize 0.7}\put(9,98){\footnotesize 0.8}'
      WRITE (9,'(A)') '\put(9,108){\footnotesize 0.9}'
      ELSE
      WRITE (9,'(A)') '\put(15,17.5){\tiny 0}\put(15,117.5){\tiny 1}'
      WRITE (9,'(A)')
     &'\put(9,28){\tiny 0.1}\put(9,38){\tiny 0.2}\put(9, 48){\tiny 0.3}'
      WRITE (9,'(A)')
     &'\put(9,58){\tiny 0.4}\put(9,68){\tiny 0.5}\put(9, 78){\tiny 0.6}'
      WRITE (9,'(A)')
     &'\put(9,88){\tiny 0.7}\put(9,98){\tiny 0.8}\put(9,108){\tiny 0.9}'
      ENDIF
      N=21
      M=20     
      DT=8.0D 0
      IF (L.LE.1) GO TO 5
      L=MIN(INT(L),4)
      READ(8,'(A1)') CHAR
      DO 4 K=1,L
      READ(8,'(15X,A14)',END=5) NAME
      IF (L.EQ.4) THEN
      IF (PICTURE.EQ.'1') THEN
      IF (K.EQ.1) WRITE (9,'(3A)')
     & '\put(132,42.5){\footnotesize\tt ',NAME,'}'
      IF (K.EQ.2) WRITE (9,'(3A)')
     & '\put(132,37.0){\footnotesize\tt ',NAME,'}'
      IF (K.EQ.3) WRITE (9,'(3A)')
     & '\put(132,31.5){\footnotesize\tt ',NAME,'}'
      IF (K.EQ.4) WRITE (9,'(3A)')
     & '\put(132,26.0){\footnotesize\tt ',NAME,'}'
      ELSE
      IF (K.EQ.1) WRITE (9,'(3A)')
     & '\put(132,42.5){\tiny\tt ',NAME,'}'
      IF (K.EQ.2) WRITE (9,'(3A)')
     & '\put(132,37.0){\tiny\tt ',NAME,'}'
      IF (K.EQ.3) WRITE (9,'(3A)')
     & '\put(132,31.5){\tiny\tt ',NAME,'}'
      IF (K.EQ.4) WRITE (9,'(3A)')
     & '\put(132,26.0){\tiny\tt ',NAME,'}'
      ENDIF
      ELSE IF (L.EQ.3) THEN
      IF (PICTURE.EQ.'1') THEN
      IF (K.EQ.1) WRITE (9,'(3A)')
     & '\put(132,37.0){\footnotesize\tt ',NAME,'}'
      IF (K.EQ.2) WRITE (9,'(3A)')
     & '\put(132,31.5){\footnotesize\tt ',NAME,'}'
      IF (K.EQ.3) WRITE (9,'(3A)')
     & '\put(132,26.0){\footnotesize\tt ',NAME,'}'
      ELSE
      IF (K.EQ.1) WRITE (9,'(3A)')
     & '\put(132,37.0){\tiny\tt ',NAME,'}'
      IF (K.EQ.2) WRITE (9,'(3A)')
     & '\put(132,31.5){\tiny\tt ',NAME,'}'
      IF (K.EQ.3) WRITE (9,'(3A)')
     & '\put(132,26.0){\tiny\tt ',NAME,'}'
      ENDIF
      ELSE IF (L.EQ.2) THEN
      IF (PICTURE.EQ.'1') THEN
      IF (K.EQ.1) WRITE (9,'(3A)')
     & '\put(132,31.5){\footnotesize\tt ',NAME,'}'
      IF (K.EQ.2) WRITE (9,'(3A)')
     & '\put(132,26.0){\footnotesize\tt ',NAME,'}'
      ELSE
      IF (K.EQ.1) WRITE (9,'(3A)')
     & '\put(132,31.5){\tiny\tt ',NAME,'}'
      IF (K.EQ.2) WRITE (9,'(3A)')
     & '\put(132,26.0){\tiny\tt ',NAME,'}'
      ENDIF
      ENDIF
      READ(8,'(A1)') CHAR
      READ(8,'(8F10.4)')(PP(I),I=1,N)
      READ(8,'(A1)') CHAR
      DO 2 I=1,N
      PP(I)=PP(I)*1.0D 2+2.0D 1
    2 CONTINUE
      X=2.0D 1
      DO 3 I=2,N
      W=PP(I-1)
      IF (K.EQ.1) THEN
      WRITE(9,'(A,F4.0,A,F5.1,A,F3.1,A)')
     & '\plinb{',X,'}{',W,'}{',(PP(I)-W)/M,'}%'
      ELSE IF (K.EQ.2) THEN
      WRITE(9,'(A,F4.0,A,F5.1,A,F3.1,A)')
     & '\plinc{',X,'}{',W,'}{',(PP(I)-W)/M,'}%'
      ELSE IF (K.EQ.3) THEN 
      WRITE(9,'(A,F4.0,A,F5.1,A,F3.1,A)')
     & '\plinr{',X,'}{',W,'}{',(PP(I)-W)/M,'}%'
      ELSE
      WRITE(9,'(A,F4.0,A,F5.1,A,F3.1,A)')
     & '\pling{',X,'}{',W,'}{',(PP(I)-W)/M,'}%'
      ENDIF
      X=X+DT
    3 CONTINUE
    4 CONTINUE
    5 WRITE (9,'(A)') '\end{picture}'
      WRITE (9,*) 
      WRITE (9,'(A)') '\end{document}'
      CLOSE(7)
      CLOSE(8)
      CLOSE(9)
      END
