$INTERFACE UALNH1                                             97/12/01

  CALL UALNH1(NF,$HA)
  $ADD(REAL,'\$HA($NF*($NF+1)/2)')
$REM  $ADD(INTEGER,'\NF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UALNH1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE LINEAR FUNCTION HESSIAN MATRIX. THE DENSE CASE.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  RO  HA(NF*(NF+1)/2)  HESSIAN MATRIX OF THE LINEAR FUNCTION.
*
* SUBPROGRAMS USED :
*  S   UXVSET  INITIATION OF A VECTOR.
*
      SUBROUTINE UALNH1(NF,HA)
      INTEGER NF
      $FLOAT HA(NF*(NF+1)/2)
      CALL UXVSET(NF*(NF+1)/2,0.0$P 0,HA)
      RETURN
      END
