$INTERFACE UCSET3                                             97/12/01

    CALL UCSET3(NF,$X,$IX,$XL,$XU,KBF,MOP2)
    $ADD(INTEGER,'\$IX($NX)')
$REM    $ADD(INTEGER,'\NF')
    $ADD(REAL,'\$X($NF)\$XL($NF)\$XU($NF)')

    $EXIT

* IMPLEMENTATION

* SUBROUTINE UCSET3             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF THE VECTOR CONTAINING TYPES OF BOUNDS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  II  KBF  VARIABLE WHICH SPECIFIES SIMPLE BOUNDS.
*
      SUBROUTINE UCSET3(NF,X,IX,XL,XU,KBF,JOB)
      INTEGER NF,IX(NF),KBF,JOB
      $FLOAT X(NF),XL(NF),XU(NF)
      INTEGER I
      IF (KBF.GT.0) THEN
      DO 1 I=1,NF
      IF ((IX(I).EQ.3.OR.IX(I).EQ.4).AND.XU(I).LE.XL(I)) THEN
      X(I)=XL(I)
      IX(I)=5
      ELSE IF (IX(I).EQ.5.OR.IX(I).EQ.6) THEN
      XL(I)=X(I)
      XU(I)=X(I)
      IX(I)=5
      ENDIF
      IF (JOB.GT.1) THEN
      IF (IX(I).EQ.1.OR.IX(I).EQ.3.OR.IX(I).EQ.4) X(I)=MAX(X(I),XL(I))
      IF (IX(I).EQ.2.OR.IX(I).EQ.3.OR.IX(I).EQ.4) X(I)=MIN(X(I),XU(I))
      ENDIF
    1 CONTINUE
      ENDIF
      RETURN
      END





