$INTERFACE UCSET5                                             97/12/01

    CALL UCSET5(NA,MAL,NC,$IA,$IC)
    $ADD(INTEGER,'\$IA(2*$NC+1)\$IC($NC)')
$REM    $ADD(INTEGER,'\NA\MAL\NC')
    $EXIT

* IMPLEMENTATION

* SUBROUTINE UCSET5             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* FORMULATION OF THE MINIMAX APPROXIMATION PROBLEM FROM THE NONLINEAR
* PROGRAMMING PROBLEM. INITIATION.
*
* PARAMETERS :
*  IO  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  IO  NAL  NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  II  NC  NUMBER OF CONSTRAINTS.
*  IO  IA(2*NC+1)  VECTOR CONTAINING TYPES OF APPROXIMATED FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*
      SUBROUTINE UCSET5(NA,NAL,NC,IA,IC)
      INTEGER NA,NAL,NC,IA(2*NC+1),IC(NC)
      INTEGER KC
      NA=1
      IA(NA)=2
      DO 1 KC=1,NC
      IF (IC(KC).GE.1) THEN
      NA=NA+1
      IA(NA)=2
      IF (IC(KC).GE.3) THEN
      NA=NA+1
      IA(NA)=2
      ENDIF
      ENDIF
    1 CONTINUE
      NAL=NA
      RETURN
      END




