$INTERFACE UDSLI2                                             03/12/01
$REM LU

  $D='D'
  $GS='GS'
$REM  $ICA='IX'
  $CON1='1.0$P-3'
  $CON2='5.0$P-1'
  $CON3='0.0$P 0'
  $CON4='1.0$P-1'
  $CON5='1.0$P-3'
  $CON6='1.0$P 6'
$REM  $CON7='1.0$P-12'
  $POM1='U'
  $POM2=',$$IX,-KBF)'
$REM  $POM1='V'
$REM  $POM2=')'
  $ADD(REAL,'\$H($M)\$CG($MC)\$B($MMAX)\$CF($NC+1)\$CFD($NC+1)\$G($NF)&
  \$S($NF+$NCA)\$XO($NF+$NX+$NC)\$GO($NF+$NX+$NC)\$GS($NF+$NCA)&
  \$D($NF+$NCA)')
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XSL($NX)\$XSU($NX)\$XZL($NX)&
  \$XZU($NX)\$CL($NC)\$CU($NC)\$CSL($NC)\$CSU($NC)\$CZL($NC)\$CZU($NC)')
  $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)\$ICG($NC+1)\$JCG($MC)\$IX($NX)&
  \ICA($NCA)')
  $ADD(REAL,'\UXVDOT\UX$(POM1)DOT')
  $ADD(REAL,'\STOL\SIG1\ALF')
  $ADD(INTEGER,'\I\J\MM\NN\NCA\IPOM\KPOM')
  $MOT1=0
  $HELP
    METHOD SELECTION:
      1 - BISECTION
      2 - TWO POINT QUADRATIC INTERPOLATION
      3 - THREE POINT QUADRATIC INTERPOLATION
      4 - THREE POINT CUBIC INTERPOLATION
  $CHECK(MES,1,'1\2\3\4',3)
  $DEFAULT='ETA0*1.0D-3'
$REM  $IF(MEP=3) $DEFAULT='1.0$P-4'
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,DEFAULT,REAL,4)
  CALL UOD1D1
  $GRAD=G
  GNORM=SQRT(UX$(POM1)DOT($N,$G,$G$POM2)
  CALL UXVNEG($N,$G,$GS)
*
*     DETERMINATION OF ACTIVE CONSTRAINTS AND CONSTRUCTION OF THE
*     CORRESPONDING KARUSH-KUHN-TUCKER SYSTEM
*
  M=$IH($N+1)-1
  NCA=0 
  CALL UCINAT($N,NX,$NN,MC,M,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF&
,$IC,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$CG,$ICG,$JCG,$GS,$GO,$H,$IH,$JH,RPF3&
,MEP1)
  CALL UODLI3($N,NX,$NN,NCA,$IX,$IC,$ICA,$GS,RPF2,RPF3,INF)
  IF (IDECF.EQ.0) THEN
  CALL UXSPCT($N,M,MH,MMAX,$H,$JH,$PSL,ITERM)
  IF (ITERM.NE.0) THEN
  TDXX='LACK SPC'
  GO TO $90
  ENDIF
*
*     SPARSE GILL-MURRAY DECOMPOSITION
*
  ALF=ETA2
  CALL UXSPCF($N,MMAX-M,$H(M+1),$PSL,$JH(M+1),$WN11,$WN12,$XO,INF&
,ALF,BET)
  NDECF=NDECF+1
  IDECF=1
  ENDIF
  CALL UXVCOP($N,$GS,$S)
  CALL UXVSFP($N,$PERM,$S,$XO)
  CALL UXSPCB($N,MMAX-M,$H(M+1),$PSL,$JH(M+1),$S,0)
  CALL UXVSBP($N,$PERM,$S,$XO)
*
*     NEWTON LIKE STEP
*
  INITD=MAX(ABS(INITD),1)
  ITERD=1
  TDXX = 'B-P STEP'
*
*     COMPUTATION OF THE DIRECTIONAL DERIVATIVE
*
  IPOM=0
  KPOM=0
  RPF2=RPF1
  $SUBST('UDSLID')
  CALL UODLI4($N,NX,$NN,NCA,$D,$S($N+1),$XO($N+1),$GO($N+1),$GS($N+1))
$90 CONTINUE
  R=ZERO
  CALL UOD1D2($N,$G,$S)
  CALL UXVSET(NX,ZERO,XO)
  $ADD(INIT)
    NDXX='UDSLI1'
  $ENDADD
  $EXIT

