$INTERFACE UDSSQ1                                             97/12/01
$REM TU
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XMAX,'1.0$P 3',REAL,2)
  $HELP
    MAXIMUM NUMBER OF MINOR CYCLES
  $CHECK(MIQ,500,INT,4,NO)
  $HELP
    MAXIMUM NUMBER OF MAJOR CYCLES
  $CHECK(MAQ,500,INT,4,NO)
  $ADD(INTEGER,'\$INBCOL($MCOLS)\$JH($MMAX)\$IH($MCOLS+1)')
  $ADD(REAL,'\$LAM($MCOLS)\$ECG($MCOLS)\$FCG($MCOLS)\$RCG($MCOLS)')
  $ADD(REAL,'\$PV($MCOLS)\$H($MMAX)\$S($MCOLS)')
  $ADD(REAL,'\$G($MCOLS)\$GF($MCOLS)\$XO($MCOLS)\$GO($MCOLS)')
$REM  $ADD(INTEGER,'NF\N\M\MROWS\MCOLS\NZ\NZA\NAU\NUP\MMAX\NEL\NAP\IBEG&
\IBGR\IENDLU\MFP\MQP\MQP1\MLP1\NIQ\NAQ\MRED\INEW\IOLD\KOLD\KINP\LINP&
\MINP\IER')
$REM  $ADD(REAL,'\ALF1\ALF2\DEL1\DEL2\DEL3\EPS6\EPS7\EPS8\EPS9\RMIN&
\RMAX\DMAX\GMAX\UMAX\XMAX\GNORM\SNORM\XNORM\FF\F\FO\P\PO\T\TO\TL\TU&
\E\EL\EU')
$ADD(INTEGER,'\I\J\KBFPOM')
$ADD(REAL,'\FSAV\UXVDOT')
  $ADD(INIT)
    NDXX='UDSSQ1'
  $ENDADD
  CALL UOD1D1
*
*     COMPUTE PARAMETERS FF,G OF THE QUADRATIC MODEL
*     FIRST - SAVE F,GF,X - FUNCTION VALUE AND GRADIENT
*
*
*     COMPUTE G
*
*      CALL UXSSMM(N,$IH(N+1)-1,$H,$IH,$JH,$X,$G)
*      CALL UXVSUM(N,$GF,$G,$G)
  FSAV=F
  LD=0
  CALL UF1FQ2(NF,$IH(NF+1)-1,$X,$GF,$G,$HF,$IH,$JH,FF,F)
*
*     COMPUTE FF
*
  FF=F-0.5$P 0*(UXVDOT(NF,X,GF)+UXVDOT(NF,X,G))
*
*     CALL QP: PARAMETERS G AND GF ARE USED DIFFERENTLY
*
$REM  CALL UXVSET(N-NF,ZERO,G(NF+1))
$REM  CALL UXVSET(N-NF,ZERO,GF(NF+1))
  CALL UXVINS(MCOLS-NF,$IH(NF+1),$IH(NF+1))
  CALL UKQGLM(NF,N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,MMAX,NEL,IBEG&
,IBGR,IENDLU,$PTL,$LENL,$CNR,$PTR,$LENR,$ORDC,$ORDR,$ORDL,$LI,$LJ,$CM&
,$AU,$LAM,$WR01,$X,$GF,$G,$H,$JH,$IH,$BCOL,$RNR,$PRNR,$A,$INBCOL,$IX&
,$WN01,$WR02,$S,$XL,$XU,$ECG,$FCG,$RCG,$PV,$RIGHT,$UP,ALF1,ALF2,DEL1&
,DEL2,DEL3,EPS6,EPS7,EPS8,EPS9,RMIN,RMAX,DMAX,GMAX,UMAX,XMAX,GNORM,SNORM&
,XNORM,R,FF,F,FO,P,PO,T,TO,TL,TU,E,EL,EU,MFP,MQP,MQP1,MLP1,NIQ,NAQ,MRED&
,$MIQ,$MAQ,INEW,IOLD,KOLD,KINP,LINP,MINP,IER)
*
*     COMPUTE LAGRANGE MULTIPLIERS RELATED TO INPUT CONSTRAINTS
*
      J=1
      DO $10 I=1,NC
      IF (IC(I).LE.0) THEN
      J=J+1
      ELSE IF (IC(I).EQ.3) THEN
      $CZ(I)=$LAM(J)+$LAM(J+1)
      J=J+2
      ELSE
      $CZ(I)=$LAM(J)
      J=J+1
      ENDIF
  $10 CONTINUE
*
*     PREPARE LAM FOR COMPUTING GMAX,UMAX WITH NEW GRADIENT
*
      DO $20 I=LINP+1,N
        J=$BCOL(I)
        $LAM(I)=$LAM(I)-$G(J)
  $20 CONTINUE
*
*     COMPUTE DIRECTION, RETRIEVE VALUES
*
      F=FSAV
      CALL UXVDIF(NF,$X,$XO,$S)
      CALL UXVCOP(NF,$GO,$GF)
      CALL UXVCOP(NF,$XO,$X)
*
*     GNORM,SNORM COMPUTATION
*
      SNORM=ZERO
      GNORM=ZERO
      DO $30 I=1,NF
        SNORM=MAX(SNORM,ABS($S(I)))
        GNORM=MAX(GNORM,ABS($GF(I)))
  $30 CONTINUE
      ITERD=ITERQ
*
*     SET TDXX
*
      IF (ITERD.EQ.3) THEN
        TDXX='INEX. ST'
      ELSE IF (ITERD.EQ.2) THEN
        TDXX='OPT. QP '
      ELSE IF (ITERD.EQ.1) THEN
        TDXX='ARB. ST.'
      ELSE IF (ITERD.EQ.-1) THEN
        TDXX=TLPX
      ELSE IF (ITERD.EQ.-2) THEN
        TDXX='UNBND DR'
      ENDIF
      CALL UOD1D2(N,$GF,$S)
$REM      M=MCL
      XMAX=HDEL
      KBF=KBFPOM
$EXIT
