$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UGFU13                                    01/12/01  +
$REM + SI                                                            +
$REM + PURPOSE: GLOBAL OPTIMIZATION VIA MODIFIED MULTIPLE RANDOM     +
$REM +          START METHOD                                         +
$REM +---------------------------------------------------------------+

      $HELP
        MAX. NUMBER OF RANDOM POINTS IN THE SAMPLE
      $CHECK(MNRND,'NF*60',STR,3,NO)
      $SUBST('UZSRND')
      $ADD(REAL,'\X($NF)\XL($NF)\XU($NF)')
      $TEXT='UGFU13'
      $SUBST('UO3FU1')
$L=$00; $LABEL
      CALL UGFU13(NF,X,XL,XU,F)
      GOTO ($30,$10,$20) ISB+1
$L=$20; $LABEL
      $SUBST('UZLMIN')
      GOTO $00
$L=$10; $LABEL
      $KD=0
      $SUBST('UZMODL')
      GOTO $00
$L=$30; $LABEL
$ADD(SUBROUTINES)
      SUBROUTINE UGFU13(NF,X,XL,XU,F)
      INTEGER NF
      $FLOAT X($NF),XL($NF),XU($NF),F
      $INCLUDE('UMCOMM')
      REAL UNRAN$RGTYPE
      $FLOAT XM($NF),FMING
      INTEGER NRND,MNRND,NITT,NFVT,NFGT,NFHT,NLMST,I,IDUM
      SAVE XM,FMING
      SAVE NRND,MNRND,NITT,NFVT,NFGT,NFHT,NLMST
$REM      IF (NS.EQ.0.OR.TSS(NS).NE.'UGFX') THEN
      IF (NS.EQ.0) THEN
        CALL UYPRO1('UGFX',-1)
        NITT=0
        NFVT=0
        NFGT=0
        NFHT=0
        NRND=0
        IDUM=-1
        NLMST=0
        X(1)=UNRAN$RGTYPE(IDUM)
        MNRND=$MNRND
      ENDIF
      GOTO (10,30,40), ISP(NS)
  *
  *     RANDOM SAMPLE
  *
   10 CONTINUE
        IDUM=1
        DO 20 I=1,NF
          X(I)=(XU(I)-XL(I))*UNRAN$RGTYPE(IDUM)+XL(I)
   20   CONTINUE
  *
  *     COMPUTATION OF THE FUNCTION VALUE
  *
        KD=0
        CALL UYSET2
        CALL UYSET0(1,2)
        RETURN
   30   CONTINUE
        NFVT=NFVT+1
        IF (NRND.GT.0) THEN
          IF (F.GT.FMING) THEN
            GOTO 50
          ENDIF
        ENDIF
  *
  *     LOCAL OPTIMIZATION
  *
          CALL UYCLST
          CALL UYSET0(2,3)
          RETURN
   40     CONTINUE
          NITT=NITT+NIT
          NFVT=NFVT+NFV
          NFGT=NFGT+NFG
          NFHT=NFHT+NFH
          NLMST=NLMST+1
          FMING=F
          CALL UXVCOP(NF,X,XM)
          CALL UO3FU2(NITT,NFVT,FMING)
   50   CONTINUE
        NRND=NRND+1
      IF (NRND.LT.MNRND) GOTO 10
  *
  *     PRINT OF RESULTS
  *
      F=FMING
      CALL UXVCOP(NF,XM,X)
      NIT=NITT
      NFV=NFVT
      NFG=NFGT
      NFH=NFHT
      CALL UO3FU3(NF,F,X)
      CALL UYEPI1(-1)
      END
$ENDADD
