$INTERFACE UOGRF3                                             98/12/01

  $FTH='FTH'
  $IF(PATH='YES')
    $JOB=1
    $DIM=2
  $ELSE
    $JOB=2
    $DIM=NF
  $ENDIF
  $ADD(INTEGER,'\NFV1\NAV1')
  $ADD(REAL4,'\$FL($NGR,$NGR)\$FTH($NGR,2)\$XPA($NPA,$DIM)')
  $ADD(REAL,'\$X($NF)')
      $IF(NA>0)
        CALL UXVCOP(NA,$AF,$AFO)
        $ADD(REAL,'\$AFO($NA)')
      $ENDIF
  $50 CALL UOGRF3(NF,$X,$XPA,$FL,F,FO,$ETA9,$JOB)
      GOTO ($60,$70,$71) ISB+1
  $60 CONTINUE
      $IF(NA>0)
        CALL UXVCOP(NA,$AFO,$AF)
      $ENDIF
      GOTO $LGR
  $70 CONTINUE
      NFV1=NFV
      NAV1=NAV
      $SUBST('UZMODL')
      NFV=NFV1
      NAV=NAV1
      GOTO $50
  $71 CONTINUE
      CALL UOCON2($FL,$FTH,$XPA,$JOB)
      GOTO $50
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOGRF3                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRAPHICAL OUTPUT - PATH.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RO  FL(NGR,NGR)  FIELD OF DRAWN FUNCTION VALUES.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RO  FO  OLD VALUE OF THE OBJECTIVE FUNCTION.
*  RI  ETA9  MAXIMUM MACHINE CONSTANT.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
      $FIFAC
      SUBROUTINE UOGRF3(NF,X,XPA,FL,F,FO,ETA9,JOB)
      $FDECL
      $INCLUDE ('UMCOMM')
      $INCLUDE ('UMCOMG')
      CHARACTER*10 PROC
      CHARACTER*25 TEXT
      INTEGER NF,JOB
      REAL*4 FL(NGR,NGR),XPA(NPA,*)
      $FLOAT X(NF),F,FO,ETA9
      $FLOAT STIGR,STJGR
      SAVE STIGR,STJGR
      $FLOAT CON1,CON2
      PARAMETER(CON1=1.0$P-18,CON2=1.0$P 18)
      INTEGER DUMMY,I,IPAC,NPAC,IVAR,JVAR
      SAVE IVAR,JVAR
      RECORD/RCCOORD/S
      record /myitem/ynq(3)
      character*40 scstr1
      integer icur1, iprev1, citem1,cchar1,pod1
      integer*2 rx1
c
      ynq(1).nazev='Yes'
      ynq(1).pozice=66
      ynq(1).delka=3
      ynq(1).barva=15
      ynq(1).hi=1
c
      ynq(2).nazev='No'
      ynq(2).pozice=70
      ynq(2).delka=2
      ynq(2).barva=15
      ynq(2).hi=1
c
      ynq(3).nazev='Quit'
      ynq(3).pozice=73
      ynq(3).delka=4
      ynq(3).barva=15
      ynq(3).hi=1
c
      scstr1='YyNnQq'
      iprev1=0
      icur1=1
      rx1=28
      citem1=3
      cchar1=76
      pod1=2
c
      IF (TSS(NS).NE.'UYXX') CALL UYPRO1('UYXX',0)
      GO TO (1,4,6) ISP(NS)
    1 CONTINUE
      CALL UOGMHD
      CALL UOGMTR
      IPA=MIN(NPA,NIT)
      IRET=0
C
C     COMPUTATION OF BOUNDS
C
   90 NPAC=MIN(NPA,NIT)
      IPAC=MAX(NPAC-IPA+1,1)
      DUMMY=SETCOLOR(15)
      DUMMY=RECTANGLE($$GFILLINTERIOR,0,16,550,410)
      DUMMY=SETCOLOR(0)
      IF (JOB.EQ.1) THEN
      XLIGR=X(IGR)
      XUIGR=X(IGR)
      XLJGR=X(JGR)
      XUJGR=X(JGR)
      DO 11 I=IPAC,NPAC
      XLIGR=MIN(XLIGR,XPA(I,1))
      XUIGR=MAX(XUIGR,XPA(I,1))
      XLJGR=MIN(XLJGR,XPA(I,2))
      XUJGR=MAX(XUJGR,XPA(I,2))
   11 CONTINUE
      ELSE IF (IRET.EQ.2) THEN
      IF (NF.LE.2) THEN
      IGR=1
      JGR=NF
      ELSE
   10 CALL UOGMTR
      CALL UOGZD1(IGR,NF,27)
      CALL UOGZD1(JGR,NF,28)
      CALL SETTEXTPOSITION(int2(rx1-1),70,S)
      CALL OUTTEXT('OK?')
      do 40 i=1,3
      call UOGPIS(rx1,ynq(i))
   40 continue
      icur1=1
      call UOGBAR(rx1,pod1,ynq,0,icur1)
      call UOGRPK(rx1,ynq,scstr1,icur1,cchar1,citem1,iprev1,pod1,1)
      goto (30,10,20) icur1
      ENDIF
   30 XLIGR=X(IGR)
      XUIGR=X(IGR)
      XLJGR=X(JGR)
      XUJGR=X(JGR)
      DO 12 I=IPAC,NPAC
      XLIGR=MIN(XLIGR,XPA(I,IGR))
      XUIGR=MAX(XUIGR,XPA(I,IGR))
      XLJGR=MIN(XLJGR,XPA(I,JGR))
      XUJGR=MAX(XUJGR,XPA(I,JGR))
   12 CONTINUE
      ELSE
      XLIGR=X(IGR)
      XUIGR=X(IGR)
      XLJGR=X(JGR)
      XUJGR=X(JGR)
      DO 13 I=IPAC,NPAC
      XLIGR=MIN(XLIGR,XPA(I,IGR))
      XUIGR=MAX(XUIGR,XPA(I,IGR))
      XLJGR=MIN(XLJGR,XPA(I,JGR))
      XUJGR=MAX(XUJGR,XPA(I,JGR))
   13 CONTINUE
      ENDIF
      STIGR=MAX((XUIGR-XLIGR)/TEN,(XUIGR+XLIGR)*1D-6,1.0D-16)
      STJGR=MAX((XUJGR-XLJGR)/TEN,(XUJGR+XLJGR)*1D-6,1.0D-16)
      XLIGR=XLIGR-STIGR
      XUIGR=XUIGR+STIGR
      XLJGR=XLJGR-STJGR
      XUJGR=XUJGR+STJGR
      CALL SETTEXTPOSITION (15,15,S)
      DUMMY=0
      WRITE(PROC,'(4X,I3,'' % '')') DUMMY
      CALL OUTTEXT(PROC)
      FO=F
      XIGR=X(IGR)
      XJGR=X(JGR)
      STIGR=(XUIGR-XLIGR)/(NGR-1)
      STJGR=(XUJGR-XLJGR)/(NGR-1)
      VALMIN= ETA9
      VALMAX=-ETA9
      IVAR=0
    2 IVAR=IVAR+1
      X(IGR)=XLIGR+(IVAR-1)*STIGR
      JVAR=0
    3 JVAR=JVAR+1
      X(JGR)=XLJGR+(JVAR-1)*STJGR
      CALL UYSET2
      CALL UYSET0(1,2)
      RETURN
    4 CONTINUE
      IF (ABS(F).GE.CON2) THEN
      FL(IVAR,JVAR)=SIGN(CON2,F)
      ELSE IF (ABS(F).LE.CON1) THEN
      FL(IVAR,JVAR)=SIGN(CON1,F)
      ELSE
      FL(IVAR,JVAR)=F
      ENDIF
      IF (FL(IVAR,JVAR).LT.VALMIN) THEN
      VALMIN=FL(IVAR,JVAR)
      IMIN=IVAR
      JMIN=JVAR
      ENDIF
      IF (FL(IVAR,JVAR).GT.VALMAX) VALMAX=FL(IVAR,JVAR)
      IF (JVAR.LT.NGR) GO TO 3
      CALL SETTEXTPOSITION (15,15,S)
      DUMMY=100*IVAR/NGR
      WRITE(PROC,'(4X,I3,'' % '')') DUMMY
      CALL OUTTEXT(PROC)
      IF (IVAR.LT.NGR) GO TO 2
      X(IGR)=XIGR
      X(JGR)=XJGR
      F=FO
    5 DUMMY=SETCOLOR(15)
      DUMMY=RECTANGLE($$GFILLINTERIOR,0,16,550,410)
      DUMMY=SETCOLOR(0)
      CALL UYSET0(2,3)
      RETURN
    6 CONTINUE
      IF (IRET.EQ.2) THEN
      IPA=MIN(NPA,NIT)
      GO TO 90
      ENDIF
      IF (IRET.EQ.1) THEN
      CALL UOGMTR
      DUMMY=SETTEXTCOLOR(15)
      CALL SETTEXTPOSITION(27,1,S)
      WRITE(TEXT,'(''OLD NUMBER OF POINTS'',I5)') IPA
      CALL OUTTEXT(TEXT)
      CALL SETTEXTPOSITION(28,1,S)
      WRITE(TEXT,'(''NEW NUMBER OF POINTS'')')
      CALL OUTTEXT(TEXT)
   60 CALL SETTEXTPOSITION(27,60,S)
      CALL OUTTEXT('                 ')
      CALL SETTEXTPOSITION(28,21,S)
      CALL OUTTEXT('                                        ')
      CALL OUTTEXT('                                        ')
      CALL SETTEXTPOSITION(28,24,S)
      READ(*,'(I5)',ERR=60) IPA
      IF (IPA.LT.1.OR.IPA.GT.NPA) GOTO 60
      CALL SETTEXTPOSITION(27,70,S)
      iprev1=0
      icur1=1
      pod1=2
      dummy=settextcolor(15)
      CALL OUTTEXT('OK?')
      do 50 i=1,3
      call UOGPIS(rx1,ynq(i))
   50 continue
      icur1=1
      call UOGBAR(rx1,pod1,ynq,0,icur1)
      call UOGRPK(rx1,ynq,scstr1,icur1,cchar1,citem1,iprev1,pod1,1)
      goto (90,60,20) icur1
      ENDIF
   20 CALL UOGMHD
      CALL UOGMTR
      CALL UYEPI1(0)
      RETURN
      END
