* SUBROUTINE UOJZD1                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
* CHOICE OF VISUALISED VARIABLES.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  II  NFD  NUMBER OF VISUALIZED VARIABLES. 
*  IO  IGR  INDEX OF THE 1-ST VISUALIZED VARIABLE.
*  IO  JGR  INDEX OF THE 2-ND VISUALIZED VARIABLE.
*  IO  JGR  INDEX OF THE 3-RD VISUALIZED VARIABLE.
*  II  NFD  NUMBER OF VISUALIZED VARIABLES. 
*
      SUBROUTINE UOJZD1(N,NFD,IGR,JGR,KGR)
      INTEGER N,NFD,IGR,JGR,KGR
      IF (N.LE.0) RETURN
      IF (NFD.GE.1) THEN
   1  CONTINUE
      WRITE(*,'(A44)') 'INDEX OF THE 1-ST VISUALIZED VARIABLE: IGR ='
      READ(*,'(I5)',ERR=1) IGR
      IF (IGR.GT.N) GO TO 1
      IF (IGR.LE.0) GO TO 1
      IF (N.LE.1) RETURN
      ENDIF
      IF (NFD.GE.2) THEN
   2  CONTINUE
      WRITE(*,'(A44)') 'INDEX OF THE 2-ND VISUALIZED VARIABLE: JGR ='
      READ(*,'(I5)',ERR=2) JGR
      IF (JGR.GT.N) GO TO 2
      IF (JGR.LE.0) GO TO 2
      IF (JGR.EQ.IGR) GO TO 2
      IF (N.LE.2) RETURN
      ENDIF
      IF (NFD.GE.3) THEN
   3  CONTINUE
      WRITE(*,'(A44)') 'INDEX OF THE 3-RD VISUALIZED VARIABLE: KGR ='
      READ(*,'(I5)',ERR=3) KGR
      IF (KGR.GT.N) GO TO 3
      IF (KGR.LE.0) GO TO 3
      IF (KGR.EQ.IGR) GO TO 3
      IF (KGR.EQ.JGR) GO TO 3
      ENDIF
      RETURN
      END
