$INTERFACE UOT1Y1                                             98/12/01

  CALL UOT1Y1(NF,$GE,FE)
  $ADD(REAL,'\$GE($NF)')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOT1Y1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF TEST OF EXTERNAL SUBROUTINES.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  GE(NF)  GRADIENT OF THE CONSTRAINT FUNCTION.
*  RI  FE  VALUE OF THE CONSTRAINT FUNCTION.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  KD DEGREE OF REQUIRED DERIVATIVES.
*
* OUTPUT VARIABLES:
* FE,GE(NF)
*
      SUBROUTINE UOT1Y1(NF,GE,FE)
      $INCLUDE('UMCOMM')
      INTEGER NF
      $FLOAT GE(NF),FE
      INTEGER I
      GOTO(1,4) KD+1
    1 WRITE(IWR,2) 'FY A =',FE
    2 FORMAT(/1X,A6,$P 19.10)
      WRITE(IWR,3) 'GY N =',(GE(I),I=1,NF)
    3 FORMAT(' ',A6,4$P 18.10:/(7X,4$P 18.10))
      RETURN
    4 WRITE(IWR,3) 'GY A =', (GE(I),I=1,NF)
      RETURN
      END
