$INTERFACE UOT2C1                                             98/12/01

  CALL UOT2C1(NF,$GC,$HC,FC)
  $ADD(REAL,'\$GC($NF)\$HC($NF*($NF+1)/2)')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOT2C1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF TEST OF EXTERNAL SUBROUTINES.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  GC(NF)  GRADIENT OF THE CONSTRAINT FUNCTION.
*  RI  HC(NF*(NF+1)/2) HESSIAN MATRIX OF THE CONSTRAINT FUNCTION.
*  RI  FC  VALUE OF THE CONSTRAINT FUNCTION.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  KD DEGREE OF REQUIRED DERIVATIVES.
*
* OUTPUT VARIABLES::
* FC,GC(NF),HC(NF*(NF+1)/2)
*
      SUBROUTINE UOT2C1(NF,GC,HC,FC)
      $INCLUDE('UMCOMM')
      INTEGER NF
      $FLOAT GC(NF),HC(NF*(NF+1)/2),FC
      INTEGER I
      GOTO(1,4,5) KD+1
    1 WRITE(IWR,2) 'FC A =',FC
    2 FORMAT(/1X,A6,$P 18.10)
      WRITE(IWR,3) 'GC N =',(GC(I),I=1,NF)
    3 FORMAT(' ',A6,4$P 18.10:/(7X,4$P 18.10))
      RETURN
    4 WRITE(IWR,3) 'GC A =', (GC(I),I=1,NF)
      WRITE(IWR,3) 'HC N =', (HC(I),I=1,NF*(NF+1)/2)
      RETURN
    5 WRITE(IWR,3) 'HC A =', (HC(I),I=1,NF*(NF+1)/2)
      RETURN
      END
