$INTERFACE UP1FF9                                             99/12/01

  $SUBST('UZCSET')
  $HELP
    TYPE OF EXTREMUM:
       0 - MINIMUM
       1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $HELP
    PENALTY FUNCTION FOR COMPLEMENTARITY CONSTRAINTS
       1 - THE L1 EXACT PENALTY FUNCTION
       2 - THE SUM OF SQUARES
  $CHECK(MEC,1,'1\2',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $HELP
    INITIAL VALUE OF SLACK VARIABLES
  $CHECK(EPS7,'1.0$P-1',REAL,4)
  $HELP
    INITIAL VALUE OF LAGRANGE MULTIPLIERS
  $CHECK(EPS8,'1.0$P-1',REAL,4)
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XSL($NX)\$XSU($NX)\$XZL($NX)&
  \$XZU($NX)\$GF($NF)\$CL($NC)\$CU($NC)\$CSL($NC)\$CSU($NC)\$CZL($NC)&
  \$CZU($NC)\$GC($NF)\$G($NF)')
$REM  $ADD(REAL,'\EPS7\EPS8\RPF4\FF\FC\F\CMAX')
  $ADD(INTEGER,'\$IX($NX)\$IXE($NX)\$IC($NC)\$ICE($NC)\ICC(2*$NCC)&
  \$ICG($NC+1)\$JCG($MC)')
$REM  $ADD(INTEGER,'\NF\NX\NC\NCC\MC\KC')
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ---------------------------
*     PENALTY FUNCTION DEFINITION
*     ---------------------------
*
$OPTION(CHDIR=CHPOM)
 $00  CALL UP1FF9(NF,NX,NC,NCC,MC,KC,$X,$IX,$IXE,$XL,$XU,$XSL,$XSU&
,$XZL,$XZU,$GF,$IC,$ICE,$ICC,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$GC,$ICG,$JCG&
,$G,EPS7,EPS8,RPF4,FF,FC,F,CMAX,$MEC)
      GO TO ($90,$10,$20,$50,$60) ISB+1
 $10  CONTINUE
      $MTYPE=FMODF
      $SUBST('UZFMOD')
      GO TO $00
 $20  CONTINUE
      $IF(GMODF='G')
        $MTYPE='G'
        $SUBST('UZFMOD')
        GO TO $00
      $ELSEIF(FMODF='F')
        $HELP
          METHOD FOR DETERMINATION OF DIFFERENCE USED FOR
          NUMERICAL COMPUTATION OF GRADIENT:
            0 - CONSTANT DIFFERENCE
            1 - EASY COMPARATIVE METHOD
            2 - STEWART'S METHOD.
        $CHECK(MCG,2,'0\1\2',3)
        $IF(MCG=0)
          $SUBST('UF0G$(CON)1')
        $ELSE
          $SUBST('UF0G$(CON)2')
        $ENDIF
        GO TO ($40,$30) ISB+1
 $30  CONTINUE
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $20
 $40  CONTINUE
        GO TO $00
      $ELSEIF(.TRUE.)
        IF (LD.LT.0) GO TO $00
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $00
      $ELSE
        GO TO $00
      $ENDIF
 $50  CONTINUE
      $IF(SAVC>-1)
        IF(LDC.GE.0) THEN
        FC=$CF(KC)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NCL<>0)
        IF(KC.LE.NCL) THEN
        $SUBST('UCLNF3')
        $IF(KBC>0) $SUBST('UCTRF1')
        $IF(ISNC>0)
          $SUBST('UCSVF1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<0)
        $IF(NCL<>NC)
          $MTYPE=FMODC
          $SUBST('UZCMOD')
          $IF(NORMC>0) $SUBST('UCNRF1')
          $IF(KBC>0) $SUBST('UCTRF1')
          $IF(ISNC>0)
            $SUBST('UCSVF1')
          $ENDIF
          $IF(FMODC<>'F')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $60  CONTINUE
      $IF(SAVC>0)
        IF(LDC.GE.1) THEN
        $SUBST('UCLNG3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NCL<>0)
        IF(KC.LE.NCL) THEN
        $SUBST('UCLNG3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<1)
        $IF(NCL<>NC)
          $IF(GMODC='G')
            $MTYPE='G'
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
            GO TO $00
          $ELSEIF(FMODC='F')
            $IF(ISNC>0)
              IF (LD.GE.0) FC=$CF(KC)
            $ENDIF
 $65  CONTINUE
            $SUBST('UC0G$(CON)3')
            GO TO ($80,$70) ISB+1
 $70  CONTINUE
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRF1')
            $IF(KBC>0) $SUBST('UCTRF1')
            GO TO $65
 $80  CONTINUE
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
            GO TO $00
          $ELSEIF(.TRUE.)
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRF1')
            $IF(KBC>0) $SUBST('UCTRF1')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
            GO TO $00
          $ELSE
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $90  CONTINUE
      LD=KD
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ----------------------------------
*     END OF PENALTY FUNCTION DEFINITION
*     ----------------------------------
*
$OPTION(CHDIR=CHPOM)
      $ADD(INIT)
        NPXX='UP1FF9'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UP1FF9             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION.
* COMPUTATION OF THE VALUES AND THE GRADIENTS OF THE CONSTRAINT
* FUNCTIONS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  MC  NUMBER OF NONZERO ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  IU  KC  INDEX OF THE CONSTRAINT.
*  II  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NX)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  IXE(NX)  VECTOR CONTAINING INDICES OF COUPLED BOUNDS.
*  RI  XL(NX)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NX)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  XZL(NX)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NX)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  RI  GF(NF)  GRADIENT OF THE MODEL FUNCTION.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  II  ICE(NX)  VECTOR CONTAINING INDICES OF COUPLED CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  RI  GC(NF)  GRADIENT OF THE SELECTED FUNCTION.
*  II  ICG(NC+1)  POSITIONS OF THE FIRST ROWS ELEMENTS IN THE SPARSE
*         JACOBIAN STRUCTURE.
*  II  JCG(MC)  COLUMN INDICES OF ELEMENTS IN THE SPARSE JACOBIAN
*         STRUCTURE.
*  RO  G(NF)  GRADIENT OF THE LAGRANGIAN FUNCTION.
*  RI  EPS7  INITIAL VALUE OF THE SLACK VARIABLES.
*  RI  EPS8  INITIAL VALUE OF THE LAGRANGE MULTIPLIERS.
*  RI  FF  VALUE OF THE MODEL FUNCTION.
*  RO  FC  VALUE OF THE PENALTY TERM.
*  RO  F  VALUE OF THE LAGRANGIAN FUNCTION.
*  RO  CMAX  MAXIMUM CONSTRAINT VIOLATION.
*  II  IPEN  TYPE OF A PENALTY FUNCTION. IPEN=1-THE L1 EXACT PENALTY
*         FUNCTION. IPEN=2-THE SUM OF SQUARES.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMUM. IEXT=1-MAXIMUM.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UXVNEG  COPYING OF A VECTOR WITH CHANGE OF THE SIGN.
*
      SUBROUTINE UP1FF9(NF,NX,NC,NCC,MC,KC,X,IX,IXE,XL,XU,XSL,XSU,XZL,
     & XZU,GF,IC,ICE,ICC,CL,CU,CSL,CSU,CZL,CZU,GC,ICG,JCG,G,EPS7,EPS8,
     & RPF4,FF,FC,F,CMAX,IPEN)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NX,NC,NCC,MC,KC,IX(NX),IXE(NX),IC(NC),ICE(NC),
     & ICC(2*NCC),ICG(NC+1),JCG(MC),IPEN
      $FLOAT X(NF),XL(NX),XU(NX),XSL(NX),XSU(NX),XZL(NX),XZU(NX),
     & GF(NF),CL(NC),CU(NC),CSL(NC),CSU(NC),CZL(NC),CZU(NC),GC(NF),
     & G(NF),EPS7,EPS8,RPF4,FF,FC,F,CMAX
      INTEGER I,IK,IL,J,JP,K,KK,L,LL
      $FLOAT TEMP,FK,FL
      SAVE FK,FL,IK,IL,K,KK,L,LL
      IF (TSS(NS).NE.'UFXX') CALL UYPRO1('UFXX',-1)
      GO TO (1,2,4,10,12,17,19,21,23) ISP(NS)
    1 CONTINUE
      IF (KD.LE.LD) GO TO 25
      IF (LD.GE.0) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      IF (IEXT.LE.0) THEN
      F= FF
      ELSE
      F=-FF
      ENDIF
      CMAX=ZERO
    3 IF (KD.LT.1) GO TO 5
      IF (LD.GE.1) GO TO 5
      CALL UYSET0(2,3)
      RETURN
    4 CONTINUE
      IF (IEXT.LE.0) THEN
      CALL UXVCOP(NF,GF,G)
      ELSE
      CALL UXVNEG(NF,GF,G)
      ENDIF
    5 IF (KD.GE.0.AND.LD.LT.0) FF=F
C      IF (KD.GE.1.AND.LD.LT.1) CALL UXVCOP(NF,G,GF)
      IF (KBF.LE.0) GO TO 8
      IF (LD.LT.0) THEN
      DO 6 I=1,NX
      IF (IXE(I).NE.0) GO TO 6
      KK=ABS(IX(I))
      IF (KK.EQ.1.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      IF (NIT.LE.LIT) THEN
      XSL(I)=MAX(EPS7,X(I)-XL(I))
      XZL(I)=EPS8
      ENDIF
      TEMP=XL(I)-X(I)
      F=F+XZL(I)*(TEMP+XSL(I))
      CMAX=MAX(CMAX,TEMP)
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      IF (NIT.LE.LIT) THEN
      XSU(I)=MAX(EPS7,XU(I)-X(I))
      XZU(I)=EPS8
      ENDIF
      TEMP=X(I)-XU(I)
      F=F+XZU(I)*(TEMP+XSU(I))
      CMAX=MAX(CMAX,TEMP)
      ENDIF
    6 CONTINUE
      ENDIF
      IF (KD.GE.1.AND.LD.LT.1) THEN
      DO 7 I=1,NX
      IF (IXE(I).NE.0) GO TO 7
      KK=ABS(IX(I))
      IF (KK.EQ.1.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      G(I)=G(I)-XZL(I)
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      G(I)=G(I)+XZU(I)
      ENDIF
    7 CONTINUE
      ENDIF
    8 IF (KBC.LE.0) GO TO 15
      KC=1
    9 IF (KC.GT.NC) GO TO 15
      IF (ICE(KC).NE.0) GO TO 14
      KK=ABS(IC(KC))
      IF (KK.EQ.0) GO TO 14
      IF (LD.GE.0) GO TO 11
      CALL UYSET0(3,4)
      RETURN
   10 CONTINUE
      IF (KK.EQ.1.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      IF (NIT.LE.LIT) THEN
      CSL(KC)=MAX(EPS7,FC-CL(KC))
      CZL(KC)=EPS8
      ENDIF
      TEMP=CL(KC)-FC
      F=F+CZL(KC)*(TEMP+CSL(KC))
      CMAX=MAX(CMAX,TEMP)
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      IF (NIT.LE.LIT) THEN
      CSU(KC)=MAX(EPS7,CU(KC)-FC)
      CZU(KC)=EPS8
      ENDIF
      TEMP=FC-CU(KC)
      F=F+CZU(KC)*(TEMP+CSU(KC))
      CMAX=MAX(CMAX,TEMP)
      ENDIF
      IF (KK.EQ.5) THEN
      IF (NIT.LE.LIT) THEN
      CZL(KC)=ZERO
      ENDIF
      F=F+CZL(KC)*FC
      CMAX=MAX(CMAX,ABS(FC))
      ENDIF
   11 IF (KD.LT.1) GO TO 14
      IF (LD.GE.1) GO TO 14
      CALL UYSET0(4,5)
      RETURN
   12 CONTINUE
      IF (KK.EQ.3.OR.KK.EQ.4) THEN
      TEMP= CZU(KC)-CZL(KC)
      ELSE IF (KK.EQ.1) THEN
      TEMP=-CZL(KC)
      ELSE IF (KK.EQ.2) THEN
      TEMP= CZU(KC)
      ELSE IF (KK.EQ.5) THEN
      TEMP= CZL(KC)
      ENDIF
      K=ICG(KC)
      L=ICG(KC+1)-K
      DO 13 J=1,L
      JP=ABS(JCG(K))
      G(JP)=G(JP)+TEMP*GC(JP)
      K=K+1
   13 CONTINUE
   14 KC=KC+1
      GO TO 9
   15 CONTINUE
      IF (LD.GE.1) GO TO 25
      I=1
   16 IF (I.GT.NCC) GO TO 25
      IK=ICC(I)
      IF (IK.LT.0) THEN
      K=-IK
      KK=ABS(IX(K))
      IF (KK.EQ.1) THEN
      FK=XL(K)-X(K)
      IF (LD.LT.0) THEN
      IF (NIT.LE.LIT) THEN
      XSL(K)=MAX(EPS7,X(K)-XL(K))
      XZL(K)=EPS8
      ENDIF
      F=F+XZL(K)*(FK+XSL(K))
      CMAX=MAX(CMAX,FK)
      ENDIF
      ELSE
      FK=X(K)-XU(K)
      IF (LD.LT.0) THEN
      IF (NIT.LE.LIT) THEN
      XSU(K)=MAX(EPS7,XU(K)-X(K))
      XZU(K)=EPS8
      ENDIF
      F=F+XZU(K)*(FK+XSU(K))
      CMAX=MAX(CMAX,FK)
      ENDIF
      ENDIF
      GO TO 18
      ENDIF
      K=IK
      KC=K
      CALL UYSET0(3,6)
      RETURN
   17 CONTINUE
      KK=ABS(IC(K))
      IF (KK.EQ.1) THEN
      FK=CL(K)-FC
      IF (LD.LT.0) THEN
      IF (NIT.LE.LIT) THEN
      CSL(K)=MAX(EPS7,FC-CL(K))
      CZL(K)=EPS8
      ENDIF
      F=F+CZL(K)*(FK+CSL(K))
      CMAX=MAX(CMAX,FK)
      ENDIF
      ELSE
      FK=FC-CU(K)
      IF (LD.LT.0) THEN
      IF (NIT.LE.LIT) THEN
      CSU(K)=MAX(EPS7,CU(K)-FC)
      CZU(K)=EPS8
      ENDIF
      F=F+CZU(K)*(FK+CSU(K))
      CMAX=MAX(CMAX,FK)
      ENDIF
      ENDIF
   18 CONTINUE
      IL=ICC(NCC+I)
      IF (IL.LT.0) THEN
      L=-IL
      LL=ABS(IX(L))
      IF (LL.EQ.1) THEN
      FL=XL(L)-X(L)
      IF (LD.LT.0) THEN
      IF (NIT.LE.LIT) THEN
      XSL(L)=MAX(EPS7,X(L)-XL(L))
      XZL(L)=EPS8
      ENDIF
      F=F+XZL(L)*(FL+XSL(L))
      CMAX=MAX(CMAX,FL)
      ENDIF
      ELSE
      FL=X(L)-XU(L)
      IF (LD.LT.0) THEN
      IF (NIT.LE.LIT) THEN
      XSU(L)=MAX(EPS7,XU(L)-X(L))
      XZU(L)=EPS8
      ENDIF
      F=F+XZU(L)*(FL+XSU(L))
      CMAX=MAX(CMAX,FL)
      ENDIF
      ENDIF
      GO TO 20
      ENDIF
      L=IL
      KC=L
      CALL UYSET0(3,7)
      RETURN
   19 CONTINUE
      LL=ABS(IC(L))
      IF (LL.EQ.1) THEN
      FL=CL(L)-FC
      IF (LD.LT.0) THEN
      IF (NIT.LE.LIT) THEN
      CSL(L)=MAX(EPS7,FC-CL(L))
      CZL(L)=EPS8
      ENDIF
      F=F+CZL(L)*(FL+CSL(L))
      CMAX=MAX(CMAX,FL)
      ENDIF
      ELSE
      FL=FC-CU(L)
      IF (LD.LT.0) THEN
      IF (NIT.LE.LIT) THEN
      CSU(L)=MAX(EPS7,CU(L)-FC)
      CZU(L)=EPS8
      ENDIF
      F=F+CZU(L)*(FL+CSU(L))
      CMAX=MAX(CMAX,FL)
      ENDIF
      ENDIF
   20 CONTINUE
      IF (LD.LT.0) THEN
      IF (IPEN.EQ.1) THEN
      F=F+RPF4*ABS(FK*FL)
      ELSE
      F=F+RPF4*(FK*FL)**2
      ENDIF
C      F=F+RPF4*FK*FL
      ENDIF
      IF (KD.LT.1) GO TO 24
      IF (IK.LT.0) THEN
      IF (IPEN.EQ.1) THEN
      IF (KK.EQ.1) THEN
      G(K)=G(K)-(XZL(K)+RPF4*SIGN(FL,FK))
      ELSE
      G(K)=G(K)+(XZU(K)+RPF4*SIGN(FL,FK))
      ENDIF
      ELSE
      IF (KK.EQ.1) THEN
      G(K)=G(K)-(XZL(K)+TWO*RPF4*FK*FL**2)
      ELSE
      G(K)=G(K)+(XZU(K)+TWO*RPF4*FK*FL**2)
      ENDIF
      ENDIF
      GO TO 22
      ENDIF
      KC=K
      CALL UYSET0(4,8)
      RETURN
   21 CONTINUE
      IF (IPEN.EQ.1) THEN
      IF (KK.EQ.1) THEN
      TEMP=-(CZL(K)+RPF4*SIGN(FL,FK))
      ELSE
      TEMP= (CZU(K)+RPF4*SIGN(FL,FK))
      ENDIF
      ELSE
      IF (KK.EQ.1) THEN
      TEMP=-(CZL(K)+TWO*RPF4*FK*FL**2)
      ELSE
      TEMP= (CZU(K)+TWO*RPF4*FK*FL**2)
      ENDIF
      ENDIF
      KC=ICG(K)
      CALL UXWDIW(ICG(K+1)-KC,NF,JCG(KC),TEMP,GC,G,G,1)
   22 CONTINUE
      IF (IL.LT.0) THEN
      IF (IPEN.EQ.1) THEN
      IF (LL.EQ.1) THEN
      G(L)=G(L)-(XZL(L)+RPF4*SIGN(FK,FL))
      ELSE
      G(L)=G(L)+(XZU(L)+RPF4*SIGN(FK,FL))
      ENDIF
      ELSE
      IF (LL.EQ.1) THEN
      G(L)=G(L)-(XZL(L)+TWO*RPF4*FL*FK**2)
      ELSE
      G(L)=G(L)+(XZU(L)+TWO*RPF4*FL*FK**2)
      ENDIF
      ENDIF
      GO TO 24
      ENDIF
      KC=L
      CALL UYSET0(4,9)
      RETURN
   23 CONTINUE
      IF (IPEN.EQ.1) THEN
      IF (LL.EQ.1) THEN
      TEMP=-(CZL(L)+RPF4*SIGN(FK,FL))
      ELSE
      TEMP= (CZU(L)+RPF4*SIGN(FK,FL))
      ENDIF
      ELSE
      IF (LL.EQ.1) THEN
      TEMP=-(CZL(L)+TWO*RPF4*FL*FK**2)
      ELSE
      TEMP= (CZU(L)+TWO*RPF4*FL*FK**2)
      ENDIF
      ENDIF
      KC=ICG(L)
      CALL UXWDIW(ICG(L+1)-KC,NF,JCG(KC),TEMP,GC,G,G,1)
   24 I=I+1
      GO TO 16
   25 CONTINUE
      CALL UYEPI1(-1)
      RETURN
      END
