* SUBROUTINE UQSIFD                ALL SYSTEMS                98/12/01
* PORTABILITY : ALL SYSTEMS
* 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GIVE VALUE OF A MACRO VARIABLE
*
* PARAMETERS :
*  TI  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*               IN THE SYMBOL TABLE
*  II  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  IO  IER - ERROR INDICATOR
*
* COMMON DATA:
*  II  LP - LAST POINTER TO THE SYMBOL TABLE
*  II  LENOPT(NOPT) - LENGTHS OF OPTION PARAMETER NAMES
*  TI  OPTNM(*) - NAMES OF OPTION PARAMETERS
*  II  NOPT - NUMBER OF OPTIONS
*  II  LENST - ACTUAL LENGTH OF THE BUFFER
*  TI  WTRUE - STRING '.TRUE.'
*  TI  WFALSE - STRING '.FALSE.'
*  TU  CHDIR - THE DIRECTIVE CHARACTER
*  TU  CHEOL - THE END OF LINE MARKER
*  TU  CHCON - THE CONTINUATION MARKER
*  TU  CHDS - THE DATA SEPARATOR MARKER
*  TU  FN1 - FILENAME PART 1 (E.G. LIBRARY)
*  TU  FN2 - FILENAME PART 2 (E.G. EXTENSION)
*  IU  DIALOG - TYPE OF DIALOGUE (0-NO DIALOGUE, 1-SHORT DIALOGUE,
*               2-FULL DIALOGUE)
*  IU  MODERW - READ/WRITE MODE (1-READ/WRITE, 2-READ/APPEND,
*               3-READ ONLY)
*  IU  ILNLEN - THE NUMBER OF CHARACTERS PER LINE OF INPUT
*  IU  OLNLEN - THE NUMBER OF CHARACTERS PER LINE OF OUTPUT
*  IU  OUNIT - THE OUTPUT UNIT NUMBER
*  IU  IUNIT - THE INPUT UNIT NUMBER
*  IU  INUNIT - THE INCLUDE UNIT NUMBER
*  IU  IIUNIT - THE INPUT INTERACTIVE UNIT NUMBER
*  IU  OIUNIT - THE OUTPUT INTERACTIVE UNIT NUMBER
*  IU  LABEL1 - STARTING VALUE OF LABEL
*  IU  LABEL2 - STEP OF LABEL AFTER SUBST('FILENAME')
*  LU  LSUBS - PERFORM SUBSTITUTIONS ?
*  LU  LFORTO - IS IT A FORTRAN ?
*  LU  LOUT - OUTPUT FILE ?
*  LU  LSMLET - LOWER CASE LETTERS ALLOWED ?
*  LU  LFRFMT - IS IT A FORTRAN IN FREE FORMAT ?
*
* SUBPROGRAMS USED :
*  S   UQCUTE  SIF FILES DECODER.
*
      SUBROUTINE UQSIFD(SYMTAB,MLENST,IPOINT,MNP,IER)
      INTEGER MLENST,MNP,IPOINT(MNP,6),IER
      CHARACTER*1 SYMTAB(MLENST)
C ----------------------------------------------------------------------
      INTEGER        LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT(30),NSUB,MNSUB,
     *        NDIR,LENDIR(30),NMSG,MNIF,NIF1,NIF2,TABCH(0:255),ADF,
     *        ADA,ADC,ARD,CRD
      COMMON/UQINT2/ LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT,NSUB,MNSUB,
     *        NDIR,LENDIR,NMSG,MNIF,NIF1,NIF2,TABCH,ADF,ADA,ADC,ARD,CRD
      INTEGER*4      LABEL1,LABEL2,MAXLAB,LEVLAB(20)
      COMMON/UQINT4/ LABEL1,LABEL2,MAXLAB,LEVLAB
      CHARACTER*1    CHCON,CHEOL,CHDS,CHDIR,WTRUE(6),WFALSE(7),
     *        ASCII(32:127),OPTNM(200),DIRNM(200)
      COMMON/UQCHR1/ CHCON,CHEOL,CHDS,CHDIR,WTRUE,WFALSE,
     *        ASCII,OPTNM,DIRNM
      CHARACTER*50   FN1,FN2,FNAMES(20),NAME,MSG(50)*70
      COMMON/UQCHRX/ FN1,FN2,FNAMES,NAME,MSG
      LOGICAL        LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON(20),
     *        LELSE(20),CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
      COMMON/UQLOGL/ LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON,
     *        LELSE,CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
C ----------------------------------------------------------------------
      INTEGER IP,JP
      CHARACTER*10 SIFNAME
      SIFNAME='          '
      IP=LP
    1 IF(IPOINT(IP,3).EQ.3) THEN
        IF(SYMTAB(IPOINT(IP,2)  ).NE.'S') GOTO 3
        IF(SYMTAB(IPOINT(IP,2)+1).NE.'I') GOTO 3
        IF(SYMTAB(IPOINT(IP,2)+2).NE.'F') GOTO 3
        JP=1
        DO 2 IP=IPOINT(IP,2)+IPOINT(IP,3),IPOINT(IP,4)
        SIFNAME(JP:JP)=SYMTAB(IP)
        JP=JP+1
    2   CONTINUE
        CALL UQCUTE(SIFNAME)
        RETURN
      ENDIF
    3 IP=IPOINT(IP,1)
      IF(IP.GT.0) GOTO 1
C
C ERROR: VARIABLE NOT DEFINED
C
   31 IER=9
      NAME='                                                  '
      NAME(1:3)='SIF'
      RETURN
      END
