* SUBROUTINE UXSGS6                 ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 DA : ORIGINAL VERSION
*
* PURPOSE :
* AUXILIARY SUBROUTINE FOR UXSGDS FROM UMFPACK.
*
      SUBROUTINE UXSGS6(ACOLI,ACOLX,PERMR,PERMC,ALEFTR,
     & AN,ANZ,ANZDIA)
      INTEGER AN,ANZ,ANZDIA,PERMR(AN),PERMC(AN),
     & ALEFTR(AN),ACOLI(ANZ),I,ROW,P,SHIFT
      $FLOAT ACOLX(ANZ)
C
C     STORE THE VALUES OF THE MATRIX INTO COLUMN FORM
C
      DO 10 I = 1, AN
      PERMR (I) = I
      PERMC (I) = I
      ALEFTR (I) = 0
10    CONTINUE
      IF (ANZ .NE. ANZDIA) THEN
C
C     COMPRESS ACOLI/X TO TAIL OF THE 2 ARRAYS
C
      SHIFT = ANZ-ANZDIA
      DO 20 P = ANZDIA, 1, -1
      ROW = ACOLI (P)
      ALEFTR (ROW) = ALEFTR (ROW) + 1
      ACOLI (P+SHIFT) = ROW
      ACOLX (P+SHIFT) = ACOLX (P)
20    CONTINUE
      ELSE
C
C     SIMPLY COUNT THE NUMBER OF NZ IN EACH ROW
C
      DO 30 P = 1, ANZDIA
      ROW = ACOLI (P)
      ALEFTR (ROW) = ALEFTR (ROW) + 1
30    CONTINUE
      ENDIF
      RETURN
      END
