* SUBROUTINE  UXSRBG               ALL SYSTEMS               92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE : GENERATION OF ELIMINATION TREE.
*
*  PARAMETERS :
*  II  NN  NUMBER OF BLOCK COLUMNS OF A.
*  II  IR(NN)
*  II  JR(NN**2/2)
*  IO  PARENT(NN) ELIMINATION TREE.
*
      SUBROUTINE UXSRBG(NN,IR,JR,PARENT)
      INTEGER NN,I,K,L,IR(NN),JR(NN*2/2),PARENT(NN),IER,J1
      K = IR(1)
      L = IR(2)
      DO 100 I=1, NN-1
        PARENT(I)=NN+1
        IF (L-K.NE.0) THEN
C
C ROWS NEED NOT TO BE ORDERED
C
          DO 200 J1=K,L-1
            PARENT(I)=MIN(PARENT(I),JR(J1))
  200     CONTINUE
        ELSE
          IER=110
          RETURN
        END IF
        K = L
        L = IR(I+2)
  100 CONTINUE
      PARENT(NN) = 0
      RETURN
      END
