* SUBROUTINE UXUDIS                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR AUGMENTED BY THE SCALED VECTOR IN A BOUND CONSTRAINED CASE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  A  SCALING FACTOR.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RO  Z(N)  OUTPUT VECTOR WHERE Z:= Y + A*X.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LE.-1. IF JOB.LT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).EQ.-5.
*
      SUBROUTINE UXUDIS(N,A,X,Y,Z,IX,JOB)
      INTEGER N,IX(N),JOB
      $FLOAT  A, X(N), Y(N), Z(N)
      $FLOAT  TEMP
      INTEGER I
      IF (JOB.EQ.0) THEN
      DO 1 I=1,N
      TEMP=Y(I)
      Z(I) = TEMP + A*X(I)
      X(I) = TEMP
    1 CONTINUE
      ELSE IF (JOB.GT.0) THEN
      DO 2 I=1,N
      IF (IX(I).GE. 0) THEN
      TEMP=Y(I)
      Z(I) = TEMP + A*X(I)
      X(I) = TEMP
      ENDIF
    2 CONTINUE
      ELSE
      DO 3 I=1,N
      IF (IX(I).NE.-5) THEN
      TEMP=Y(I)
      Z(I) = TEMP + A*X(I)
      X(I) = TEMP
      ENDIF
    3 CONTINUE
      ENDIF
      RETURN
      END
