* SUBROUTINE UXUSUM                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SUM OF TWO VECTORS IN A BOUND CONSTRAINED CASE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RO  Z(N)  OUTPUT VECTOR WHERE Z:= X - Y.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LE.-1. IF JOB.LT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).EQ.-5.
*
      SUBROUTINE UXUSUM(N,X,Y,Z,IX,JOB)
      INTEGER N,IX(N),JOB
      $FLOAT X(N),Y(N),Z(N)
      INTEGER I
      IF (JOB.EQ.0) THEN
      DO 1 I=1,N
      Z(I)=X(I)+Y(I)
    1 CONTINUE
      ELSE IF (JOB.GT.0) THEN
      DO 2 I=1,N
      IF (IX(I).GE. 0) Z(I)=X(I)+Y(I)
    2 CONTINUE
      ELSE
      DO 3 I=1,N
      IF (IX(I).NE.-5) Z(I)=X(I)+Y(I)
    3 CONTINUE
      ENDIF
      RETURN
      END
