* SUBROUTINE UXUZER                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR DIFFERENCE IN A BOUND CONSTRAINED CASE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  A  INITIAL VALUE.
*  RO  X(N)  OUTPUT VECTOR SUCH THAT X(I)=A FOR ALL I.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LE.-1. IF JOB.LT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).EQ.-5.
*
      SUBROUTINE UXUZER(N,X,IX,JOB)
      INTEGER N,IX(N),JOB
      $FLOAT X(N)
      INTEGER I
      IF (JOB.EQ.0) RETURN
      DO 1 I=1,N
      IF (IX(I).LT.0) X(I)=0.0$P 0
    1 CONTINUE
      RETURN
      END
