* FUNCTION UXVDOG                  ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DOT PRODUCT OF TWO VECTORS.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  II  K  INCREMENT. 
*  RR  UXVDOG  VALUE OF DOT PRODUCT UXVDOT=TRANS(X)*Y.
*
      FUNCTION UXVDOG(N,X,Y,K)
      INTEGER N,K
      $FLOAT  X(N), Y(N), UXVDOG
      DOUBLE PRECISION TEMP
      INTEGER I,J
      TEMP = 0.0$P 0
      IF (K.EQ.1) THEN
      DO 1 I=1,N
      TEMP = TEMP + X(I)*Y(I)
    1 CONTINUE
      ELSE IF (K.GT.0) THEN
      I=1
      DO 2 J=1,N
      TEMP = TEMP + X(I)*Y(I)
      I=I+K
    2 CONTINUE
      ELSE IF (K.LT.0) THEN
      I=1
      DO 3 J=1,N
      TEMP = TEMP + X(I)*Y(J)
      I=I-K
    3 CONTINUE
      ENDIF
      UXVDOG = TEMP
      RETURN
      END
