* FUNCTION UXVDOT                  ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DOT PRODUCT OF TWO VECTORS.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RR  UXVDOT  VALUE OF DOT PRODUCT UXVDOT=TRANS(X)*Y.
*
      FUNCTION UXVDOT(N,X,Y)
      INTEGER N
      $FLOAT  X(N), Y(N), UXVDOT
      DOUBLE PRECISION TEMP
      INTEGER I
      TEMP = 0.0D0
      DO 1 I=1,N
      TEMP = TEMP + X(I)*Y(I)
    1 CONTINUE
      UXVDOT = TEMP
      RETURN
      END
