* SUBROUTINE UXVLAN                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* THREE-TERM LANCZOS RECURRENCES.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  A  SCALING FACTOR.
*  RU  X(N)  INPUT VECTOR.
*  RI  B  SCALING FACTOR.
*  RU  Y(N)  OUTPUT VECTOR WHERE Y:= Z - A*X - B*Y.
*  RI  Z(N)  INPUT VECTOR.
*
      SUBROUTINE UXVLAN(N,A,X,B,Y,Z)
      INTEGER N
      $FLOAT A,X(N),B,Y(N),Z(N)
      INTEGER I
      $FLOAT TEMP
      DO 1 I=1,N
      TEMP=X(I)
      X(I)=Y(I)
      Y(I)=Z(I)-A*TEMP-B*Y(I)
    1 CONTINUE
      RETURN
      END
