* SUBROUTINE UXVRCP               ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* REDUCTION OF A VECTOR WITH RESPECTION TO ACTIVE BOX CONSTRAINTS.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  IU  IX(N)  TYPES OF BOX CONSTRAINTS.
*  II  X  INPUT VECTOR.
*  II  Y  REDUCED VECTOR.
*
      SUBROUTINE UXVRCP(NF,N,IX,X,Y)
      INTEGER NF,N,IX(NF),I,K
      $FLOAT X(NF),Y(N)
      K=0
      DO 1 I=1,NF
      IF (IX(I).GE.0) THEN
      K=K+1
      Y(K)=X(I)
      ENDIF
    1 CONTINUE
      RETURN
      END
