* SUBROUTINE UXVROT               ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PLANE ROTATION IS APPLIED TO TWO VALUES.
*
* PARAMETERS :
*  RU  XK  FIRST VALUE FOR PLANE ROTATION.
*  RU  XL  SECOND VALUE FOR PLANE ROTATION.
*  RI  CK  DIAGONAL ELEMENT OF THE ELEMENTARY ORTHOGONAL MATRIX.
*  RI  CL  OFF-DIAGONAL ELEMENT OF THE ELEMENTARY ORTHOGONAL MATRIX.
*  II  IER  INFORMATION ON THE TRANSFORMATION. IER=0-GENERAL PLANE
*         ROTATION. IER=1-PERMUTATION. IER=2-TRANSFORMATION SUPPRESSED.
*
      SUBROUTINE UXVROT(XK,XL,CK,CL,IER)
      INTEGER IER
      $FLOAT XK,XL,CK,CL
      $FLOAT POM
      IF (IER.EQ.0) THEN
      POM=XK
      XK=CK*POM+CL*XL
      XL=CL*POM-CK*XL
      ELSE IF (IER.EQ.1) THEN
      POM=XK
      XK=XL
      XL=POM
      ENDIF
      RETURN
      END
