* SUBROUTINE UXVSR8                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* SHELLSORT.
*
* PARAMETERS :
*  II  K  NUMBER OF REAL VALUES OF THE SORTED ARRAY.
*  RU  ARRAY(K)  REAL SORTED ARRAY.
*  IO  ARRAYB(K)  INTEGER ARRAY WHICH IS PERMUTED IN THE SAME WAY
*         AS THE REAL SORTED ARRAY.
*
      SUBROUTINE UXVSR8(K,ARRAY,ARRAYB)
      INTEGER K
      $FLOAT ARRAY(K),ARRAYB(K)
      INTEGER IS,LT,LS,LLS,I,J,JS,KHALF
      $FLOAT LA,LB
C
C NOTHING TO BE SORTED
C
      IF(K.LE.1) GO TO 400
C
C SHELLSORT
C
      LS=131071
      KHALF=K/2
      DO 300 LT=1,17
        IF(LS.GT.KHALF) THEN
          LS=LS/2
          GO TO 300
        END IF
        LLS=K-LS
        DO 200 I=1,LLS
          IS=I+LS
          LA=ARRAY(IS)
          LB=ARRAYB(IS)
          J=I
          JS=IS
 100      IF(ABS(LA).GE.ABS(ARRAY(J))) THEN
            ARRAY(JS)=LA
            ARRAYB(JS)=LB
            GO TO 200
          ELSE
            ARRAY(JS)=ARRAY(J)
            ARRAYB(JS)=ARRAYB(J)
            JS=J
            J=J-LS
          END IF
          IF(J.GE.1) GO TO 100
          ARRAY(JS)=LA
          ARRAYB(JS)=LB
 200    CONTINUE
        LS=LS/2
 300  CONTINUE
 400  CONTINUE
      RETURN
      END
