* SUBROUTINE UXVSRT                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* SHELLSORT
*
* PARAMETERS :
*  II  K LENGTH OF SORTED VECTOR.
*  IU  ARRAY(K) SORTED ARRAY.
*
      SUBROUTINE UXVSRT(K,ARRAY)
      INTEGER K
      INTEGER ARRAY(K)
      INTEGER IS,LA,LT,LS,LLS,I,J,JS,KHALF
C
C NOTHING TO BE SORTED
C
      IF(K.LE.1) GO TO 400
C
C SHELLSORT
C
      LS=131071
      KHALF=K/2
      DO 300 LT=1,17
        IF(LS.GT.KHALF) THEN
          LS=LS/2
          GO TO 300
        END IF
        LLS=K-LS
        DO 200 I=1,LLS
          IS=I+LS
          LA=ARRAY(IS)
          J=I
          JS=IS
 100      IF(LA.GE.ARRAY(J)) THEN
            ARRAY(JS)=LA
            GO TO 200
          ELSE
            ARRAY(JS)=ARRAY(J)
            JS=J
            J=J-LS
          END IF
          IF(J.GE.1) GO TO 100
          ARRAY(JS)=LA
 200    CONTINUE
        LS=LS/2
 300  CONTINUE
 400  CONTINUE
      RETURN
      END
