* FUNCTION UYGMLN                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  GAMA FUNCTION.
*  RETURNS THE VALUE OF LN(GAMA(XX)) FOR XX>0. FULL ACCURACY IS
*  OBTAINED FOR XX>1.
*
* PARAMETERS :
*  RI  XX  PARAMETER OF GAMA FUNCTION
*
      FUNCTION UYGMLN(XX)
      $FLOAT UYGMLN,XX
      INTEGER J
      REAL*8 COF(6),STP,HALF,ONE,FPF,X,TMP,SER
      DATA COF,STP/76.18009173D0,-86.50532033D0,24.01409822D0,
     *    -1.231739516D0,.120858003D-2,-.536382D-5,2.50662827465D0/
      DATA HALF,ONE,FPF/0.5D0,1.0D0,5.5D0/
      X=XX-ONE
      TMP=X+FPF
      TMP=(X+HALF)*LOG(TMP)-TMP
      SER=ONE
      DO 10 J=1,6
        X=X+ONE
        SER=SER+COF(J)/X
   10 CONTINUE
      UYGMLN=TMP+LOG(STP*SER)
      END
