* FUNCTION UYGSSZ                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 SI : ORIGINAL VERSION
*
* PURPOSE:
*  CALCULATION OT THE MINIMUM RANDOM SAMPLE SIZE NEEDED TO FULLFILL
*  BAYESIAN STOPPING RULE
*
* PARAMETERS:
*  II  NLMIN  NUMBER OF DIFFERENT LOCAL MINIMA FOUND
*  RI  GAMA  REDUCTION OF THE SAMPLE (0.1 .. 0.2)
*
      INTEGER FUNCTION UYGSSZ(NLMIN,GAMA)
      INTEGER NLMIN
      $FLOAT GAMA,TEMP
      TEMP = (1.0/GAMA)*(2.0*NLMIN**2+3.0*NLMIN+2.0)
      UYGSSZ = TEMP
      END

