$INTERFACE UYINV1                                             98/12/01

  CALL UYINV1(NF,$IX)
  $ADD(INTEGER,'\$IX($NX)')
$REM  $ADD(INTEGER,'\NF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYINV1             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF THE INPUT VECTOR.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  IO  IX(NA)  VECTOR CONTAINING TYPES OF BOUNDS.
*
* COMMON DATA :
*  II  KBF  INDICATION OF SIMPLE BOUNDS.
*  II  LCS  INDICATION OF LOCALLY CONSTRAINED STEP COMPUTATION
*         USING QUADRATIC PROGRAMMING METHODS.
*
      SUBROUTINE UYINV1(NF,IX)
      $INCLUDE ('UMCOMM')
      INTEGER NF,IX(NF)
      INTEGER K
      IF (KBF.GT.0.OR.LCS.GT.0) THEN
      DO 1 K=1,NF
      IX(K)=0
    1 CONTINUE
      ENDIF
      RETURN
      END
