$INTERFACE UYTRNG                                             98/12/01

  CALL UYTRNG(NF,$XN,$G,$GN)
  $ADD(REAL,'\$XN($NF)\$G($NF)\$GN($NF)')
$REM  $ADD(INTEGER,'\NF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRNG             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENT OF THE MODEL FUNCTION IS SCALED.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RO  GN(NF)  SCALED GRADIENT OF THE OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
      SUBROUTINE UYTRNG(NF,XN,G,GN)
      $INCLUDE ('UMCOMM')
      INTEGER NF
      $FLOAT XN(NF),G(NF),GN(NF)
      INTEGER I
      DO 1 I=1,NF
      IF (NORMF.GT.0) THEN
      GN(I)=G(I)*XN(I)
      ELSE
      GN(I)=G(I)
      ENDIF
    1 CONTINUE
      RETURN
      END
