* SUBROUTINE EABU15             ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  RO  G(N)  GRADIENT OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EABU15(N,KA,X,FA,GA,NEXT)
      INTEGER N,KA,NEXT
      $FLOAT X(N),FA,GA(N)
      CALL EAFU15(N,KA,X,FA,NEXT)
      CALL EAGU15(N,KA,X,GA,NEXT)
      IF (FA.LT.0.0$P 0) THEN
      FA=-FA
      CALL UXVNEG(N,GA,GA)
      ENDIF
      RETURN
      END
