* SUBROUTINE EFFU41                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION - LU VERSION WITH MODIFIED TESTS NO 7-10,12.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFFU41(N,X,F,NEXT)
      INTEGER N,NEXT
      $FLOAT X(N),F
      INTEGER J
      F=0.0$P 0
      GO TO (10,20,30), NEXT
   10 DO 11 J=2,N-2,2
      F=F+X(J-1)**2+X(J)**2+2.0$P 0*X(J+1)**2+X(J+2)**2-5.0$P 0*X(J-1)-
     & 5.0$P 0*X(J)-2.1$P 1*X(J+1)+7.0$P 0*X(J+2)
   11 CONTINUE
      RETURN
   20 CONTINUE
      RETURN
   30 CONTINUE
      RETURN
      END
