* SUBROUTINE EFGU41                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION - LU VERSION WITH MODIFIED TESTS NO 7-10,12.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  G(N)  GRADIENT OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFGU41(N,X,G,NEXT)
      INTEGER N,NEXT
      $FLOAT X(N),G(N)
      INTEGER I,J
      DO 1 I=1,N
      G(I)=0.0$P 0
    1 CONTINUE
      GO TO (10,20,30), NEXT
   10 DO 11 J=2,N-2,2
      G(J-1)=G(J-1)+2.0$P 0*X(J-1)-5.0$P 0
      G(J  )=G(J  )+2.0$P 0*X(J  )-5.0$P 0
      G(J+1)=G(J+1)+4.0$P 0*X(J+1)-2.1$P 1
      G(J+2)=G(J+2)+2.0$P 0*X(J+2)+7.0$P 0
   11 CONTINUE
      RETURN
   20 CONTINUE
      RETURN
   30 CONTINUE
      RETURN
      END

