* SUBROUTINE EINS13                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  INPUT OF HESSIAN MATRIX FOR SPARSE LINEARLY CONSTRAINED
*  OPTIMIZATION. SPARSE VERSION.
*
* PARAMETERS :
*  II  NF ESTIMATED NUMBER OF NUMBER OF VARIABLES.
*  II  M SIZE OF ARRAYS SH,H.
*  RO  HF(M) NUMERICAL VALUES OF THE HESSIAN MATRIX.
*  IO  JH(M) INDEX VECTOR OF THE HESSIAN MATRIX.
*  IO  IH(MCOLS+1) POINTER VECTOR OF SH,H.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EINS13(MCOLS,NF,M,HF,JH,IH,NEXT)
      INTEGER MCOLS,NF,NFL,M,NEXT
      INTEGER JH(*),IH(MCOLS+1)
      INTEGER I,NB
      $FLOAT HF(*)
      $FLOAT ONE,ZERO
      PARAMETER(ONE=1.0$P 0,ZERO=0.0$P 0)
C
      NFL=NF
      GO TO (10,20,30,40,50,60) NEXT
   10 DO 11 I=1,NFL/3
        HF(I)=ONE
        JH(I)=I
        IH(I)=I
   11 CONTINUE
      DO 12 I=NFL/3+1,2*(NFL/3)
        HF(I)=-ONE
        JH(I)=I
        IH(I)=I
   12 CONTINUE
      DO 13 I=2*(NFL/3)+1,NFL
        IH(I)=I
        JH(I)=I
        HF(I)=ZERO
   13 CONTINUE
      NB=NFL
      IH(NFL+1)=NFL+1
      RETURN
   20 CONTINUE
      IH(1)=1
      IH(2)=3
      IH(3)=4
      JH(1)=1
      JH(2)=2
      JH(3)=2
      RETURN
   30 DO 31 I=1,NFL/3
        HF(I)=ONE
        JH(I)=I
        IH(I)=I
   31 CONTINUE
      DO 32 I=NFL/3+1,2*(NFL/3)
        HF(I)=-ONE
        JH(I)=I
        IH(I)=I
   32 CONTINUE
      DO 33 I=2*(NFL/3)+1,NFL
        IH(I)=I
        JH(I)=I
        HF(I)=ZERO
   33 CONTINUE
      NB=NFL
      IH(NFL+1)=NFL+1
      RETURN
   40 DO 41 I=1,NFL/3
        HF(I)=ONE
        JH(I)=I
        IH(I)=I
   41 CONTINUE
      DO 42 I=NFL/3+1,2*(NFL/3)
        HF(I)=-ONE
        JH(I)=I
        IH(I)=I
   42 CONTINUE
      DO 43 I=2*(NFL/3)+1,NFL
        IH(I)=I
        JH(I)=I
        HF(I)=ZERO
   43 CONTINUE
      NB=NFL
      IH(NFL+1)=NFL+1
      RETURN
   50 DO 51 I=1,NFL/3
        HF(I)=ONE
        JH(I)=I
        IH(I)=I
   51 CONTINUE
      DO 52 I=NFL/3+1,2*(NFL/3)
        HF(I)=-ONE
        JH(I)=I
        IH(I)=I
   52 CONTINUE
      DO 53 I=2*(NFL/3)+1,NFL
        IH(I)=I
        JH(I)=I
        HF(I)=ZERO
   53 CONTINUE
      NB=NFL
      IH(NFL+1)=NFL+1
      RETURN
   60 CONTINUE
      HF(1)=1
      HF(2)=ZERO
      HF(3)=ZERO
      HF(4)=1
      HF(5)=ZERO
      HF(6)=1
      JH(1)=1
      JH(2)=2
      JH(3)=3
      JH(4)=2
      JH(5)=3
      JH(6)=3
      IH(1)=1
      IH(2)=4
      IH(3)=6
      IH(4)=7
      RETURN
      END
