* SUBROUTINE EIUD24                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR UNCONSTRAINED MINIMIZATION.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD24(N,NA,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NA,NEXT,IEXT,IERR
      $FLOAT X(N),FMIN,XMAX
      INTEGER NAL
      INTEGER IP02(8),IP16(9),IP17(3),IP18(38)
      DATA IP02 /20,21,22,23,25,27,29,30/
      DATA IP16 /1,2,5,9,20,21,23,24,28/
      DATA IP17 /16,19,20/
      DATA IP18 /2,3,4,5,6,8,9,11,14,16,17,18,19,20,21,22,23,24,25,26,
     & 27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44/
      IF (NEXT.LE.22) THEN
      CALL EIUD15(N,NA,X,FMIN,XMAX,NEXT,IEXT,IERR)
      ELSE IF (NEXT.LE.60) THEN
      CALL EIUD18(N,NA,X,FMIN,XMAX,IP18(NEXT-22),IEXT,IERR)
      ELSE IF (NEXT.LE.68) THEN 
      CALL EIUD02(N,NA,NAL,X,FMIN,XMAX,IP02(NEXT-60),IEXT,IERR)
      ELSE IF (NEXT.LE.77) THEN
      CALL EIUD16(N,NA,NAL,X,FMIN,XMAX,IP16(NEXT-68),IEXT,IERR)
      ELSE IF (NEXT.LE.80) THEN
      CALL EIUD17(N,NA,NAL,X,FMIN,XMAX,IP17(NEXT-77),IEXT,IERR)
      ELSE
      IERR=1
      ENDIF
      RETURN
      END
