* SUBROUTINE EAGU27             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GA(N)  GRADIENT OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU27(N,KA,X,GA,NEXT)
      INTEGER N,KA,NEXT
      REAL*8 X(N),GA(N)
      IF (NEXT.LE.30) THEN
      CALL EAGU02(N,KA,X,GA,NEXT)
      ELSE IF (NEXT.LE.52) THEN
      CALL UXVSET(N,0.0D 0,GA)
      CALL EAGU15(N,KA,X,GA,NEXT-30)
      ELSE IF (NEXT.LE.96) THEN
      CALL UXVSET(N,0.0D 0,GA)
      CALL EAGU18(N,KA,X,GA,NEXT-52)
      ENDIF
      RETURN
      END
