* SUBROUTINE EFFU08             ALL SYSTEMS                 91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FF  VALUE OF THE OBJECTIVE FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFFU08(N,X,FF,NEXT)
      INTEGER N,NEXT
      INTEGER I
      REAL*8 X(N),FF
      REAL*8 X1,X2
      REAL*8 Y(20)
      COMMON /EMPR08/ Y
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,60,150,160,170,
     * 180,190,200,210,30,230,240,250,260,270,280,290,300,310),NEXT
   10 FF=X(1)*X(2)**2
      RETURN
   20 FF=-X(1)+1.0D 1*(X(1)**2+X(2)**2-1.0D 0)
      RETURN
   30 FF=100.0D 0*(X(2)-X(1)**2)**2+(1.0D 0-X(1))**2
      RETURN
   40 FF=(1.0D 0-X(1))**2
      RETURN
   50 FF=LOG(1.0D 0+X(1)**2)-X(2)
      RETURN
   60 FF=-X(1)
      RETURN
   70 FF=(X(1)-X(2))**2+(X(2)-X(3))**4
      RETURN
   80 FF=1.0D-2*(X(1)-1.0D 0)**2+(X(2)-X(1)**2)**2
      RETURN
   90 FF=(X(1)-1.0D 0)**2+(X(1)-X(2))**2+(X(2)-X(3))**4
      RETURN
  100 FF=X(1)-X(2)+X(2)**3
      RETURN
  110 FF=4.0D 0*X(1)**2+2.0D 0*X(2)**2+2.0D 0*X(3)**2-33.0D 0*X(1)+
     * 16.0D 0*X(2)-24.0D 0*X(3)
      RETURN
  120 FF=1.0D 3-X(1)**2-2.0D 0*X(2)**2-X(3)**2-X(1)*X(2)-X(1)*X(3)
      RETURN
  130 FF=1.0D-3*X(1)+X(2)
      RETURN
  150 FF=(X(1)-1.0D 0)**2+(X(2)-2.0D 0)**2+(X(3)-3.0D 0)**2+
     * (X(4)-4.0D 0)**2
      RETURN
  160 FF=(0.0024D 0-((EXP(X(1))-1.0D 0)-X(3))*X(4)/(EXP(X(1))-
     * 1.0D 0+X(4)))/X(1)
      RETURN
  170 FF=X(5)**2
      RETURN
  180 FF=X(1)**2+X(2)**2+X(3)**2
      RETURN
  190 FF=(X(1)-X(2))**2+(X(3)-1.0D 0)**2+(X(4)-1.0D 0)**4+
     * (X(5)-1.0D 0)**6
      RETURN
  200 FF=(X(1)-1.0D 0)**2+(X(1)-X(2))**2+(X(3)-1.0D 0)**2+
     * (X(4)-1.0D 0)**4+(X(5)-1.0D 0)**6
      RETURN
  210 FF=(X(1)-X(2))**4+(X(2)+X(3)-2.0D 0)**2+(X(4)-1.0D 0)**2+
     * (X(5)-1.0D 0)**2
      RETURN
  230 FF=0.01D 0*X(1)**2+X(2)**2
      RETURN
  240 FF=(X(1)-X(2))**2+(X(2)-X(3))**2+(X(3)-X(4))**4+(X(4)-X(5))**4
      RETURN
  250 FF=X(1)*X(2)*X(3)*X(4)*X(5)
      RETURN
  260 FF=(X(1)-1.0D 0)**2+(X(1)-X(2))**2+(X(2)-X(3))**2+
     * (X(3)-X(4))**4+(X(4)-X(5))**4
      RETURN
  270 FF=EXP(X(1)*X(2)*X(3)*X(4)*X(5))
      RETURN
  280 FF=EXP(X(1)*X(2)*X(3)*X(4)*X(5))-0.5D 0*(X(1)**3+X(2)**3+
     * 1.0D 0)**2
      RETURN
  290 IF (X(1).LT.300.0D 0) THEN
      X1=30.0D 0*X(1)
      ELSE
      X1=31.0D 0*X(1)
      ENDIF
      IF (X(2).LT.100.0D 0) THEN
      X2=28.0D 0*X(2)
      ELSE IF (X(2).LT.200.0D 0) THEN
      X2=29.0D 0*X(2)
      ELSE
      X2=30.0D 0*X(2)
      ENDIF
      FF=X1+X2
      RETURN
  300 X1=1250.0D 0*(COS(X(1))+COS(X(2)))+3750.0D 0*(COS(X(3))+
     * COS(X(4))+COS(X(5)))+9000.0D 0*(COS(X(6))+COS(X(7)))
      FF=-X1**2
      RETURN
  310 X1=0.0D 0
      DO 311 I=1,10
      Y(I+10)=EXP(X(I))
      X1=X1+Y(I+10)
  311 CONTINUE
      X1=LOG(X1)
      X2=0.0D 0
      DO 312 I=1,10
      X2=X2+Y(I+10)*(Y(I)+X(I)-X1)
  312 CONTINUE
      FF=X2
      RETURN
      END
