* SUBROUTINE EFFU99                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR COMPLEMENTARITY PROBLEMS.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFFU99(N,X,F,NEXT)
      INTEGER N,NEXT
      REAL*8 X(N),F
      REAL*8 WC,WB,WG,WBB,WGG,WPI
      GOTO (10,20,30,40,50,60,70,80,40,50,60,70,80,40,50,60,70,80,40,50,
     &60,70,80,240,250,250,270,270,290), NEXT
   10 F=X(1)**2-2.0D 0*X(1)+X(2)**2-2.0D 0*X(2)+X(5)**2+X(6)**2
      RETURN
   20 F=(X(1)-X(2)-1.0D 0)**2
      RETURN
   30 F=(X(2)-3.5D 0)**2+(X(3)+4.0D 0)**2
      RETURN
   40 WG=1.0D 0
   41 WC=1.0D 1
      WB=1.2D 0
      WBB=WB/(WB+1.0D 0)
      WGG=1.0D 0/WG
      F=WC*X(1)+WBB/5.0D 0**(1.0D 0/WB)*X(1)**(1.0D 0/WBB)-
     &  X(1)*(5.0D 3/(X(1)+X(2)+X(3)+X(4)+X(5)))**WGG
      RETURN
   50 WG=1.1D 0
      GOTO 41
   60 WG=1.3D 0
      GOTO 41
   70 WG=1.5D 0
      GOTO 41
   80 WG=1.7D 0
      GOTO 41
  240 WPI=3.141592654D 0
      F=-WPI*X(3)**2
      RETURN
  250 WPI=3.141592654D 0
      F=-WPI*X(3)*X(4)
      RETURN
  270 WPI=3.141592654D 0
      F=-WPI*ABS(X(3)*X(6)-X(4)*X(5))
      RETURN
  290 F=(X(1)-X(3))*(X(4)-X(2))
      RETURN
      END
