* SUBROUTINE EISS32                ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  SPARSE VERSION OF LINEAR PROGRAMMING - OBJECTIVE FUNCTION.
*
* PARAMETERS :
*  II  NF ESTIMATED NUMBER OF NUMBER OF VARIABLES.
*  RO  GF(NF)  GRADIENT OF THE LINEAR OBJECTIVE FUNCTION.
*  RO  FF  CONSTANT MEMBER OF THE LINEAR OBJECTIVE FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EISS32(NF,GF,FF,NEXT)
      INTEGER NF,NEXT,I
      REAL*8 GF(NF),FF
      REAL*8 ONE,THREE,SIX,SEVEN,EIGHT,NINE,TEN
      PARAMETER(ONE=1.0D 0,THREE=3.0D 0)
      PARAMETER(SIX=6.0D 0)
      PARAMETER(SEVEN=7.0D 0,EIGHT=8.0D 0,TEN=1.0D 1)
      PARAMETER(NINE=9.0D 0)
      FF=0.0D 0
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,
     *     160,170,180) NEXT
 10   CONTINUE
      DO 11 I=1,NF
        GF(I)=I
 11   CONTINUE
      RETURN
 20   CONTINUE
      DO 21 I=1,NF
        GF(I)=I
 21   CONTINUE
      RETURN
 30   CONTINUE
      DO 31 I=1,NF
        GF(I)=I
 31   CONTINUE
      RETURN
 40   CONTINUE
      DO 41 I=1,NF
        GF(I)=-I
 41   CONTINUE
      RETURN
 50   CONTINUE
      DO 51 I=1,NF
        GF(I)=-I
 51   CONTINUE
      RETURN
 60   CONTINUE
      DO 61 I=1,NF
        GF(I)=I
 61   CONTINUE
      RETURN
 70   CONTINUE
      DO 71 I=1,NF
        GF(I)=I
 71   CONTINUE
      RETURN
 80   CONTINUE
      DO 81 I=1,NF
        GF(I)=I
 81   CONTINUE
      RETURN
 90   CONTINUE
      DO 91 I=1,NF
        GF(I)=I
 91   CONTINUE
      RETURN
 100  CONTINUE
      DO 101 I=1,NF
        GF(I)=I
 101  CONTINUE
      RETURN
 110  CONTINUE
      DO 111 I=1,NF
        GF(I)=I
 111  CONTINUE
      RETURN
 120  CONTINUE
      DO 121 I=1,NF
        GF(I)=I
 121  CONTINUE
      RETURN
 130  CONTINUE
      GF(1)=0
      GF(2)=0
      GF(3)=-ONE
      GF(4)=-ONE
      GF(5)=-ONE
      RETURN
 140  CONTINUE
      GF(1)=SIX
      GF(2)=THREE
      GF(3)=ONE
      GF(4)=SEVEN
      GF(5)=EIGHT
      RETURN
 150  CONTINUE
      GF(1)=THREE
      GF(2)=24D0
      GF(3)=13D0
      GF(4)=NINE
      GF(5)=20D0
      GF(6)=19D0
      RETURN
 160  CONTINUE
      DO 161 I=1,NF
        GF(I)=I
 161  CONTINUE
      RETURN
 170  CONTINUE
      DO 171 I=1,NF
        GF(I)=I
 171  CONTINUE
      RETURN
 180  CONTINUE
      DO 181 I=1,NF
        GF(I)=I
 181  CONTINUE
      RETURN
      END
