* SUBROUTINE UANRF1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALING OF THE SELECTED FUNCTION VALUE.
*
* PARAMETERS :
*  II  NA NUMBER OF UNCTIONS.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  RI  AW(NA)  VECTOR CONTAINING SCALING PARAMETERS.
*  RU  FA  VALUE OF THE SELECTED FUNCTION.
*  II  NORMA  SCALING SPECIFICATION. NORMA=0-NO SCALING IS PERFORMED.
*         NORMA=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMA=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
      SUBROUTINE UANRF1(NA,KA,AW,FA,NORMA)
      INTEGER NA,KA,NORMA
      REAL*8 AW(NA),FA
      IF (NORMA.GT.0) THEN
      FA=FA*AW(KA)
      ENDIF
      RETURN
      END
