* SUBROUTINE UG0F01             ALL SYSTEMS                 91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  COMPUTATION OF THE TUNNELING FUNCTION
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES
*  RU  F  FUNCTION VALUE
*  RI  X(NF)  VECTOR OF VARIABLES
*  RI  FMIN  FUNCTION VALUE IN XMIN
*  RI  XMIN(NF)  VECTOR OF VARIABLES IN MINIMUM
*  II  IALF  TUNNELING PARAMETER
*
      SUBROUTINE UG0F01(NF,F,X,FMIN,XMIN,IALF)
      INTEGER NF,IALF
      REAL*8 F,X(NF),FMIN,XMIN(NF)
      INTEGER I
      REAL*8 SUM
      SUM=0.0D 0
      DO 10 I=1,NF
        SUM=SUM+(X(I)-XMIN(I))**2
   10 CONTINUE
      F=(F-FMIN)/(SUM**IALF)
      END
