* SUBROUTINE UPSET1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NEW PENALTY PARAMETERS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  RI  S(NF+NC)  DIRECTION VECTOR.
*  RI  CZ(NC)  VECTOR OF LAGRANGE MULTIPLIERS.
*  RU  CP(NC)  VECTOR CONTAINING PENALTY PARAMETERS.
*
      SUBROUTINE UPSET1(NF,NC,S,CZ,CP)
      INTEGER NF,NC
      REAL*8 S(NF+NC),CZ(NC),CP(NC)
      REAL*8 TEMP
      INTEGER KC
      DO 1 KC=1,NC
      TEMP=ABS(CZ(KC)+S(NF+KC))
      CP(KC)=MAX(TEMP,0.5D 0*(CP(KC)+TEMP))
    1 CONTINUE
      RETURN
      END
