* SUBROUTINE UPSETB                ALL SYSTEMS                03/12/01
C PORTABILITY : ALL SYSTEMS
C 03/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  LINE SEARCH WITHOUT DIRECTIONAL DERIVATIVES BASED ON A SQP FILTER.
*
* PARAMETERS :
*  IU  KS  NUMBER OF FILTER SAMPLES.
*  II  MS  MAXIMUM NUMBER OF FILTER SAMPLES.
*  RU  FS(MS,4)  ARRAY CONTAINING FILTER SAMPLES.
*  RI  RPF3  BARRIER COEFFICIENT.
*
      SUBROUTINE UPSETB(KS,MS,FS,RPF3)
      INTEGER KS,MS
      REAL*8 FS(MS,4),RPF3
      INTEGER I
      DO 1 I=1,KS
      FS(I,1)=FS(I,3)+RPF3*FS(I,4)
    1 CONTINUE
      RETURN
      END
