* LOGICAL FUNCTION UQLOGM          ALL SYSTEMS                98/12/01
* PORTABILITY : ALL SYSTEMS
* 98/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  IS IT A LOGICAL CONSTANT ?
*
* PARAMETERS :
*  TI  STRARR(MLEN) - A STRING ARRAY
*  II  MLEN - MAX. LENGTH OF STRARR
*  II  IPOS1 - POSITION OF THE FIRST CHARACTER OF A LOG. CONSTANT IN STRARR
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF A LOG. CONSTANT IN STRARR
*
* COMMON DATA:
*  TI  WTRUE - STRING '.TRUE.'
*  TI  WFALSE - STRING '.FALSE.'
*
* SUBPROGRAMS USED :
*  LF  UQSTRC - COMPARISON OF TWO SUBSTRINGS
*
      LOGICAL FUNCTION UQLOGM(STRARR,MLEN,IPOS1,IPOS2)
      INTEGER MLEN,IPOS1,IPOS2
      CHARACTER*1 STRARR(MLEN)
      LOGICAL UQSTRC
C ----------------------------------------------------------------------
      INTEGER        LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT(30),NSUB,MNSUB,
     *        NDIR,LENDIR(30),NMSG,MNIF,NIF1,NIF2,TABCH(0:255),ADF,
     *        ADA,ADC,ARD,CRD
      COMMON/UQINT2/ LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT,NSUB,MNSUB,
     *        NDIR,LENDIR,NMSG,MNIF,NIF1,NIF2,TABCH,ADF,ADA,ADC,ARD,CRD
      INTEGER*4      LABEL1,LABEL2,MAXLAB,LEVLAB(20)
      COMMON/UQINT4/ LABEL1,LABEL2,MAXLAB,LEVLAB
      CHARACTER*1    CHCON,CHEOL,CHDS,CHDIR,WTRUE(6),WFALSE(7),
     *        ASCII(32:127),OPTNM(200),DIRNM(200)
      COMMON/UQCHR1/ CHCON,CHEOL,CHDS,CHDIR,WTRUE,WFALSE,
     *        ASCII,OPTNM,DIRNM
      CHARACTER*50   FN1,FN2,FNAMES(20),NAME,MSG(50)*70
      COMMON/UQCHRX/ FN1,FN2,FNAMES,NAME,MSG
      LOGICAL        LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON(20),
     *        LELSE(20),CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
      COMMON/UQLOGL/ LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON,
     *        LELSE,CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
C ----------------------------------------------------------------------
      IF(UQSTRC(STRARR,MLEN,IPOS1,IPOS2,WTRUE,6,1,6).OR.
     *   UQSTRC(STRARR,MLEN,IPOS1,IPOS2,WFALSE,7,1,7)) THEN
        UQLOGM=.TRUE.
      ELSE
        UQLOGM=.FALSE.
      ENDIF
      RETURN
      END
