* SUBROUTINE UXDCDS               ALL SYSTEMS                17/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALING OF DIAGONAL ELEMENTS OF A COLUMNWISE STORED DENSE RECTANGULAR
* MATRIX.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  M  NUMBER OF COLUMNS OF THE MATRIX A.
*  RO  A(N*M)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE
*          ONE-DIMENSIONAL ARRAY.
*  RI  ALF  SCALING FACTOR.
*
      SUBROUTINE UXDCDS(N,M,A,ALF)
      INTEGER N,M
      REAL*8 A(M*N),ALF
      INTEGER I,K
      K=0
      DO 1 I=1,MIN(N,M)
      A(I+K)=A(I+K)*ALF
      K=K+M
    1 CONTINUE
      RETURN
      END
