* SUBROUTINE UXDSDO                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  A SCALAR IS SET TO ALL DIAGONAL ELEMENTS OF A DENSE
*  SYMMETRIC MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RI  ALF  SCALAR WHICH IS SET TO ALL DIAGONAL ELEMENTS
*           OF THE MATRIX A.
*  RU  A(N*(N+1)/2) DENSE SYMMETRIC MATRIX STORED IN THE PACKED
*           FORM.
*
      SUBROUTINE UXDSDO(N,ALF,A)
      INTEGER N
      REAL*8 A(N*(N+1)/2),ALF
      INTEGER I,J
      J=0
      DO 1 I=1,N
      J=J+I
      A(J)=ALF
    1 CONTINUE
      RETURN
      END
