* SUBROUTINE UXSGS1                 ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 DA : ORIGINAL VERSION
*
* PURPOSE :
* AUXILIARY SUBROUTINE FOR UXSGDS FROM UMFPACK.
*
      SUBROUTINE UXSGS1(LU,AINDC,AINDR,AVALUE,XX,II,MMEM,ERROR,
     & MAXINT,HISRCH,NB,EXTRA,LOSRCH,NPIV,AN,ANZ,BLOCK,ABSPT,
     & RELPT,GRO,PMIN,IGAR,XGAR,SYMSRC,TRANS,NINVLD)
      INTEGER AINDC(*),AINDR(*),II(*),ERROR,LU(2,2),MMEM(7,2),
     & MAXINT,HISRCH,NB,EXTRA,
     & LOSRCH,NPIV,AN,ANZ,ANZ2,ANZDIA,ANZOFF,ABLKS,
     & LUNS,TAIL1(2,2),ABLKPP,LUBLPP,PERMP,ACOLIP,
     & ACOLXP,AROWPP,ACOLPP,ALEFTP,LUTIPP,LUTXPP,FPP,
     & FLEFRP,FLEFCP,AFLPP,WJP,WIP,WXP,WMP,PERM2P,
     & FSONLP,AHIHDP,AHIP,AHIPRP,AHINXP,ALOHDP,ALOP,
     & ALOPRP,ALONXP,WORKIP,TLENP,ZPERMP,INBLKP,TPP,
     & ACOL2P,IPRMRP,IPRMCP,NIL,R,C,TCOLPP,TCOLIP,P,
     & TCOLXP,SEENP,POSP,NINVLD,BLP,AOFFIP,
     & AOFFXP,AOFFPP,SIZE,AOFP2,P1,P2,MARK(2,2),
     & IGAR,XGAR
      LOGICAL BLOCK,SYMSRC,TRANS
      REAL*8 AVALUE(*),XX(*),ABSPT,RELPT,GRO,PMIN
      PARAMETER (NIL = 0, R = 1, C = 2)
      CALL UXIGET(MMEM,ERROR,1,6,1,LU(1,1))
      IF (ERROR .NE. 0) GOTO 997
      IF (LU (1,1) .EQ. NIL) GOTO 998
      IF (LU (1,1) .NE. 1) GOTO 997
      CALL UXIGET(MMEM,ERROR,2,0,1,LU(1,2))
      IF (ERROR .NE. 0) GOTO 997
      IF (LU (1,2) .EQ. NIL) GOTO 999
      IF (LU (1,2) .NE. 1) GOTO 997
      II(1) = AN
      II(2) = 0
      II(3) = 0
      II(4) = 0
      II(5) = 0
      II(6) = 0
      CALL UXIGET(MMEM,ERROR,1,2*AN,1,PERMP)
      IF (ERROR .NE. 0) GOTO 997
      IF (PERMP .EQ. NIL) GOTO 998
      IF (PERMP .NE. 7) GOTO 997
C
C     ALLOCATE SPACE NEEDED DURING LU FACTORIZATION, AND CONVERT
C     LU DATA STRUCTURE
C
      CALL UXIGET(MMEM,ERROR,1,6*AN+1,2,P)
      IF (ERROR .NE. 0) GOTO 997
      IF (P .EQ. NIL) GOTO 998
      LUTXPP = P
      P = P + (AN)
      LUTIPP = P
      P = P + (AN)
      FPP    = P
      P = P + (AN)
      WMP    = P
      P = P + (AN+1)
      PERM2P = P
      P = P + (2*AN)
      CALL UXIMRK(MMEM,ERROR,TAIL1)
      IF (ERROR .NE. 0) GOTO 997
C
C     ALLOCATE SPACE NEEDED ONLY DURING LU FACTORIZATION
C
      SIZE = 12*AN+2
      IF (LOSRCH .NE. 0) SIZE = SIZE + 3*AN
      CALL UXIGET(MMEM,ERROR,1,SIZE,2,P)
      IF (ERROR .NE. 0) GOTO 997
      IF (P .EQ. NIL) GOTO 998
      ACOLPP = P
      P = P + (AN+1)
      AROWPP = P
      P = P + (AN+1)
      ALEFTP = P
      P = P + (2*AN)
      WJP    = P
      P = P + (2*AN)
      AHIP   = P
      P = P + (2*AN)
      ALOP   = P
      P = P + (2*AN)
      IF (LOSRCH .NE. 0) THEN
      ALONXP = P
      P = P + (AN)
      ALOPRP = P
      P = P + (AN)
      ALOHDP = P
      P = P + (AN)
      ELSE
      ALONXP = 1
      ALOPRP = 1
      ALOHDP = 1
      ENDIF
      WIP    = P
      P = P + (2*AN)
      CALL UXIGET(MMEM,ERROR,2,AN,2,WXP)
      IF (ERROR .NE. 0) GOTO 997
      IF (WXP .EQ. NIL) GOTO 999
      AHIHDP = LUTIPP
      AHIPRP = LUTXPP
      AHINXP = FPP
      FLEFRP = ALOP + AN
      FLEFCP = AHIP + AN
      AFLPP = PERM2P
      FSONLP = ALEFTP + AN
      IPRMRP = PERM2P
      IPRMCP = PERM2P + AN
      WORKIP = AHIP
      ACOL2P = AROWPP
      TPP = AROWPP
      TCOLPP = WMP
      ZPERMP = FPP
      TLENP = WJP
      INBLKP = LUTXPP
      SEENP = WORKIP
      POSP = WORKIP + AN
      AOFP2 = SEENP
C
C     ALLOCATE ACOLI/X AT TAIL
C
      CALL UXIGET(MMEM,ERROR,2,ANZ,2,ACOLXP)
      IF (ERROR .NE. 0) GOTO 997
      IF (ACOLXP .EQ. NIL) GOTO 999
      CALL UXIGET(MMEM,ERROR,1,ANZ,2,ACOLIP)
      IF (ERROR .NE. 0) GOTO 997
      IF (ACOLIP .EQ. NIL) GOTO 998
      IF (BLOCK) THEN
C
C     CONVERT TO TEMPORARY COLUMN-ORIENTED FORM, REMOVE DUPLICATES,
C     SCALE, AND DROP ENTRIES BELOE TRESHOLD
C
      CALL UXIGET(MMEM,ERROR,2,ANZ,2,TCOLXP)
      IF (ERROR .NE. 0) GOTO 997
      IF (TCOLXP .EQ. NIL) GOTO 999
      CALL UXIGET(MMEM,ERROR,1,ANZ,2,TCOLIP)
      IF (ERROR .NE. 0) GOTO 997
      IF (TCOLIP .EQ. NIL) GOTO 998
      CALL UXSGF6(AVALUE,AINDC,AINDR,AN,ANZ,ANZ2,
     & II(ALEFTP+AN),II(TCOLPP),II(TCOLIP),
     & XX(TCOLXP),II(POSP),TRANS,NINVLD)
      IF (NINVLD .NE. 0) GOTO 996
C
C     PERMUTE TO UPPER-BLOCK-TRIANGULAR
C
      CALL UXSGS8(II(TCOLPP),II(TCOLIP),II(ALEFTP+AN),
     & II(TPP),II(WORKIP),II(IPRMRP),II(IPRMCP),
     & II(ZPERMP),II(TLENP),AN,ANZ2,ABLKS)
      IF (ABLKS .GT. 1) THEN
C
C     MORE THAN ONE BLOCK FOUND
C
      SIZE = 2*(ABLKS+1) + (AN+1)
      CALL UXIGET(MMEM,ERROR,1,SIZE,1,BLP)
      IF (ERROR .NE. 0) GOTO 997
      IF (BLP .EQ. NIL) GOTO 998
      LUBLPP = BLP
      ABLKPP = LUBLPP + (ABLKS+1)
      AOFFPP = ABLKPP + (ABLKS+1)
      IF (AOFFPP .NE. 7+2*AN+2*(ABLKS+1)) GOTO 997
C
C     SAVE STERTING ROW OF EACH BLOCK
C
      DO 10 P = 0, ABLKS-1
      II (ABLKPP+P) = II (WORKIP+P)
10    CONTINUE
      II (ABLKPP+ABLKS) = AN+1
C
C     FIND THE COUNT OF OFF-DIAGONAL NONZEROS, AND ON-DIAGONAL,
C     AND FIND INVERSE PERMUTATION VECTORS
C
      CALL UXSGS3(II(TCOLPP),II(TCOLIP),
     & II(PERMP),II(PERMP+AN),
     & II(ABLKPP),II(ALEFTP),II(ALEFTP+AN),II(INBLKP),
     & II(IPRMRP),II(IPRMCP),AN,ABLKS,
     & ANZDIA,ANZOFF,ANZ2,II(TLENP))
C
C     MOVE ACOLI/X FORWARD
C
      ACOLIP = ACOLIP + (ANZ-ANZDIA)
      ACOLXP = ACOLXP + (ANZ-ANZDIA)
C
C     STORE THE MATRIX INTO THE BLOCK UPPER-TRIANGULAR FORM
C
C
C     ALLOCATE THE AOFFI/X DATA STRUCTURE
C
      CALL UXIGET(MMEM,ERROR,1,ANZOFF,1,AOFFIP)
      IF (ERROR .NE. 0) GOTO 997
      IF (AOFFIP .EQ. NIL) GOTO 998
      IF (AOFFIP .NE. 7+2*AN+2*(ABLKS+1)+(AN+1)) GOTO 997
      CALL UXIGET(MMEM,ERROR,2,ANZOFF,1,AOFFXP)
      IF (ERROR .NE. 0) GOTO 997
      IF (AOFFXP .EQ. NIL) GOTO 999
      IF (AOFFXP .NE. 1) GOTO 997
      CALL UXSGS4(II(TCOLPP),II(TCOLIP),XX(TCOLXP),
     & II(AOFFPP),II(AOFFIP),XX(AOFFXP),
     & II(PERMP),II(PERMP+AN),
     & II(ACOLPP),II(ALEFTP+AN),II(INBLKP),
     & II(ACOLIP),XX(ACOLXP),II(ACOL2P),AN,ANZ2,
     & ANZDIA,II(TLENP),II(AOFP2))
C
C     DEALLOCATE TCOLI/X/P, AND UNUSED SPACE AT FRONT OF ACOLI/X
C
      SIZE = ANZ + (ANZ-ANZDIA)
      CALL UXIFRE(MMEM,ERROR,1,SIZE,TCOLIP)
      IF (ERROR .NE. 0) GOTO 997
      IF (MMEM (2,1) .NE. ACOLIP) GOTO 997
      CALL UXIFRE(MMEM,ERROR,2,SIZE,TCOLXP)
      IF (ERROR .NE. 0) GOTO 997
      IF (MMEM (2,2) .NE. ACOLXP) GOTO 997
      ELSE
C
C     ONLY ONE BLOCK FOUND - MATRIX IS IRREDUCIBLE
C
      CALL UXIGET(MMEM,ERROR,1,4,1,BLP)
      IF (ERROR .NE. 0) GOTO 997
      IF (BLP .EQ. NIL) GOTO 998
      LUBLPP = BLP
      ABLKPP = LUBLPP + 2
      II (ABLKPP) = 1
      II (ABLKPP+1) = AN+1
      ANZDIA = ANZ2
      ANZOFF = 0
      ACOLIP = ACOLIP + (ANZ-ANZDIA)
      ACOLXP = ACOLXP + (ANZ-ANZDIA)
C
C     STORE THE VALUES INTO ACOLI/X AND COUNT NZ IN ROWS
C
      CALL UXSGS5(II(TCOLPP),II(TCOLIP),XX(TCOLXP),
     & II(ACOLPP),II(ACOLIP),XX(ACOLXP),
     & II(PERMP),II(PERMP+AN),II(ALEFTP),AN,ANZDIA)
      ENDIF
      ELSE
C
C     NOT BLOCKING - SIMPLE STORE THE MATRIX INTO COLUMN-ORIENTED FORM
C
      CALL UXSGF6(AVALUE,AINDC,AINDR,AN,ANZ,ANZ2,
     & II(ALEFTP+AN),II(ACOLPP),II(ACOLIP),
     & XX(ACOLXP),II(POSP),TRANS,NINVLD)
      IF (NINVLD .NE. 0) GOTO 996
      CALL UXIGET(MMEM,ERROR,1,4,1,BLP)
      IF (ERROR .NE. 0) GOTO 997
      IF (BLP .EQ. NIL) GOTO 998
      LUBLPP = BLP
      ABLKPP = LUBLPP + 2
      II (ABLKPP) = 1
      II (ABLKPP+1) = AN+1
      ABLKS = 1
      ANZDIA = ANZ2
      ANZOFF = 0
      CALL UXSGS6(II(ACOLIP),XX(ACOLXP),
     & II(PERMP),II(PERMP+AN),II(ALEFTP),AN,ANZ,ANZDIA)
      ACOLIP = ACOLIP + (ANZ-ANZDIA)
      ACOLXP = ACOLXP + (ANZ-ANZDIA)
      ENDIF
      IF (LUBLPP .NE. 7+2*AN .OR. ABLKPP .NE. 7+2*AN+ABLKS+1) GOTO 997
      II(2) = ABLKS
      II(3) = ANZOFF
      II(4) = ANZDIA
C
C     FACTORIZATION
C
      CALL UXSGS2(ERROR,TAIL1,II,II(ABLKPP),II(AROWPP),
     & II(ACOLPP),II(ACOLIP),II(WMP),II(LUTIPP),II(LUTXPP),
     & II(LUBLPP),II(AHIHDP),II(AHIPRP),II(AHINXP),II(ALOHDP),
     & II(ALOPRP),II(ALONXP),II(FPP),II(FSONLP),II(FLEFRP),
     & II(FLEFCP),II(PERMP),II(PERMP+AN),II(PERM2P),
     & II(PERM2P),II(PERM2P+AN),II(AHIP),II(AHIP+AN),II(ALOP),
     & II(ALOP+AN),II(ALEFTP),II(ALEFTP+AN),II(AFLPP),
     & II(AFLPP),II(AFLPP+AN),II(WJP),II(WJP+AN),II(WIP),
     & II(WIP+AN),XX,XX(WXP),XX(ACOLXP),MMEM,MAXINT,
     & HISRCH,NB,EXTRA,LOSRCH,NPIV,AN,ABLKS,LUNS,ABSPT,RELPT,
     & GRO,PMIN,IGAR,XGAR,SYMSRC)
      IF (ERROR .NE. 0) RETURN
C
C     PERMUTE THE OFF-DIAGONAL NONZEROS TO REFLECT THE NEW PIVOT ORDER
C
      IF (ABLKS .GT. 1) THEN
      CALL UXIGET(MMEM,ERROR,1,ANZOFF,2,P1)
      IF (ERROR .NE. 0) GOTO 997
      IF (P1 .EQ. NIL) GOTO 998
      CALL UXIGET(MMEM,ERROR,2,ANZOFF,2,P2)
      IF (ERROR .NE. 0) GOTO 997
      IF (P2 .EQ. NIL) GOTO 999
      CALL UXSGS7(II(AOFFPP),II(AOFFIP),XX(AOFFXP),II(WMP),
     & II(P1),XX(P2),AN,ANZOFF,II(PERM2P),II(PERM2P+AN))
      ENDIF
      MARK (1,1) = MMEM (1,1)
      MARK (1,2) = MMEM (1,2)
      MARK (2,1) = MMEM (4,1)
      MARK (2,2) = MMEM (4,2)
      CALL UXIRST(MMEM,ERROR,MARK,1)
      IF (ERROR .NE. 0) GOTO 997
      CALL UXIRST(MMEM,ERROR,MARK,2)
      IF (ERROR .NE. 0) GOTO 997
C
C     DEALLOCATE TO THIS POINT WHEN REFACTORING
C
      LU (2,1) = MMEM (1,1)
      LU (2,2) = MMEM (1,2)
      RETURN
C
C     ERROR CONDITIONS
C
  996 ERROR = 63
      CALL UOERR1('UXSGS1',ERROR)
      RETURN
  997 ERROR = 64
      CALL UOERR1('UXSGS1',ERROR)
      RETURN
  998 ERROR = 65
      CALL UOERR1('UXSGS1',ERROR)
      RETURN
  999 ERROR = 66
      CALL UOERR1('UXSGS1',ERROR)
      RETURN
      END
