* SUBROUTINE UXSGS4                 ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 DA : ORIGINAL VERSION
*
* PURPOSE :
* AUXILIARY SUBROUTINE FOR UXSGDS FROM UMFPACK.
*
      SUBROUTINE UXSGS4(TCOLP,TCOLI,TCOLX,AOFFP,AOFFI,AOFFX,
     & PERMR,PERMC,ACOLP,ALEFTC,INBLK,ACOLI,ACOLX,
     & ACOLP2,AN,ANZ2,ANZDIA,TLEN,AOFFP2)
      INTEGER AN,ANZDIA,ANZ2,PERMR(AN),PERMC(AN),
     & ACOLP(AN+1),ALEFTC(AN),INBLK(AN),
     & ACOLP2(AN+1),ACOLI(ANZDIA),I,COL,ROW,P,
     & R,C,TCOLI(ANZ2),TCOLP(AN+1),P2,AOFFI(*),
     & AOFFP(AN+1),TLEN(AN),AOFFP2(AN)
      REAL*8 TCOLX(ANZ2),ACOLX(ANZDIA),VALUE,AOFFX(*)
        PARAMETER (R = 1, C = 2)
C
C     STORE THE MATRIX INTO UPPER-BLOCK-TRIANGULAR FORM (COLUMN FORM OF
C     DIAGONAL BLOCKS, AND ROW-FOR OF OFF-DIAGONAL BLOCKS)
C
      AOFFP (1) = 1
      ACOLP (1) = 1
      DO 10 I = 2, AN+1
      AOFFP (I) = AOFFP (I-1) + TLEN (I-1)
      ACOLP (I) = ACOLP (I-1) + ALEFTC (I-1)
10    CONTINUE
      DO 20 ROW = 1, AN
      AOFFP2 (ROW) = AOFFP (ROW)
      ACOLP2 (ROW) = ACOLP (ROW)
20    CONTINUE
      DO 40 I = 1, AN
      COL = PERMC (I)
      DO 50 P = TCOLP (I), TCOLP (I+1)-1
      ROW = PERMR (TCOLI (P))
      VALUE = TCOLX (P)
      IF (INBLK (ROW) .EQ. INBLK (COL)) THEN
      P2 = ACOLP2 (COL)
      ACOLI (P2) = ROW
      ACOLX (P2) = VALUE
      ACOLP2 (COL) = P2 + 1
      ELSE
      P2 = AOFFP2 (ROW)
      AOFFI (P2) = COL
      AOFFX (P2) = VALUE
      AOFFP2 (ROW) = P2 + 1
      ENDIF
50    CONTINUE
40    CONTINUE
      RETURN
      END
