* SUBROUTINE UXSII1                 ALL SYSTEMS                96/12/01
C PORTABILITY : ALL SYSTEMS
C 96/12/01 DR : ORIGINAL VERSION
*
* PURPOSE :
* AUXILIARY SUBROUTINE FOR UXSIIF.
*
      SUBROUTINE UXSII1(N,M,IA,JA,A,PERM,INVP,KSTEP,COL)
      INTEGER N,M,IA(N+1),JA(M),PERM(N),INVP(N),KSTEP
      REAL*8  A(M),COL(N)
      INTEGER IND,J,K,L,JSTRT,JSTOP,I5,II,IIND,JJ,JJSTRT,JJSTOP,LL,KK
      DO 15 I5=1,N
      COL(I5)=0.0D 0
   15 CONTINUE
C
C     NUMBER OF COLUMNS WHERE 1x1 PIVOT WAS FOUND
C
      IND=PERM(KSTEP)
      JSTRT=IA(IND)
      JSTOP=IA(IND+1)-1
C
C     ELEMENTS WHICH WILL BE USED FOR FACTORIZATION IN ITER KSTEP
C     ARE SAVED INTO WORKING ARRAY COL(N)
C
      DO 200 J=JSTRT,JSTOP
      K=JA(J)
      L=INVP(K)
      IF (L.GE.KSTEP) THEN
      COL(L)=A(J)
      END IF
  200 CONTINUE
      IF ( KSTEP.LE.IND ) THEN
C
C     SHORTER COLUMN IS IN KSTEP-TH COLUMN. NEXT RELATED ELEMENTS
C     ARE ADDED INTO WORKING ARRAY COL(N)
C
      DO 300 II=(KSTEP+1),N
      IIND=PERM(II)
      JJSTRT=IA(IIND)+1
      JJSTOP=IA(IIND+1)-1
      DO 400 JJ=JJSTRT,JJSTOP
      KK=JA(JJ)
      LL=INVP(KK)
      IF (KK.EQ.IND) THEN
      COL(II)=A(JJ)
      END IF
  400 CONTINUE
  300 CONTINUE
      END IF
      RETURN
      END
