* SUBROUTINE  UXSRBH              ALL SYSTEMS               92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE : GENERATION OF ELIMINATION TREE DIRECTLY FROM THE COMPACT
*           STRUCTURE.
*
*  PARAMETERS :
*  II  NN  NUMBER OF BLOCK COLUMNS OF A.
*  II  XLNZ(NN)
*  II  JR(NN**2/2)
*  IO  PARENT(NN) ELIMINATION TREE.
*
      SUBROUTINE UXSRBH(NN,XLNZ,XNZSUB,NZSUB,PARENT,IND,WN02)
      INTEGER NN,I,K,L,PARENT(NN),J1,XLNZ(NN+1)
      INTEGER IND, WN02(NN), XNZSUB(NN+1), NZSUB(*)
      K = XLNZ(1)
      L = XLNZ(2)
      IND=0
      DO 100 I=1, NN
        PARENT(I)=NN+1
        IF (L-K.NE.0) THEN
C
C ROWS NEED NOT TO BE ORDERED
C
          DO 200 J1=XNZSUB(I),XNZSUB(I)+L-K-1
            PARENT(I)=MIN(PARENT(I),NZSUB(J1))
  200     CONTINUE
        ELSE
          PARENT(I)=0
          IND=IND+1
          WN02(IND)=I
        END IF
        K = L
        L = XLNZ(I+2)
  100 CONTINUE
      RETURN
      END
