* SUBROUTINE UXSSDC                ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DIAGONAL OF A SPARSE SYMMETRIC MATRIX A IS COPIED TO THE VECTOR D.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  RI  D(N)  DIAGONAL OF THE SPARSE SYMMETRIC MATRIX.
*
      SUBROUTINE UXSSDC(N,M,A,IA,D)
      INTEGER N,M,IA(N)
      REAL*8  A(M), D(N)
      INTEGER I
      DO 100 I=1,N
      D(I)=A(IA(I))
100   CONTINUE
      RETURN
      END
