* SUBROUTINE UXVGFP                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR X(N) IS PERMUTED ACCORDING TO THE FORMULA
* X(I)=X(PERM(I)).
*
* PARAMETERS :
*  II  N  LENGTH OF VECTORS.
*  II  PERM(N)  INPUT PERMUTATION VECTOR.
*  RU  X(N)  VECTOR THAT IS TO BE PERMUTED.
*  RA  RN01(N)  AUXILIARY VECTOR.
*
      SUBROUTINE UXVGFP(N,PERM,X,RN01)
      INTEGER N,PERM(N),I
      REAL*8 RN01(N),X(N)
C
      DO 100 I=1,N
      RN01(I)=X(PERM(I)/N+1)
100   CONTINUE
      DO 200 I=1,N
      X(I)=RN01(I)
200   CONTINUE
      RETURN
      END
