* SUBROUTINE UXVIMX             ALL SYSTEMS                   91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* L-INFINITY NORM OF A VECTOR WITH INDEX DETERMINATION.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RR  XMAX  L-INFINITY NORM OF THE VECTOR X.
*  IO  UXVIMX  INDEX OF ELEMENT WITH MAXIMUM ABSOLUTE VALUE.
*
      FUNCTION UXVIMX(N,X,XMAX)
      INTEGER N,UXVIMX
      REAL*8 X(N),XMAX
      INTEGER I
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      UXVIMX=1
      XMAX=ABS(X(1))
      DO 1 I=2,N
      IF (ABS(X(I)).GT.XMAX) THEN
      XMAX=ABS(X(I))
      UXVIMX=I
      ENDIF
    1 CONTINUE
      RETURN
      END
