* FUNCTION  UXVNOR               ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* EUCLIDEAN NORM OF A VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RR  UXVNOR  EUCLIDEAN NORM OF X.
*
      FUNCTION UXVNOR(N,X)
      INTEGER N
      REAL*8 X(N),UXVNOR
      REAL*8 POM,DEN
      INTEGER I
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      DEN=ZERO
      DO 1 I=1,N
      DEN=MAX(DEN,ABS(X(I)))
    1 CONTINUE
      POM=ZERO
      IF (DEN.GT.ZERO) THEN
      DO 2 I=1,N
      POM=POM+(X(I)/DEN)**2
    2 CONTINUE
      ENDIF
      UXVNOR=DEN*SQRT(POM)
      RETURN
      END
