* FUNCTION UYGST1                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 SI : ORIGINAL VERSION
*
* PURPOSE:
*  BAYESIAN STOPPING RULE FOR GLOBAL OPTIMIZATION
*
* PARAMETERS:
*  II  NLMIN  NUMBER OF DIFFERENT LOCAL MINIMA
*  II  N  NUMBER OF POINTS IN THE REDUCED RANDOM SAMPLE
*
      LOGICAL FUNCTION UYGST1(NLMIN,N)
      INTEGER NLMIN,N
      REAL A,B
      A=NLMIN*(N-1)
      B=N-NLMIN-2
      IF (B.EQ.0.0E0) B=1.0E0
      A=A/B
      B=NLMIN
      IF (A.LE.B+0.5) THEN
        UYGST1 = .TRUE.
      ELSE
        UYGST1 = .FALSE.
      ENDIF
      END
