$INTERFACE U1LSL1                                             97/12/01
$REM TU

  $PTR='ICG'
  $CNR='JCG'
  $AU='CG'
  $ADD(INTEGER,'\IEXTS')
  $TYPE='L'
  $HELP
    METHOD
      1 - PRIMAL NULL SPACE LINEAR PROGRAMMING METHOD
      2 - PRIMAL RANGE SPACE LINEAR PROGRAMMING METHOD
  $CHECK(NUMBER,1,'1\2',2,NO)
  $HELP
    LOWER BOUND FOR CONSTRAINT VIOLATION
  $CHECK(TOLC,'1.0$P-6',REAL,3)
  $HELP
    PRECISION FOR EITHER LINEAR OR QUADRATIC PROGRAMMING SUBROUTINE
  $CHECK(EPS7,'1.0$P-10',REAL,4)
  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-8',REAL,4)
  $KD=1
  $ADD(INIT)
    MFP=2
    NXFU='U1LSL1'
  $ENDADD
  KD=1
  JOUT=1
  IF(ABS(KOUT).EQ.2) KOUT=SIGN(4,KOUT)
$REM  IF(ABS(MOUT).EQ.1) MOUT=SIGN(3,MOUT)
  IF(ABS(MOUT).EQ.2) MOUT=SIGN(4,MOUT)
  $SUBST('UO0FU1')
  $SUBST('UZMODL')
  $IF(NORMF>0) $SUBST('UYTRUG')
  $IF(NCL>0)
    $IF(NUMBER=1) $NC=MCOLS
    $MCL=NCL
     MCL=NCL
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL3')
    $IF(NUMBER=2) $SUBST('UCLNF4')
    $IF(NORMF>0) $SUBST('UCTRL3')
    $IF(NUMBER=1) $NC=NCL
  $ENDIF
  LCS=0
  $IXA='IX'
*
*     ------------------------------
*     SPARSE SIMPLEX TYPE LP METHODS
*     TEMPLATE : U1LSL1
*     ------------------------------
*
  $IF(NUMBER=1)
    IEXTS=IEXT
    IEXT=0
    CALL UXVSET(MCOLS-NF,ZERO,$GF(NF+1))
    $ICS=IC
    $CLS=CL
    $CUS=CU
    $IF(KBC>0)
      $IC='ICC'
      CALL UXVICP(NC,$ICS,$IC)
      $ADD(INTEGER,'\$ICS($MROWS)')
      $CL='CCL'
      CALL UXVCOP(NC,$CLS,$CL)
      $ADD(REAL,'\$CLS($MROWS)')
    $ENDIF
    $IF(KBC>1)
      $CU='CCU'
      CALL UXVCOP(NC,$CUS,$CU)
      $ADD(REAL,'\$CUS($MROWS)')
    $ENDIF
    $SUBST('UKLINM')
    $SUBST('UKSGLM')
    ITERM=ITERL
    IF (ITERM.GE.0) THEN
    $SUBST('UKLNF4')
    CALL UYCMAX(NC,$CF,$ICS,$CLS,$CUS,CMAX)
    IF (CMAX.GE.TOLC) THEN
    CALL UOERR1('U1FSQ1',89)
    ITERM=-89
    ENDIF
    ENDIF
    $IF(KBC>0) $IC=ICS
    $IF(KBC>0) $CL=CLS
    $IF(KBC>1) $CU=CUS
    $ADD(INIT)
      NDXX='UKSGLM'
    $ENDADD
    NF=NFL
    NC=NCL
    IEXT=IEXTS
  $ELSE
    $DEFAULT='20*($NF+$NC)'
    $HELP
      LENGTH OF WORK SPACE
    $CHECK(MMAX,DEFAULT,INT,1)
    $IF(KBC=1) $CU=CL
    $REPEAT
      $HELP
        LENGTH OF WORK SPACE
      $CHECK(MMAX,0,INT,1)
      $IF(MMAX=0)
        $IF(DIALOG>0)
          $ERASE(MMAX)
        $ELSE
          $ERROR: 'MMAX' - LACK OF WORK SPACE FOR SPARSE
                           DIRECT METHODS
          $STOP
        $ENDIF
      $ENDIF
    $UNTIL($DEF(MMAX))
    $JOB=0
    $SUBST('UMLPB2')
    IF (KBF.GT.0) CALL UXVINA(NF,IX)
  $ENDIF
  $ADD(INIT)
    NDXX=NLPX
  $ENDADD
  $IF(NCL>0)
    $IF(NUMBER=1) $NC=MCOLS
    $IF(NUMBER=2) CALL UXVINA(NC,IC)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL3')
    $IF(NORMC>0) $SUBST('UCNRL3')
    $IF(NUMBER=1) $NC=NCL
    ITERM=ITERL
  $ENDIF
  NIT=NRED
  NFV=2
  CALL UYSET2
  $SUBST('UZMODL')
  $SUBST('UYCMAX')
  GMAX=0.0$P 0
  IF (ITERL.EQ.-2) THEN
  TXFU='INFINITY'
  ELSE IF (ITERL.EQ.-1) THEN
  TXFU='INFEAS  '
  ELSE IF (ITERL.EQ.1) THEN
  TXFU='FEASIBLE'
  ELSE IF (ITERL.EQ.2) THEN
  TXFU='OPTIMUM '
  ELSE
  TXFU='        '
  ENDIF
  KDC=0
  ISNC=1
  $SUBST('UO1FN2')
$EXIT

