$INTERFACE UCSVF3                                             97/12/01

  CALL UCSVF3($NN,$CF,FF,IEXT)
  $ADD(REAL,'\$CF($NC+1)')
$REM  $ADD(REAL,'\FF')
$REM  $ADD(INTEGER,'\NF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UCSVF3             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE OF THE LINEAR APPROXIMATED FUNCTION.
*
* PARAMETERS :
*  II  NC  NUMBER OF APPROXIMATED FUNCTIONS.
*  RU  CF(NC+1)  VECTOR CONTAINING VALUES OF THE APPROXIMATED
*         FUNCTIONS.
*  RI  FF  VALUE OF THE MODEL FUNCTION.
*  II  IEXT  TYPE OF EXTREMUM. IEXT<0-MINIMAX. IEXT=0-CHEBYSHEV
*         APPROXIMATION, IEXT>0-MAXIMIN.
*
      SUBROUTINE UCSVF3(NC,CF,FF,IEXT)
      INTEGER NC,IEXT
      $FLOAT CF(NC+1),FF
      IF (IEXT.LE.0) THEN
      CF(NC+1)= FF
      ELSE
      CF(NC+1)=-FF
      ENDIF
      RETURN
      END
