$INTERFACE UCTRF1                                             97/12/01

  CALL UCTRF1(NC,KC,$IC,$CL,FC)
  $ADD(REAL,'\$CL($NC)')
$REM  $ADD(REAL,'\FC')
  $ADD(INTEGER,'\$IC($NC)')
$REM  $ADD(INTEGER,'\NC\KC')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UCTRF1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF A DEVIATION FOR THE CONSTRAINT FUNCTION.
*
* PARAMETERS :
*  II  NC  NUMBER OF FUNCTIONS.
*  II  KC  INDEX OF THE SELECTED FUNCTION.
*  II  IC(NC)  TYPES OF FUNCTIONS.
*  RI  CL(NC)  LOWER BOUNDS OF FUNCTIONS.
*  RO  FC  VALUE OF THE SELECTED FUNCTION.
*
      SUBROUTINE UCTRF1(NC,KC,IC,CL,FC)
      INTEGER NC,KC,IC(NC)
      $FLOAT CL(NC),FC
      IF (ABS(IC(KC)).EQ.5) THEN
      FC=FC-CL(KC)
      ENDIF
      RETURN
      END
