$INTERFACE UE0Y01                                             98/12/01

$REM $ADD(INTEGER,'\NE\KE')
 $00  CALL UE0Y01(NE,KE)
      GOTO ($20,$10) ISB+1
 $10  CONTINUE
      $IF(LYD<0)
        $MTYPE=FMODY
        $SUBST('UZYMOD')
        $SUBST('UESVY1')
      $ELSE
        IF(LDY.GE.0) FE=$EF(KE)
      $ENDIF
      GOTO $00
 $20  CONTINUE
      $ADD(INIT)
        NEXX='UE0Y01'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UE0Y01             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE OF THE RIHGT HAND SIDE FUNCTION.
*
* PARAMETERS :
*  II  NE  DECLARED NUMBER OF DIFFERENTIAL EQUATIONS.
*  IU  KE  INDEX OF THE DIFFERENTIAL EQUATION.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UE0Y01(NE,KE)
      $INCLUDE ('UMCOMM')
      INTEGER NE,KE
      IF (TSS(NS).NE.'UEXX') CALL UYPRO1('UEXX',-1)
      GO TO (1,3) ISP(NS)
    1 CONTINUE
      KE=1
    2 IF (KE.GT.NE) GOTO 6
      CALL UYSET0(1,2)
      RETURN
    3 CONTINUE
      KE=KE+1
      GO TO 2
    6 CONTINUE
      CALL UYEPI1(-1)
      RETURN
      END
