$INTERFACE UFSET1                                             97/12/01

  $HELP
    MAXIMUM SIZE OF THE SPARSE HESSIAN MATRIX
  $CHECK(M,'10*$NF',INT,1)
  $ADD(INTEGER,'\$IH($NF+1)')
$REM  $ADD(INTEGER,'\NF\M')
  CALL UFSET1(NF,M,$IH)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UFSET1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER OF NONZERO ELEMENTS OF THE SPARSE
* HESSIAN MATRIX STORED IN THE GENERAL FORM.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  IO  M  NUMBER OF NONZERO ELEMENTS OF THE SPARSE HESSIAN MATRIX
*  RI  IH(NF+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD H.
*
      SUBROUTINE UFSET1(NF,M,IH)
      INTEGER NF,M,IH(NF+1)
      M=IH(NF+1)-1
      RETURN
      END
