* SUBROUTINE UG0F02             ALL SYSTEMS                 91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  COMPUTATION OF THE FILLED FUNCTION
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  RU  F  FUNCTION VALUE.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  FMIN  FUNCTION VALUE IN XMIN.
*  RI  XMIN(NF)  VECTOR OF VARIABLES IN MINIMUM.
*  RI  PFILL  FILL PARAMETER.
*
      SUBROUTINE UG0F02(NF,F,X,FMIN,XMIN,PFILL)
      INTEGER NF
      $FLOAT F,X(NF),FMIN,XMIN(NF),PFILL
      $FLOAT UXVNM2
      F=-(F-FMIN)*EXP(PFILL*UXVNM2(NF,X,XMIN))
      END
