* SUBROUTINE ULDIRS               ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE NEW VECTOR OF VARIABLES.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  S(NF)  DIRECTION VECTOR.
*  RO  STEP  CURRENT STEPSIZE.
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*
      SUBROUTINE ULDIRS(NF,X,IX,S,STEP,KBF)
      INTEGER NF,IX(NF),KBF
      $FLOAT X(NF),S(NF),STEP
      INTEGER I
      DO 1 I=1,NF
      IF (KBF.LE.0) THEN
      X(I)=X(I)+STEP*S(I)
      ELSE IF (IX(I).GE.0.AND.IX(I).LE.10) THEN
      X(I)=X(I)+STEP*S(I)
      ELSE IF (IX(I).LT.-10) THEN
      X(I)=X(I)+STEP*S(I)
      ENDIF
    1 CONTINUE
      RETURN
      END
