$INTERFACE UO2FN3                                             91/12/01

  $IF(KBF>0)
    $PARIX='$$IX'
    $PARXL='$$XL'
    $PARXU='$$XU'
  $ELSE
    $PARIX='$$IX'
    $PARXL='$$X'
    $PARXU='$$X'
  $ENDIF
  $IF(KD>0)
    $PARG='$$G'
    $DIMG='$$NF'
  $ELSE
    $PARG='X'
    $DIMG='$$NF'
  $ENDIF
  $IF(HESF='NO')
    $PARH='X'
    $DIMH='$$NF'
  $ELSEIF(ISNF>0)
    $PARH='$$H'
    $DIMH='$$M'
  $ELSE
    $PARH='X'
    $DIMH='$$NF'
  $ENDIF
  $IF(ISNA>0)
    $PARAF='$$AF'
    $DIMAF='$$NA'
  $ELSE
    $PARAF='X'
    $DIMAF='$$NF'
  $ENDIF
  $IF(ISNC>0)
    $PARCF='$$CF'
    $DIMCF='$$NC'
    $IF(KBC>0)
      $PARIC='$$IC'
      $PARCL='$$CL'
      $PARCU='$$CU'
    $ELSE
      $PARIC='$$IX'
      $PARCL='$$X'
      $PARCU='$$X'
    $ENDIF
  $ELSE
    $PARCF='X'
    $DIMCF='$$NF'
    $PARIC='$$IX'
    $PARCL='$$X'
    $PARCU='$$X'
  $ENDIF
  $DEFAULT=1
  $IF(GRAPH<>'NO') $DEFAULT=0
  $IF(DISPLAY<>'NO') $DEFAULT=0
  $IF(GRAPHICS<0) $DEFAULT=1
  $IF(DEFAULT=0)
    $HELP
      SCANING OF ITERATIONS
        Y - ITERATIONS ARE SCANED
        N - NO SCANING IS USED
    $CHECK(SCAN,'N','NO\N\YES\Y',1,NO)
    $IF(SCAN='N') $SCAN='NO'
    $IF(SCAN='Y') $SCAN='YES'
  $ELSE
    $SCAN='NO'
  $ENDIF
  $IF(HESF='D')
    $PARM='NF*(NF+1)/2'
  $ELSEIF(HESF='S')
    $PARM='$IH(NF+1)-1'
  $ELSE
    $PARM='NF'
  $ENDIF
  CALL UO2FN3(NF,$PARM,NA,NC,$PARIX,$X,$PARXL,$PARXU,$PARG,$PARH,$PARAF&
,$PARIC,$PARCF,$PARCL,$PARCU,F,DMAX,GMAX,CMAX)
  $ADD(REAL,'\$X($NF)\$PARG($DIMG)\$PARH($DIMH)\$PARAF($DIMAF)&
  \$PARCF($DIMCF)')
$REM  $ADD(INTEGER,'\NF\M\NA\NC')
$REM  $ADD(REAL,'\F\DMAX\GMAX\CMAX')
  $IF(GRAPHICS<0)
    $IF(GRAPH<>'NO')
      $IF(PATH='NO')
        $JOB=0
      $ELSE
        $SUBST('UO2FJ4')
      $ENDIF
    $ENDIF
  $ELSEIF(GRAPH<>'NO')
    $SCANING=0
    $IF(SCAN='YES') $SCANING=1
    $IF(KBF>1)
    $ELSEIF(KBF>0)
      $XU=XL
    $ELSE
      $XU=X
      $XL=X
    $ENDIF
    $IF(NAP>0)
      $PARA=AF
      $DIMA=NA
      $IIMA=NA
      $IF(KBA=0)
        $AM=AF
      $ELSE
        CALL UXVSUM(NA,$AF,$AM,$AFO)
        $PARA=$AFO
        $ADD(REAL,'\$AFO($NA)')
      $ENDIF
      $DIMAM=NA
    $ELSE
      $PARA=X
      $DIMA=NF
      $IIMA=NX
      $IA=IX
      $AM=X
      $AT=X
      $DIMAM=NF
    $ENDIF
    $IF(NCP>0)
      $PARC=CF
      $DIMC=NC
      $IIMC=NC
      $IF(KBC>1)
      $ELSEIF(KBC>0)
        $CU=CL
      $ELSE
        $CU=PARC
        $CL=PARC
      $ENDIF
    $ELSE
      $PARC=X
      $DIMC=NF
      $IIMC=NX
      $IC=IX
      $CU=X
      $CL=X
    $ENDIF
    $ADD(REAL,'\$X($NF)\$XL($NF)\$XU($NF)\$PARA($DIMA)\$AM($DIMAM)&
    \$PARC($DIMC)\$CL($DIMC)\$CU($DIMC)')
    $ADD(INTEGER,'\$IX($NX)\$IA($IIMA)\$IC($IIMC)')
    $SUBST('UO2FG3')    
$REM    $IF(SCAN='YES')
$REM      $LSC=$00
$REM      IF (ITERM.LT.0) GO TO $LSC
$REM    $ENDIF
    $IF(PATH<>'NO') $SUBST('UO2FG4')
  $ELSEIF(DISPLAY='YES')
    $IF(SCAN='YES')
      CALL UO2FD3(F,DMAX,GMAX)
    $ENDIF
  $ENDIF
  $ADD(INIT)
    ISNF=$ISNF
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UO2FN3                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ITERATIONS IN UNCONSTRAINED MINIMIZATION.
*
* PARAMETERS:
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NC  NUMBER OF CONSTRAINTS
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  H(M)  HESSIAN MATRIX OF THE OBJECTIVE FUNCTION.
*  RI  AF(NA)  VALUES OF THE APPROXIMATED FUNCTIONS.
*  RI  CF(NC)  VALUES OF THE CONSTRAINT FUNCTIONS.
*  RI  F  NEW VALUE OF THE OBJECTIVE FUNCTION.
*  RI  DMAX  MAXIMUM RELATIVE DIFFERENCE OF VARIABLES.
*  RO  GMAX  NORM OF THE TRANSFORMED GRADIENT.
*  RI  CMAX  VALUE OF THE CONSTRAINT VIOLATION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  ISNA  LEVEL OF PRINT. IF ISNA>0 VALUES OF THE APPROXIMATED
*         FUNCTIONS ARE PRINTED.
*  II  ISNC  LEVEL OF PRINT. IF ISNC>0 VALUES OF CONSTRAINTS ARE
*         PRINTED.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF MATRIX CORRECTION.
*         KOUT=5-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=6-ADDITIONAL PRINT OF DEBUGGING.
*  II  LOUT  PRINT OF ITERATIONS. LOUT=0-STANDARD PAPER SAVING PRINT.
*         LOUT=1-ADDITIONAL PRINT OF VARIABLES. LOUT=2-ADDITIONAL
*         PRINT OF THE GRADIENT. LOUT=3-ADDITIONAL PRINT OF THE HESSIAN
*         MATRIX.
*  II  MOUT  LEVEL OF PRINT ON THE TERMINAL DEVICE.
*         MOUT=0 - NO PRINT.
*         MOUT=1 - PRINT OF FINAL RESULTS.
*         MOUT=2 - ADDITIONAL PRINT OF ITERATIONS.
*  II  LIT  NUMBER OF THE FIRST ITERATION.
*  II  NIT  ACTUAL NUMBER OF ITERATIONS.
*  RI  F  NEW VALUE OF THE OBJECTIVE FUNCTION.
*  RI  DMAX  MAXIMUM RELATIVE DIFFERENCE OF VARIABLES.
*  RO  GMAX  NORM OF THE TRANSFORMED GRADIENT.
*
      SUBROUTINE UO2FN3(NF,M,NA,NC,IX,X,XL,XU,G,H,AF,IC,CF,CL,CU,F,
     & DMAX,GMAX,CMAX)
      $INCLUDE ('UMCOMM')
      $INCLUDE ('UMCOMD')
      INTEGER NF,M,NA,NC,IX(*),IC(*)
      $FLOAT X(NF),XL(NF),XU(NF),G(NF),H(*),AF(*),CF(*),CL(*),CU(*),
     & F,DMAX,GMAX,CMAX
      INTEGER I
      LOGICAL LL
      NDEM=NF
      LL=KOUT.EQ.0.AND.LOUT.GT.0
      IF(ABS(MOUT).GT.1) THEN
      IF(KD.LE.0) THEN
      WRITE(ITR,15) NIC,NIT,NFV,F,CMAX
      IF(LL) WRITE(IWR,15) NIC,NIT,NFV,F,CMAX
      ELSE
      WRITE(ITR,16) NIC,NIT,NFV,NFG,F,CMAX,GMAX
      IF(LL) WRITE(IWR,16) NIC,NIT,NFV,NFG,F,CMAX,GMAX
      ENDIF
      ENDIF
      IF(JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.1.AND.LOUT.EQ.0) THEN
      IF (KD.LE.0) THEN
      WRITE (IWR,11) NIC,NIT,NFV,F,CMAX,DMAX,TXFU,TDXX,TSXX,TPXX
   11 FORMAT (' ','NIC=',I3,1X,'NIT=',I5,1X,'NFV=',I5,1X,'F=',
     & $P 9.3,1X,'C=',$P 9.3,1X,'D=',$P 9.3,1X,A8,1X,A8,1X,A8,1X,A8)
      ELSE
      WRITE (IWR,12) NIC,NIT,NFV,NFG,F,CMAX,GMAX,DMAX,TXFU,TDXX,TSXX,
     & TPXX
   12 FORMAT (' ','NIC=',I3,1X,'NIT=',I5,1X,'NFV=',I5,1X,'NFG=',I5,1X,
     & 'F=',$P 9.3,1X,'C=',$P 9.3,1X,'G=',$P 9.3,1X,'D=',$P 9.3,1X,A8,
     & 1X,A8,1X,A8,1X,A8)
      ENDIF
      ELSE
      IF (KD.LE.0) THEN
      WRITE (IWR,1) NIC,NIT,NFV,F,CMAX,TXFU,TDXX,TSXX,TPXX,DMAX
    1 FORMAT (' ','NIC=',I4,1X,'NIT=',I5,1X,'NFV=',I5,1X,'F=',$P 9.3,
     & 1X,'C=',$P 9.3,1X,'D=',$P 9.3/1X,A8,1X,A8,2X,A8,2X,A8)
      ELSE
      WRITE (IWR,2) NIC,NIT,NFV,NFG,F,CMAX,GMAX,TXFU,TDXX,TSXX,TPXX,DMAX
    2 FORMAT (' ','NIC=',I4,1X,'NIT=',I5,1X,'NFV=',I5,1X,'NFG=',I5,2X,
     & 'F=',$P 9.3,1X,'C=',$P 9.3,1X,'G=',$P 9.3/1X,A8,1X,A8,2X,A8,2X,
     & A8,3X,'D=',$P 9.3)
      ENDIF
      ENDIF
      IF (ABS(LOUT).GE.1) THEN
      IF (LOUT.LT.0.AND.KBF.GT.0) WRITE (IWR,30) (ABS(IX(I)),
     & I=1,MIN(25,NF))
      WRITE ( IWR, 3)  (X(I), I=1,MIN(25,NF))
      IF (LOUT.LT.0.AND.KBF.GT.0) WRITE (IWR,31) (XL(I),I=1,MIN(25,NF))
      IF (LOUT.LT.0.AND.KBF.GT.0) WRITE (IWR,32) (XU(I),I=1,MIN(25,NF))
    3 FORMAT ( ' ', 'X   =', 5$P 14.5:/( 6X, 5$P 14.5))
   30 FORMAT ( ' ', 'IX  =', 5I14:/( 6X, 5I14))
   31 FORMAT ( ' ', 'XL  =', 5$P 14.5:/( 6X, 5$P 14.5))
   32 FORMAT ( ' ', 'XU  =', 5$P 14.5:/( 6X, 5$P 14.5))
      ENDIF
      IF (LOUT.LT.0.AND.ISNA.GT.0)
     *WRITE ( IWR, 4)  (AF(I), I=1,MIN(25,NA))
    4 FORMAT ( ' ', 'AF  =', 5$P 14.5:/( 6X, 5$P 14.5))
      IF (LOUT.LT.0.AND.ISNC.GT.0) THEN
      IF (KBC.GT.0) WRITE (IWR,50) (ABS(IC(I)),I=1,MIN(25,NC))
      WRITE ( IWR, 5)  (CF(I), I=1,MIN(25,NC))
      IF (KBC.GT.0) WRITE (IWR,51) (CL(I),I=1,MIN(25,NC))
      IF (KBC.GT.0) WRITE (IWR,52) (CU(I),I=1,MIN(25,NC))
    5 FORMAT ( ' ', 'CF  =', 5$P 14.5:/( 6X, 5$P 14.5))
   50 FORMAT ( ' ', 'IC  =', 5I14:/( 6X, 5I14))
   51 FORMAT ( ' ', 'CL  =', 5$P 14.5:/( 6X, 5$P 14.5))
   52 FORMAT ( ' ', 'CU  =', 5$P 14.5:/( 6X, 5$P 14.5))
      ENDIF
      IF (ABS(LOUT).GE.2) THEN
      IF (KD.GT.0) WRITE(IWR,6) (G(I),I=1,MIN(25,NF))
    6 FORMAT ( ' ', 'G   =', 5$P 14.5:/( 6X, 5$P 14.5))
      ENDIF
      IF (ABS(LOUT).GE.3) THEN
      IF (ISNF.GT.0) WRITE(IWR,7) (H(I),I=1,MIN(50,M))
    7 FORMAT ( ' ', 'H   =', 5$P 14.5:/( 6X, 5$P 14.5))
      ENDIF
      IF(LOUT.NE.0.AND.ABS(KOUT).LE.1) WRITE(IWR,8)
      IF(ABS(KOUT).GT.1 .OR.LOUT.LT.0) WRITE(IWR,9)
    8 FORMAT(' ')
    9 FORMAT(' ',43('-'))
   15 FORMAT(' ',4X,'NIC=',I3,1X,'NIT=',I4,1X,'NFV=',I5,1X,'F=',
     *            D9.3,1X,'C=',D9.3)
   16 FORMAT(' ',4X,'NIC=',I3,1X,'NIT=',I4,1X,'NFV=',I5,1X,'NFG=',
     *            I5,1X,'F=',D9.3,1X,'C=',D9.3,1X,'G=',D9.3)
      RETURN
      END

