$INTERFACE UOSRF2                                             10/12/01

  $ADD(INTEGER,'\NFV1\NAV1') 
  $ADD(REAL,'\$X($NF)')
  $ADD(REAL4,'\$FL($NGR,$NGR)')
$REM  $ADD(INTEGER,'\NF')
$REM  $ADD(REAL,'\F\FO')
      $IF(NA>0)
        CALL UXVCOP(NA,$AF,$AFO)
        $ADD(REAL,'\$AFO($NA)')
      $ENDIF
$REM      IF (NF.LE.1) THEN
$REM      WRITE(12,'(2I5)') 0,0
$REM      GO TO $LGR
$REM      ELSE IF (NF.LE.2) THEN
$REM      WRITE(12,'(2I5)') 1,NGR
$REM      ELSE
$REM      WRITE(12,'(2I5)') 3,NGR
$REM      ENDIF
  $50 CONTINUE
      IF (NF.LE.2) THEN
      CALL UOSRF1(NF,$X,$FL,F,FO,$ETA9,$OBR)
      ELSE
      CALL UOSRF2(NF,$X,$FL,F,FO,$ETA9,$OBR)
      ENDIF
      GOTO ($60,$70) ISB+1
  $60 CONTINUE
      $IF(NA>0)
        CALL UXVCOP(NA,$AFO,$AF)
      $ENDIF
      GOTO $LGR
  $70 CONTINUE
      NFV1=NFV
      NAV1=NAV
      $SUBST('UZMODL')
      NFV=NFV1
      NAV=NAV1
      GOTO $50
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOSRF2                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  SCILAB GRAPHICAL OUTPUT - EXTENDED ISOLINES, MAP, HILLS.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RO  FL(NGR,NGR)  FIELD OF DRAWN FUNCTION VALUES.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RO  FO  OLD VALUE OF THE OBJECTIVE FUNCTION.
*  RI  ETA9  MAXIMUM MACHINE CONSTANT.
*  RI  GFMT  GRAPHIC FORMAT: 0=INTERNAL GRAPHICS,
*                            1=EXTERNAL GRAPHICS (*.EPS FILES),
*                            2=EXTERNAL GRAPHICS (*.PNG FILES).
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
      SUBROUTINE UOSRF2(NF,X,FL,F,FO,ETA9,GFMT)
      $INCLUDE ('UMCOMM')
      $INCLUDE ('UMCOMG')
      INTEGER NF,GFMT
      REAL*4 FL(NGR,NGR)
      $FLOAT X(NF),F,FO,ETA9
      $FLOAT DVYB(3),HVYB(3),XVYB(3),SVYB(3),PVYB(3)
      $FLOAT CON1,CON2
      LOGICAL VYPISF
      PARAMETER(CON1=1.0$P-60,CON2=1.0$P 60)
      INTEGER IPOM,JPOM,INDEX(3),INMIN(3),IVAR,JVAR,
     & INFO,CISLOGRAFU,LEVEL,SCALE
      SAVE IPOM,JPOM,INDEX,INMIN,IVAR,JVAR,DVYB,HVYB,XVYB,SVYB,PVYB
      SAVE INFO,CISLOGRAFU,LEVEL,SCALE
      CHARACTER ANSWER
C
      IF (TSS(NS).NE.'UYXX') CALL UYPRO1('UYXX',0)
      GO TO (1,6) ISP(NS)
    1 CONTINUE
      CISLOGRAFU=0
      WRITE(*,'(A)') 'GRAPH OF MAPS:'
      WRITE(*,'(A)')
     &  '  S = ISOLINES/MAP/SURFACE, R = RETURN  [ENTER = R]'
      READ(*,'(A)') ANSWER
      IF (ANSWER.NE.'S'.AND.ANSWER.NE.'s') GOTO 20
   11 WRITE(*,'(A)') 'INDEX OF THE 1-ST VARIABLE:'
      READ(*,*,ERR=11) IGR
      IF (IGR.LE.0.OR.IGR.GT.NF) GO TO 11
      CALL UOJZD3(NF,X,IGR,DVYB(1),HVYB(1))
   12 WRITE(*,'(A)') 'INDEX OF THE 2-ND VARIABLE:'
      READ(*,*,ERR=12) JGR
      IF (JGR.LE.0.OR.JGR.GT.NF.OR.JGR.EQ.IGR) GO TO 12
      CALL UOJZD3(NF,X,JGR,DVYB(2),HVYB(2))
   13 WRITE(*,'(A)') 'INDEX OF THE 3-RD VARIABLE:'
      READ(*,*,ERR=13) KGR
      IF (KGR.LE.0.OR.KGR.GT.NF.OR.KGR.EQ.IGR.OR.KGR.EQ.JGR) GO TO 13
      CALL UOJZD3(NF,X,KGR,DVYB(3),HVYB(3))
      INDEX(1)=IGR
      INDEX(2)=JGR
      INDEX(3)=KGR
      LEVEL=16
      CALL UOMSCR('S',0,0,0,0,0,GFMT,0,0,INFO,LEVEL,SCALE)
      IF (INFO.EQ.-1) GOTO 11
      IF (INFO.EQ.0) GOTO 1
C
      FO=F
      XVYB(1)=X(INDEX(1))
      XVYB(2)=X(INDEX(2))
      XVYB(3)=X(INDEX(3))
      SVYB(1)=(HVYB(1)-DVYB(1))/(NGR-1)
      SVYB(2)=(HVYB(2)-DVYB(2))/(NGR-1)
      SVYB(3)=(HVYB(3)-DVYB(3))/(NGR-1)
      PVYB(1)=ETA9
      PVYB(2)=ETA9
      PVYB(3)=ETA9
      IPOM=0
    2 IPOM=IPOM+1
      JPOM=IPOM
    3 JPOM=JPOM+1
      VALMIN= ETA9
      VALMAX=-ETA9
      IVAR=0
    4 IVAR=IVAR+1
      X(INDEX(IPOM))=DVYB(IPOM)+(IVAR-1)*SVYB(IPOM)
      JVAR=0
    5 JVAR=JVAR+1
      X(INDEX(JPOM))=DVYB(JPOM)+(JVAR-1)*SVYB(JPOM)
      CALL UYSET2
      CALL UYSET0(1,2)
      RETURN
    6 CONTINUE
      IF (ABS(F).GE.CON2) THEN
      FL(IVAR,JVAR)=SIGN(CON2,F)
      ELSE IF (ABS(F).LE.CON1) THEN
      FL(IVAR,JVAR)=SIGN(CON1,F)
      ELSE
      FL(IVAR,JVAR)=F
      ENDIF
      IF (ABS(XVYB(IPOM)-X(INDEX(IPOM))).LT.PVYB(IPOM)) THEN
      PVYB(IPOM)=ABS(XVYB(IPOM)-X(INDEX(IPOM)))
      INMIN(IPOM)=IVAR
      ENDIF
      IF (ABS(XVYB(JPOM)-X(INDEX(JPOM))).LT.PVYB(JPOM)) THEN
      PVYB(JPOM)=ABS(XVYB(JPOM)-X(INDEX(JPOM)))
      INMIN(JPOM)=JVAR
      ENDIF
      IF (FL(IVAR,JVAR).LT.VALMIN) VALMIN=FL(IVAR,JVAR)
      IF (FL(IVAR,JVAR).GT.VALMAX) VALMAX=FL(IVAR,JVAR)
      IF (JVAR.LT.NGR) GO TO 5
      IF (IVAR.LT.NGR) GO TO 4
      IF (XVYB(IPOM).LT.DVYB(IPOM).OR.XVYB(IPOM).GT.HVYB(IPOM))
     & INMIN(IPOM)=0
      IF (XVYB(JPOM).LT.DVYB(JPOM).OR.XVYB(JPOM).GT.HVYB(JPOM))
     & INMIN(JPOM)=0
      X(INDEX(IPOM))=XVYB(IPOM)
      X(INDEX(JPOM))=XVYB(JPOM)
      VYPISF=.FALSE.
      CISLOGRAFU=CISLOGRAFU+1
      IF (INFO.EQ.1.OR.INFO.EQ.12.OR.INFO.EQ.13.OR.INFO.EQ.123)
     &  CALL UOSISO(NGR,INDEX(IPOM),INDEX(JPOM),XVYB(IPOM),XVYB(JPOM),
     &    DVYB(IPOM),HVYB(IPOM),DVYB(JPOM),HVYB(JPOM),
     &    INMIN(IPOM),INMIN(JPOM),FL,VYPISF,LEVEL,SCALE,CISLOGRAFU,GFMT)
      IF (INFO.EQ.2.OR.INFO.EQ.12.OR.INFO.EQ.23.OR.INFO.EQ.123)
     &  CALL UOSMAP(NGR,INDEX(IPOM),INDEX(JPOM),XVYB(IPOM),XVYB(JPOM),
     &    DVYB(IPOM),HVYB(IPOM),DVYB(JPOM),HVYB(JPOM),
     &    INMIN(IPOM),INMIN(JPOM),FL,VYPISF,LEVEL,SCALE,CISLOGRAFU,GFMT)
      IF (INFO.EQ.3.OR.INFO.EQ.13.OR.INFO.EQ.23.OR.INFO.EQ.123)
     &  CALL UOSSUR(NGR,INDEX(IPOM),INDEX(JPOM),
     &    DVYB(IPOM),HVYB(IPOM),DVYB(JPOM),HVYB(JPOM),
     &    FL,VYPISF,SCALE,CISLOGRAFU,GFMT)
      IF (JPOM.LT.3) GO TO 3
      IF (IPOM.LT.2) GO TO 2
      F=FO
      IMIN=INMIN(1)
      JMIN=INMIN(2)
      KMIN=INMIN(3)
   20 CONTINUE
      CALL UYEPI1(0)
      RETURN
      END

