$INTERFACE UOT1A3                                             98/12/01

  CALL UOT1A3(NF,NA,MA,KA,$GA,$IAG,$JAG,FA)
  $ADD(REAL,'\$GA($NF)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOT1A3                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF TEST OF EXTERNAL SUBROUTINES.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF FUNCTIONS.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD AG.
*  II  KA  INDEX OF THE FUNCTION.
*  RI  GA(NF)  GRADIENT OF THE APPROXIMATED FUNCTION.
*  RI  FA  VALUE OF THE APPROXIMATED FUNCTION.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  KD DEGREE OF REQUIRED DERIVATIVES.
*
* OUTPUT VARIABLES:
* FA,GA(NF)
*
      SUBROUTINE UOT1A3(NF,NA,MA,KA,GA,IAG,JAG,FA)
      $INCLUDE('UMCOMM')
      INTEGER NF,NA,MA,KA,IAG(NA+1),JAG(MA)
      $FLOAT GA(NF),FA
      INTEGER I
      GOTO(1,4) KD+1
    1 WRITE(IWR,2) 'FA A =',FA
    2 FORMAT(/1X,A6,$P 18.10)
      WRITE(IWR,3) 'GA N =',(GA(JAG(I)),I=IAG(KA),IAG(KA+1)-1)
    3 FORMAT(' ',A6,4$P 18.10:/(7X,4$P 18.10))
      RETURN
    4 WRITE(IWR,3) 'GA A =',(GA(JAG(I)),I=IAG(KA),IAG(KA+1)-1)
      RETURN
      END
