$INTERFACE UOT1E1                                             98/12/01

  $IF(GDEF=0)
    $GE=YA
  $ELSE
    $ADD(REAL,'\$GE($NF)')
  $ENDIF
  $IF(DDEF=0)
    $DE=YA
  $ELSE
    $ADD(REAL,'\$DE($NE)')
  $ENDIF
  CALL UOT1E1(NF,NE,$GE,$DE,FE,$GDEF,$DDEF)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOT1E1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF TEST OF EXTERNAL SUBROUTINES.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NE  DECLARED NUMBER OF DIFERENTIAL EQUATIONS.
*  RI  GE(NF)  GRADIENT OF THE STATE FUNCTION.
*  RI  DE(NE)  ADDITIONAL DERIVATIVES OF THE STATE FUNCTION.
*  RI  FE(NF)  VALUE OF THE STATE FUNCTION.
*  II  IGDEF  PRINT SPECIFICATION.
*  II  IDDEF  PRINT SPECIFICATION.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  KD DEGREE OF REQUIRED DERIVATIVES.
*
* OUTPUT VARIABLES:
* FE,GE(NF)
*
      SUBROUTINE UOT1E1(NF,NE,GE,DE,FE,IGDEF,IDDEF)
      $INCLUDE('UMCOMM')
      INTEGER NF,NE,IGDEF,IDDEF
      $FLOAT GE(NF),DE(NE),FE
      INTEGER I
      GOTO(1,4) KD+1
    1 WRITE(IWR,2) 'FE A =',FE
    2 FORMAT(/1X,A6,$P 18.10)
      IF (IGDEF.GT.0) WRITE(IWR,3) 'GE N =',(GE(I),I=1,NF)
      IF (IDDEF.GT.0) WRITE(IWR,3) 'DE N =',(DE(I),I=1,NE)
    3 FORMAT(' ',A6,4$P 18.10:/(7X,4$P 18.10))
      RETURN
    4 IF (IGDEF.GT.0) WRITE(IWR,3) 'GE A =',(GE(I),I=1,NF)
      IF (IDDEF.GT.0) WRITE(IWR,3) 'DE A =',(DE(I),I=1,NE)
      RETURN
      END
