* SUBROUTINE UOTES4                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION FOR SIMULTANEOUS TESTS.
*
* COMMON DATA :
*  II  NIT  NUMBER OF ITERATIONS.
*  II  NFV  NUMBER OF FUNCTION VALUE EVALUATIONS.
*  II  NFG  NUMBER OF FUNCTION GRADIENT EVALUATIONS.
*  II  NDC  NUMBER OF MATRIX DECOMPOSITIONS
*
      SUBROUTINE UOTES4
      $INCLUDE('UMCOMM')
      INTEGER NFD,NAD,NCD,NED,NITT,NFVT,NFGT,NFHT,NDCT,NCGT,
     & NLST,NSCT,NUPT,NMXT,NRST,NADT,NRMT,NSUC,NTOT,NTIM,ITIM
      COMMON /UMTEST/ NFD,NAD,NCD,NED,NITT,NFVT,NFGT,NFHT,NDCT,NCGT,
     & NLST,NSCT,NUPT,NMXT,NRST,NADT,NRMT,NSUC,NTOT,NTIM,ITIM
      WRITE(ITR,55) NITT,NFVT,NFGT,NDCT,NSUC,NCGT,NLST,NSCT,NUPT,NRST,
     & NMXT,NADT,NRMT
      IF (KOUT.EQ.0.AND.LOUT.GT.0) THEN
      WRITE(IWR,55) NITT,NFVT,NFGT,NDCT,NSUC,NCGT,NLST,NSCT,NUPT,NRST,
     & NMXT,NADT,NRMT
      ENDIF
   55 FORMAT(' TOTAL',3X,'NIT=',I8,3X,'NFV=',I8,3X,'NFG=',I8,3X,'NDC=',
     & I8,' * ',I5/9X,'NCG=',I8,3X,'NLS=',I8,3X,'NSC=',I8,3X,'NUP=',
     & I8/9X,'NRS=',I8,3X,'NMX=',I8,3X,'NAD=',I8,3X,'NRM=',I8)
      CALL UYTIM2(ITIM)
      NITT=0
      NFVT=0
      NFGT=0
      NFHT=0
      NDCT=0
      NCGT=0
      NLST=0
      NSCT=0
      NUPT=0
      NRST=0
      NMXT=0
      NADT=0
      NRMT=0
      NSUC=0
      NTOT=0
      RETURN
      END
