$INTERFACE UP0SE2                                             99/12/01

  CALL UP0SE2(NC,$CF,RPF2,RPF3,FC,F)
  $ADD(REAL,'\$CF($NC+1)')
$REM  $ADD(REAL,'\RPF2\RPF3\FC\F')
$REM  $ADD(INTEGER,'\NC')
  $ADD(INIT)
    NPFX='UP0SE2'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UP0SE2             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE  OF THE L2 EXACT PENALTY FUNCTION.
*
* PARAMETERS :
*  II  NC  NUMBER OF CONSTRAINTS.
*  RI  CF(NC+1)  VECTOR CONTAINING VALUES OF THE CONSTRAINTS.
*  RI  RPF2  PENALTY COEFFICIENT.
*  RI  RPF3  PENALTY COEFFICIENT.
*  RO  FC  VALUE OF THE PENALTY TERM.
*  RO  F  VALUE OF THE PENALTY FUNCTION.
*
      SUBROUTINE UP0SE2(NC,CF,RPF2,RPF3,FC,F)
      INTEGER NC
      $FLOAT CF(NC+1),RPF2,RPF3,FC,F,UXVNOR
      INTEGER KC
      FC=0.0$P 0
      DO 1 KC=1,NC
      FC=FC+0.5$P 0*RPF3*CF(KC)**2
    1 CONTINUE
      F=CF(NC+1)+FC+RPF2*UXVNOR(NC,CF)
      RETURN
      END
