* SUBROUTINE UQERAS                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE 'ERASE'
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF LINE
*               IN THE BUFFER
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  IU  LENST - ACTUAL LENGTH OF THE SYMBOL TABLE
*  IU  LP - LAST POINTER TO THE SYMBOL TABLE
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQSADR - SYNTAX ANALYSIS OF DIRECTIVE LINE
*  S   UQDELV - DELETE A MACRO FROM THE SYMBOL TABLE
*
      SUBROUTINE UQERAS(BUFFER,MLENB,IPOSD,IPOS2,SYMTAB,MLENST,
     *                  IPOINT,MNP,LENST,LP,IER)
      INTEGER MLENB,IPOSD,IPOS2,MLENST,MNP,IPOINT(MNP,6),LENST,LP,IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
      INTEGER MNPAR
      PARAMETER(MNPAR=1)
      INTEGER NPAR,IPOSP(MNPAR,2),ITYPE(MNPAR)
      CALL UQSADR(BUFFER,MLENB,IPOSD,IPOS2,IPOSP,MNPAR,NPAR,ITYPE,IER)
      IF(IER.NE.0) RETURN
      IF(NPAR.NE.1) GOTO 1
      IF(ITYPE(1).NE.5) GOTO 2
      CALL UQDELV(BUFFER,MLENB,IPOSP(1,1),IPOSP(1,2),SYMTAB,
     *            MLENST,LENST,IPOINT,MNP,LP,IER)
      RETURN
C
C ERROR: SYNTAX ERROR
C
    1 IER=20
      RETURN
C
C ERROR: MACRO NAME EXPECTED
C
    2 IER=23
      RETURN
      END


