* SUBROUTINE UQGCST                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  GARBAGE COLLECTOR OF THE SYMBOL TABLE
*
* PARAMETERS :
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  IU  LENST - ACTUAL LENGTH OF THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  IU  LP - LAST POINTER TO THE SYMBOL TABLE
*

      SUBROUTINE UQGCST(SYMTAB,MLENST,LENST,IPOINT,MNP,LP)
      INTEGER MLENST,LENST,MNP,LP,IPOINT(MNP,6)
      CHARACTER*1 SYMTAB(MLENST)
      INTEGER LINK(1000),I,J,K,IP,LEN
C
C     FORWARD LINK
C
      I=1
      IP=LP
      LINK(I)=LP
    1 IF(IPOINT(IP,1).GT.0) THEN
        I=I+1
        LINK(I)=IPOINT(IP,1)
        IP=IPOINT(IP,1)
        GOTO 1
      ENDIF
C
C     MEMORY COMPRESSION
C
      LENST=0
      DO 3 K=I,1,-1
        IP=LINK(K)
        LEN=IPOINT(IP,4)-IPOINT(IP,2)+1
        IF(IPOINT(IP,2).GT.LENST+1) THEN
          DO 2 J=1,LEN
            SYMTAB(LENST+J)=SYMTAB(IPOINT(IP,2)+J-1)
    2     CONTINUE
          IPOINT(IP,2)=LENST+1
          IPOINT(IP,4)=LENST+LEN
        ENDIF
        LENST=IPOINT(IP,4)
    3 CONTINUE
      RETURN
      END
