* LOGICAL FUNCTION UQREAM          ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  IS IT A REAL CONSTANT ?
*
* PARAMETERS :
*  TI  STRARR(MLEN) - A STRING ARRAY
*  II  MLEN - MAX. LENGTH OF STRARR
*  II  IPOS1 - POSITION OF THE FIRST CHARACTER OF A NUMBER IN STRARR
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF A NUMBER IN STRARR
*
* SUBPROGRAMS USED :
*  LF  UQINTM - IS IT AN INTEGER CONSTANT ?
*  TF  UQUCHR - CONVERTS A CHARACTER TO UPPERCASE
*
* REMARK:
*  PARAMETER 'LENEXP' IS MAX. LENGTH OF EXPONENT
*
      LOGICAL FUNCTION UQREAM(STRARR,MLEN,IPOS1,IPOS2)
      INTEGER MLEN,IPOS1,IPOS2
      CHARACTER*1 STRARR(MLEN)
      INTEGER I,J,K,LENEXP,MPOINT,MDE
      LOGICAL L,LSIGN,LNUM,LPOINT,LDE,UQINTM
      CHARACTER*1 UQUCHR
      PARAMETER(LENEXP=3)
      UQREAM=.FALSE.
      IF(IPOS1.GT.IPOS2) RETURN
      LPOINT=.FALSE.
      LDE=.FALSE.
      DO 1 I=IPOS1,IPOS2
        IF(STRARR(I).EQ.'.') THEN
          IF(LPOINT) RETURN
          MPOINT=I
          LPOINT=.TRUE.
        ELSEIF(UQUCHR(STRARR(I)).EQ.'D'.OR.UQUCHR(STRARR(I)).EQ.'E')
     *    THEN
          IF(LDE) RETURN
          MDE=I
          LDE=.TRUE.
        ENDIF
    1 CONTINUE
      IF(LPOINT) THEN
        DO 2 I=IPOS1,MPOINT-1
          IF(STRARR(I).NE.' ') GOTO 3
    2   CONTINUE
        GOTO 4
    3   L=UQINTM(STRARR,MLEN,IPOS1,MPOINT-1,LSIGN,LNUM)
        IF(.NOT.(L.OR.LSIGN.AND..NOT.LNUM)) RETURN
    4   I=MPOINT+1
      ELSE
        I=IPOS1
      ENDIF
      IF(LDE) THEN
        IF(.NOT.UQINTM(STRARR,MLEN,MDE+1,IPOS2,LSIGN,LNUM)) RETURN
        K=0
        DO 5 J=MDE+1,IPOS2
          IF(STRARR(J).NE.' '.AND.STRARR(J).NE.'+'.AND.
     *       STRARR(J).NE.'-') K=K+1
    5   CONTINUE
        IF(K.GT.LENEXP) RETURN
        J=MDE-1
      ELSE
        J=IPOS2
      ENDIF
      L=UQINTM(STRARR,MLEN,I,J,LSIGN,LNUM)
      IF(.NOT.LPOINT.AND..NOT.L) RETURN
      IF(LPOINT.AND.L.AND.LSIGN) RETURN
      IF(LPOINT.AND..NOT.L) THEN
        DO 6 I=I,J
          IF(STRARR(I).NE.' ') RETURN
    6   CONTINUE
      ENDIF
      UQREAM=.TRUE.
      RETURN
      END



