* SUBROUTINE UQRWND                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE 'REWIND'
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF LINE
*               IN THE BUFFER
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQSADR - SYNTAX ANALYSIS OF DIRECTIVE LINE
*  S   UQGVAL - GIVE VALUE OF A MACRO
*  IF  UQINTI - CONVERT A STRING TO AN INTEGER NUMBER
*
      SUBROUTINE UQRWND(BUFFER,MLENB,IPOSD,IPOS2,SYMTAB,MLENST,
     *                  IPOINT,MNP,IER)
      INTEGER MLENB,IPOSD,IPOS2,MLENST,MNP,IPOINT(MNP,6),IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
      INTEGER MNPAR
      PARAMETER(MNPAR=1)
      INTEGER NPAR,IPOSP(MNPAR,2),ITYPE(MNPAR)
      INTEGER*4 UQINTI,I
      CALL UQSADR(BUFFER,MLENB,IPOSD,IPOS2,IPOSP,MNPAR,NPAR,ITYPE,IER)
      IF(IER.NE.0) RETURN
      IF(NPAR.NE.1) GOTO 1
      IF(ITYPE(1).EQ.5) THEN
        CALL UQGVAL(BUFFER,MLENB,IPOSP(1,1),IPOSP(1,2),SYMTAB,
     *              MLENST,IPOSP(1,1),IPOSP(1,2),IPOINT,MNP,IER)
        IF(IER.NE.0) RETURN
        I=UQINTI(SYMTAB,MLENST,IPOSP(1,1),IPOSP(1,2),IER)
      ELSEIF(ITYPE(1).EQ.7) THEN
        I=UQINTI(BUFFER,MLENB,IPOSP(1,1),IPOSP(1,2),IER)
      ELSE
        GOTO 1
      ENDIF
      IF(IER.NE.0) RETURN
      IF(I.LE.0.OR.I.GT.999) GOTO 1
      REWIND(UNIT=I,ERR=2)
      RETURN
C
C ERROR: SYNTAX ERROR
C
    1 IER=20
      RETURN
C
C ERROR: REWIND - I/O ERROR
C
    2 IER=39
      RETURN
      END


