* SUBROUTINE UQSASB                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*   SYNTAX ANALYSIS OF SUBSTITUTIONS
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF BUFFER
*  II  IPOS1- POSITION IN BUFFER
*  IO  IPOS2 - POSITION OF THE FIRST CHARACTER OF A NAME IN BUFFER
*  IO  IPOS3 - POSITION OF THE LAST CHARACTER OF A NAME IN BUFFER
*  IO  IPOS4 - POSITION OF THE LAST CHARACTER OF SUBSTITUTION
*              IN THE BUFFER
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQNEXT - GIVE NEXT WORD FROM BUFFER
*  S   UQUPCS - CONVERT SUBSTRING TO UPPERCASE
*
      SUBROUTINE UQSASB(BUFFER,MLENB,IPOS1,IPOS2,IPOS3,IPOS4,IER)
      INTEGER MLENB,IPOS1,IPOS2,IPOS3,IPOS4,IER
      CHARACTER*1 BUFFER(MLENB)
      INTEGER I,J,ITYP
      CALL UQNEXT(BUFFER,MLENB,IPOS1,IPOS2,IPOS3,I,ITYP,IER)
      IF(IER.NE.0) RETURN
      IF(ITYP.NE.5) GOTO 1
      CALL UQUPCS(BUFFER,MLENB,IPOS2,IPOS3)
      CALL UQNEXT(BUFFER,MLENB,IPOS3+1,I,IPOS4,J,ITYP,IER)
      IF(IER.NE.0) RETURN
      IF(ITYP.NE.2) GOTO 2
      RETURN
C
C ERROR: MACRO NAME EXPECTED
C
    1 IER=23
      RETURN
C
C ERROR: ')' EXPECTED
C
    2 IER=22
      RETURN
      END
