* LOGICAL FUNCTION UQVDEF          ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  IS VARIABLE DEFINED IN THE SYMBOL TABLE ?
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOS1 - POSITION OF THE FIRST CHARACTER OF A MACRO NAME
*              IN THE BUFFER
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF A MACRO NAME
*              IN THE BUFFER
*  TI  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  II  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  II  LP - LAST POINTER TO THE SYMBOL TABLE
*  IO  IP -  POINTER TO VARIABLE
*  IO  IPPRED - PREDECESSOR OF THE POINTER IP
*
      LOGICAL FUNCTION UQVDEF(BUFFER,MLENB,IPOS1,IPOS2,SYMTAB,
     *                        MLENST,IPOINT,MNP,LP,IP,IPPRED)
      INTEGER MLENB,IPOS1,IPOS2,MLENST,MNP,LP,IPOINT(MNP,6),IP,
     *        IPPRED
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
      INTEGER I,LEN
      LEN=IPOS2-IPOS1+1
      IP=LP
      IPPRED=LP
    1 IF(LEN.EQ.IPOINT(IP,3)) THEN
        DO 2 I=0,LEN-1
          IF(BUFFER(IPOS1+I).NE.SYMTAB(IPOINT(IP,2)+I)) GOTO 3
    2   CONTINUE
        UQVDEF=.TRUE.
        RETURN
      ENDIF
    3 IPPRED=IP
      IP=IPOINT(IP,1)
      IF(IP.GT.0) GOTO 1
      UQVDEF=.FALSE.
      RETURN
      END
