* SUBROUTINE UXDSDC                ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* THE DIAGONAL OF A DENSE SYMMETRIC MATRIX A IS COPIED INTO THE VECTOR X.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*  RO  X(N)  OUTPUT VECTOR CONTAINING THE DIAGONAL OF THE MATRIX A.
*
      SUBROUTINE UXDSDC(N,A,X)
      INTEGER N
      $FLOAT  A(N*(N+1)/2), X(N)
      INTEGER I,J
      J = 0
      DO  1  I = 1, N
      J = J + I
      X(I) = A(J)
    1 CONTINUE
      RETURN
      END
