* SUBROUTINE UXDSMO             ALL SYSTEMS                 91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* A SCALAR IS SET TO ALL ELEMENTS OF A DENSE SYMMETRIC MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RI  ALF  INITIAL VALUE.
*  RO  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*
      SUBROUTINE UXDSMO(N,ALF,A)
      INTEGER N,I
      $FLOAT ALF,A(N*(N+1)/2)
      DO 1 I=1,N*(N+1)/2
      A(I)=ALF
    1 CONTINUE
      RETURN
      END
