* SUBROUTINE UXDSMV                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* K-TH ROW OF A DENSE SYMMETRIC MATRIX A IS COPIED TO THE VECTOR X.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*  RO  X(N)  OUTPUT VECTOR.
*  II  K  INDEX OF COPIED ROW.
*
      SUBROUTINE UXDSMV(N,A,X,K)
      INTEGER N,K
      $FLOAT  A(N*(N+1)/2),X(N)
      INTEGER  I,L
      L=K*(K-1)/2
      DO 1 I=1,N
      IF (I.LE.K) THEN
      L=L+1
      ELSE
      L=L+I-1
      ENDIF
      X(I)=A(L)
    1 CONTINUE
      RETURN
      END
