* SUBROUTINE UXSGF6                 ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 DA : ORIGINAL VERSION
*
* PURPOSE :
* AUXILIARY SUBROUTINE FOR UXSGDF FROM UMFPACK.
*
      SUBROUTINE UXSGF6(AVALUE,AINDC,AINDR,AN,ANZ,ANZ2,
     & TLEN,TCOLP,TCOLI,TCOLX,POS,TRANS,NINVLD)
      INTEGER AN,ANZ,AINDC(ANZ),AINDR(ANZ),TCOLP(AN+1),TCOLI(ANZ),RC,CR,
     & TLEN(AN),ANZ2,NINVLD,P,POS(AN),I,COL,ROW,R,C
      LOGICAL TRANS
      $FLOAT TCOLX(ANZ),AVALUE(ANZ)
      PARAMETER (R = 1, C = 2)
      ANZ2 = ANZ
      NINVLD = 0
      IF (TRANS) THEN
C
C     FACTORING TRANS(A)
C
      RC = C
      CR = R
      ELSE
C
C     FACTORING A
C
      RC = R
      CR = C
      ENDIF
C
C     COUNT THE NUMBER OF ENTRIES IN EACH COLUMN
C
      DO 10 I = 1, AN
      TLEN (I) = 0
10    CONTINUE
      DO 20 I = 1, ANZ
      ROW = AINDR (I)
      COL = AINDC (I)
      IF (ROW.LT.1.OR.ROW.GT.AN.OR.COL.LT.1.OR.COL.GT.AN) THEN
      NINVLD = NINVLD + 1
      ENDIF
20    CONTINUE
      IF (NINVLD .NE. 0) RETURN
      DO 25 I = 1, ANZ
      TLEN (AINDC (I)) = TLEN (AINDC (I)) + 1
25    CONTINUE
C
C     STORE THE VALUES OF THE MATRIX INTO COLUMN FORM
C
      TCOLP (1) = 1
      COL = 1
      DO 30 COL = 2, AN+1
      TCOLP (COL) = TCOLP (COL-1) + TLEN (COL-1)
30    CONTINUE
      DO 40 COL = 1, AN
      POS (COL) = TCOLP (COL)
40    CONTINUE
      DO 55 I = 1, ANZ
      COL = AINDC (I)
      P = POS (COL)
      TCOLI (P) = AINDR (I)
      TCOLX (P) = AVALUE (I)
      POS (COL) = P + 1
55    CONTINUE
      RETURN
      END
