* SUBROUTINE UXSGS3                 ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 DA : ORIGINAL VERSION
*
* PURPOSE :
* AUXILIARY SUBROUTINE FOR UXSGDS FROM UMFPACK.
*
      SUBROUTINE UXSGS3(TCOLP,TCOLI,PERMR,PERMC,ABLKP,ALEFTR,
     & ALEFTC,INBLK,IPERMR,IPERMC,AN,ABLKS,
     & ANZDIA,ANZOFF,ANZ2,TLEN)
      INTEGER AN,ABLKS,ANZ2,TCOLI(ANZ2),PERMR(AN),PERMC(AN),
     & IPERMC(AN),ABLKP(ABLKS+1),INBLK(AN),ALEFTR(AN),
     & ALEFTC(AN),BLOCK,I,COL,ROW,R,C,IPERMR(AN),
     & ANZDIA,ANZOFF,TCOLP(AN+1),TLEN(AN),P
      PARAMETER (R = 1, C = 2)
C
C     FIND THE INVERSE PERMUTATION VECTORS
C
      DO 5 I = 1, AN
      PERMR (IPERMR (I)) = I
      PERMC (IPERMC (I)) = I
      ALEFTR (I) = 0
      ALEFTC (I) = 0
      TLEN (I) = 0
5     CONTINUE
C
C     CAN NOW DEALLOCATE IPERM
C
C
C     COUNT THE NUMBER OF OFF-DIAGONAL NONZEROS IN EACH ROW AND COLUMN,
C     AND THE NUMBER OF NONZEROS IN THE DIAGONAL BLOCKS
C
      DO 10 BLOCK = 1, ABLKS
      DO 20 COL = ABLKP (BLOCK), ABLKP (BLOCK+1) - 1
      INBLK (COL) = BLOCK
20    CONTINUE
10    CONTINUE
      ANZDIA = 0
      ANZOFF = 0
      DO 45 I = 1, AN
      COL = PERMC (I)
      DO 50 P = TCOLP (I), TCOLP (I+1)-1
      ROW = PERMR (TCOLI (P))
      IF (INBLK (ROW) .EQ. INBLK (COL)) THEN
      ANZDIA = ANZDIA + 1
      ALEFTR (ROW) = ALEFTR (ROW) + 1
      ALEFTC (COL) = ALEFTC (COL) + 1
      ELSE
      ANZOFF = ANZOFF + 1
      TLEN (ROW) = TLEN (ROW) + 1
      ENDIF
50    CONTINUE
45    CONTINUE
      RETURN
      END
