* SUBROUTINE UXSSDA                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* A SPARSE SYMMETRIC MATRIX A IS AUGMENTED BY THE SCALED UNIT MATRIX
* SUCH THAT A:=A+ALF*I (I IS THE UNIT MATRIX OF ORDER N).
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  RI  ALF  SCALING FACTOR.
*
      SUBROUTINE UXSSDA(N,M,A,IA,ALF)
      INTEGER N,M,IA(N)
      $FLOAT  A(M), ALF
      INTEGER I
      DO 100 I=1,N
      A(IA(I))=A(IA(I))+ALF
100   CONTINUE
      RETURN
      END
