* FUNCTION UXUDDT                  ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DOT PRODUCT WITH VECTOR DIFFERENCE IN A BOUND CONSTRAINED CASE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RI  Z(N)  INPUT VECTOR.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LE.-1. IF JOB.LT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).EQ.-5.
*  RR  UXUDDT  VALUE OF DOT PRODUCT UXUDDT=TRANS(X)*Y.
*
      FUNCTION UXUDDT(N,X,Y,Z,IX,JOB)
      INTEGER N,IX(N),JOB
      $FLOAT X(N),Y(N),Z(N),UXUDDT
      DOUBLE PRECISION TEMP
      INTEGER I
      TEMP=0.0$P 0
      IF (JOB.EQ.0) THEN
      DO 1 I=1,N
      TEMP=TEMP+X(I)*(Y(I)-Z(I))
    1 CONTINUE
      ELSE IF (JOB.GT.0) THEN
      DO 2 I=1,N
      IF (IX(I).GE. 0) TEMP=TEMP+X(I)*(Y(I)-Z(I))
    2 CONTINUE
      ELSE
      DO 3 I=1,N
      IF (IX(I).NE.-5) TEMP=TEMP+X(I)*(Y(I)-Z(I))
    3 CONTINUE
      ENDIF
      UXUDDT=TEMP
      RETURN
      END
