* SUBROUTINE UXVINB            ALL SYSTEMS                   91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* UPDATE OF AN INTEGER VECTOR.
*
* PARAMETERS :
*  II  N DIMENSION OF THE INTEGER VECTOR.
*  II  M DIMENSION OF THE CHANGED INTEGER VECTOR.
*  II  IX(N)  INTEGER VECTOR.
*  IU  JA(M)  INTEGER VECTOR WHICH IS UPDATED SO THAT JA(I)=-JA(I)
*         IF IX(JA(I)).LT.0.
*
      SUBROUTINE UXVINB(N,M,IX,JA)
      INTEGER N,M,IX(N),JA(M)
      INTEGER I
      DO 1 I=1,M
      JA(I)=ABS(JA(I))
      IF (IX(JA(I)).LT.0) JA(I)=-JA(I)
    1 CONTINUE
      RETURN
      END
