* SUBROUTINE UXVMAX             ALL SYSTEMS                   91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* L-INFINITY NORM OF A VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RR  UXVMAX  L-INFINITY NORM OF THE VECTOR X.
*

      FUNCTION UXVMAX(N,X)
      INTEGER N
      $FLOAT X(N),UXVMAX
      INTEGER I
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      UXVMAX=ZERO
      DO 1 I=1,N
      UXVMAX=MAX(UXVMAX,ABS(X(I)))
    1 CONTINUE
      RETURN
      END
