* SUBROUTINE UXVMIN             ALL SYSTEMS                   96/12/01
C PORTABILITY : ALL SYSTEMS
C 96/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* L-INFINITY NORM OF A VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RR  UXVMIN  L-INFINITY NORM OF THE VECTOR X.
*

      FUNCTION UXVMIN(N,X)
      INTEGER N
      $FLOAT X(N),UXVMIN
      INTEGER I
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      UXVMIN=ABS(X(1))
      DO 1 I=2,N
      UXVMIN=MIN(UXVMIN,ABS(X(I)))
    1 CONTINUE
      RETURN
      END
