* SUBROUTINE UXVMX1             ALL SYSTEMS                   91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* L-INFINITY NORM OF A VECTOR WITH INDEX DETERMINATION.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  IO  K  INDEX OF ELEMENT WITH MAXIMUM ABSOLUTE VALUE.
*  RR  UXVMX1  L-INFINITY NORM OF THE VECTOR X.
*

      FUNCTION UXVMX1(N,X,K)
      INTEGER N,K
      $FLOAT X(N),UXVMX1
      INTEGER I
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      K=1
      UXVMX1=ABS(X(1))
      DO 1 I=2,N
      IF(ABS(X(I)).GT.UXVMX1) THEN
      K=I
      UXVMX1=ABS(X(I))
      ENDIF
    1 CONTINUE
      RETURN
      END
