* FUNCTION UXVMX2                ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  L-INFINITY NORM OF VECTOR DIFFERENCE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RR  UXVMX2  L-INFINITY NORM OF X-Y.
*
      FUNCTION UXVMX2(N,X,Y)
      INTEGER N
      $FLOAT X(N),Y(N),UXVMX2
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      INTEGER I
      $FLOAT TEMP
      TEMP=ZERO
      DO 10 I=1,N
        TEMP=MAX(TEMP,ABS(X(I)-Y(I)))
   10 CONTINUE
      UXVMX2=TEMP
      END

