* SUBROUTINE  UXVQRP              ALL SYSTEMS               30/06/92
C PORTABILITY : ALL SYSTEMS
C 30/06/92 TU : ORIGINAL VERSION
*
* PURPOSE : GET PERMUTATION OF INDIVIDUAL COLUMNS.
*
*  PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF A.
*  II  NN  NUMBER OF BLOCK COLUMNS OF A.
*  II  P(NN) WIDTHS OF COLUMN BLOCKSS.
*  II  PERM(N) INDIVIDUAL ORDERING BEFORE UXSRBD.
*  IO  INVP(N)
*  II  PSTORD(NN)
*  IA  WN01(N)
*  II  IPERM(NN) ORDERING OBTAINED IN UXSRBD.
*
      SUBROUTINE UXVQRP(N,NN,P,PERM,INVP,PSTORD,WN01,IPERM)
      INTEGER NN,N
      INTEGER I,J,K,L,J1
      INTEGER JSTRT,JSTOP
      INTEGER PSTORD(NN),PERM(N),INVP(N),P(NN),WN01(N),IPERM(NN)
C
      DO 40 I=1,N
        WN01(I)=PERM(I)
 40   CONTINUE
      JSTRT=1
      J1=0
      DO 100 I=1,NN
        J=PSTORD(I)
        J=IPERM(J)
        JSTOP=JSTRT+P(J)-1
        DO 200 K=JSTRT,JSTOP
          L=WN01(K)
          J1=J1+1
          PERM(J1)=L
          INVP(L)=J1
 200    CONTINUE
        JSTRT=JSTOP+1
 100  CONTINUE
      RETURN
      END
