* SUBROUTINE UYSET3                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DEFINITION OF THE RESTART VARIABLES.
*
* COMMON DATA :
*  II  NIT  ACTUAL NUMBER OF ITERATIONS.
*  II  KIT  NUMBER OF THE ITERATION AFTER LAST RESTART.
*  IU  ITERM  TERMINATION INDICATOR. ITERM<0 AFTER UNSUCCESSFUL RESTART.
*  IU  NRES  ACTUAL NUMBER OF RESTARTS.
*  TI  TRXX  TEXT INFORMATION ON THE CAUSE OF RESTART.
*  TO  TPXX  TEXT INFORMATION ON THE CAUSE OF RESTART.
*  TO  TDXX  TEXT INFORMATION ON THE CAUSE OF TERMINATION.
*
      SUBROUTINE UYSET3
      $INCLUDE ('UMCOMM')
      IF (KIT.LT.NIT) THEN
        IF (TRXX.NE.'NORMAL  ') NRES=NRES+1
        KIT = NIT
        TPXX=TRXX
      ELSE
        ITERM=-10
        IF (ITERS.LT.0) ITERM=ITERS-5
        TDXX=TRXX
        IF (ITERM.EQ.-10) CALL UOERR1('UYSET3',-ITERM)
      ENDIF
      RETURN
      END
