* FUNCTION UYSRT2                ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  SORTS AN ARRAY RA OF LENGTH N INTO ASCENDING ORDER USING
*  THE HEAPSORT ALGORITHM, WHILE MAKEING THE CORRESPONDING
*  REARRANGEMENT OF THE ARRAY RB.
*
* PARAMETERS :
*  II  N  LENGTH OF ARRAY RA.
*  RU  RA  ARRAY WITH VALUES.
*  RU  RB  SECOND ARRAY.
*
* METHOD :
*  HEAPSORT.
*
      SUBROUTINE UYSRT2(N,RA,RB)
      INTEGER N
      $FLOAT RA(N),RB(N)
      INTEGER L,I,J,IR
      $FLOAT RRA,RRB
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
          RRB=RB(L)
        ELSE
          RRA=RA(IR)
          RRB=RB(IR)
          RA(IR)=RA(1)
          RB(IR)=RB(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RB(1)=RRB
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            RB(I)=RB(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
        RB(I)=RRB
      GO TO 10
      END
