* SUBROUTINE UYTES4                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION FOR SIMULTANEOUS TESTS.
*
* COMMON DATA :
*  II  NIT  NUMBER OF ITERATIONS.
*  II  NFV  NUMBER OF FUNCTION VALUE EVALUATIONS.
*  II  NFG  NUMBER OF FUNCTION GRADIENT EVALUATIONS.
*  II  NDC  NUMBER OF MATRIX DECOMPOSITIONS
*
      SUBROUTINE UYTES4(NITF,NFVF,NFGF,NFHF,NDCF,NCGF,NLSF,NTMF,NDIM,
     & GMAX,IPAR)
      $INCLUDE('UMCOMM')
      INTEGER NDIM,NITF(NDIM),NFVF(NDIM),NFGF(NDIM),NFHF(NDIM),
     & NDCF(NDIM),NCGF(NDIM),NLSF(NDIM),NTMF(NDIM),IPAR
      $FLOAT GMAX
      INTEGER NFD,NAD,NCD,NED,NITT,NFVT,NFGT,NFHT,NDCT,NCGT,
     & NLST,NSCT,NUPT,NMXT,NRST,NADT,NRMT,NSUC,NTOT,NTIM,ITIM
      COMMON /UMTEST/ NFD,NAD,NCD,NED,NITT,NFVT,NFGT,NFHT,NDCT,NCGT,
     & NLST,NSCT,NUPT,NMXT,NRST,NADT,NRMT,NSUC,NTOT,NTIM,ITIM
      INTEGER MTIM
      NITT=NITT+NIT
      NFVT=NFVT+NFV
      NFGT=NFGT+NFG
      NFHT=NFHT+NFH
      NDCT=NDCT+NDECF+NDECA
      NCGT=NCGT+NCGR
      NLST=NLST+NLNS
      NSCT=NSCT+NSCL
      NUPT=NUPT+NUPD
      NRST=NRST+NRES
      NMXT=NMXT+NMAX
      NADT=NADT+NADD
      NRMT=NRMT+NREM
      IF(ITERM.EQ. 1.AND.IPAR.EQ.0.AND.GMAX.LE.1.0$P 2*TOLG) NSUC=NSUC+1
      IF(ITERM.EQ. 2.AND.IPAR.EQ.0) NSUC=NSUC+1
      IF(ITERM.EQ. 3) NSUC=NSUC+1
      IF(ITERM.EQ. 4.AND.IPAR.EQ.0) NSUC=NSUC+1
      IF(ITERM.EQ.-6.AND.IPAR.EQ.0.AND.GMAX.LE.1.0$P 2*TOLG) NSUC=NSUC+1
      NTOT=NTOT+1
      CALL UYTIM1(MTIM)
      NTIME=MTIM-NTIM
      NITF(NTOT)=NIT
      NFVF(NTOT)=NFV
      NFGF(NTOT)=NFG
      NFHF(NTOT)=NFH
      NDCF(NTOT)=NDECF+NDECA
      NCGF(NTOT)=NCGR
      NLSF(NTOT)=NLNS
      NTMF(NTOT)=NTIME
      NTIM=MTIM
      RETURN
      END
